/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _519MP7JRSCOLORQUANTIZATIONTYPE_COMPONENT_LOCALTYPE_H
#define _519MP7JRSCOLORQUANTIZATIONTYPE_COMPONENT_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_Component_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsColorQuantizationType_Component_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 327<br>
 * Enumerations: <br>
 * R (mapped to XML R) <br>
 * G (mapped to XML G) <br>
 * B (mapped to XML B) <br>
 * Y (mapped to XML Y) <br>
 * Cb (mapped to XML Cb) <br>
 * Cr (mapped to XML Cr) <br>
 * H (mapped to XML H) <br>
 * S (mapped to XML S) <br>
 * V (mapped to XML V) <br>
 * Max (mapped to XML Max) <br>
 * Min (mapped to XML Min) <br>
 * Diff (mapped to XML Diff) <br>
 * Sum (mapped to XML Sum) <br>
 */
class MP7JRS_EXPORT Mp7JrsColorQuantizationType_Component_LocalType
{
public:
	/** Mp7JrsColorQuantizationType_Component_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		R, // Mapped to R
		G, // Mapped to G
		B, // Mapped to B
		Y, // Mapped to Y
		Cb, // Mapped to Cb
		Cr, // Mapped to Cr
		H, // Mapped to H
		S, // Mapped to S
		V, // Mapped to V
		Max, // Mapped to Max
		Min, // Mapped to Min
		Diff, // Mapped to Diff
		Sum, // Mapped to Sum
	};
	

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_Component_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsColorQuantizationType_Component_LocalType::Enumeration item);
	static Mp7JrsColorQuantizationType_Component_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsColorQuantizationType_Component_LocalType_ExtPropDef.h



};
#endif // _519MP7JRSCOLORQUANTIZATIONTYPE_COMPONENT_LOCALTYPE_H
