/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1007MP7JRSHARMONICSPECTRALDEVIATIONTYPE_H
#define _1007MP7JRSHARMONICSPECTRALDEVIATIONTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsHarmonicSpectralDeviationTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralDeviationType_ExtInclude.h


#include "Mp7JrsAudioDType.h"
#include "Mp7JrsAudioLLDScalarType.h"
#include "Mp7JrsDType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioLLDScalarType;
class IMp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType;
class IMp7JrsHarmonicSpectralDeviationType;
class IMp7JrsintegerVector;
class IMp7JrszeroToOneType;
typedef Mp7JrsPtr< IMp7JrsAudioLLDScalarType > Mp7JrsAudioLLDScalarPtr;
typedef Mp7JrsPtr< IMp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionType > Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralDeviationType> Mp7JrsHarmonicSpectralDeviationPtr;
typedef Mp7JrsPtr< IMp7JrsintegerVector > Mp7JrsintegerVectorPtr;
typedef Mp7JrsPtr< IMp7JrszeroToOneType > Mp7JrszeroToOnePtr;

/** 
 * Generated interface IMp7JrsHarmonicSpectralDeviationType for class Mp7JrsHarmonicSpectralDeviationType<br>
 * Located at: mpeg7-2004.xsd, line 1695<br>
 * Classified: Class<br>
 * Derived from: AudioLLDScalarType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsHarmonicSpectralDeviationType 
 :
        public IMp7JrsAudioLLDScalarType
{
public:
    // TODO: make these protected?
    IMp7JrsHarmonicSpectralDeviationType();
    virtual ~IMp7JrsHarmonicSpectralDeviationType();
    /**
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const = 0;

    /**
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const = 0;

    /**
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsAudioLLDScalarType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence() = 0;

        /** @name Choice

         */
        //@{
    /**
     * Get Scalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return float
     */
    virtual float GetScalar() const = 0;

    /**
     * Set Scalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item float
     */
    // Mandatory			
    virtual void SetScalar(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get SeriesOfScalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr
     */
    virtual Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr GetSeriesOfScalar() const = 0;

    /**
     * Set SeriesOfScalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetSeriesOfScalar(const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
    /**
     * Get channels attribute.
<br>
     * (Inherited from Mp7JrsAudioDType)
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr Getchannels() const = 0;

    /**
     * Get channels attribute validity information.
     * (Inherited from Mp7JrsAudioDType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existchannels() const = 0;

    /**
     * Set channels attribute.
<br>
     * (Inherited from Mp7JrsAudioDType)
     * @param item const Mp7JrsintegerVectorPtr &
     */
    virtual void Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


    /**
     * Invalidate channels attribute.
     * (Inherited from Mp7JrsAudioDType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatechannels() = 0;

    /**
     * Gets or creates Mp7JrsNodePtr child elements of HarmonicSpectralDeviationType.
     * Currently this type contains one child element of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:SeriesOfScalar</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

    
// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralDeviationType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralDeviationType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsHarmonicSpectralDeviationType<br>
 * Located at: mpeg7-2004.xsd, line 1695<br>
 * Classified: Class<br>
 * Derived from: AudioLLDScalarType (Class)<br>
 * Defined in mpeg7-2004.xsd, line 1695.<br>
 */
class MP7JRS_EXPORT Mp7JrsHarmonicSpectralDeviationType :
        public IMp7JrsHarmonicSpectralDeviationType
{
    friend class Mp7JrsHarmonicSpectralDeviationTypeFactory; // constructs objects

public:
    /*
     * Retrieves the base class of Mp7JrsHarmonicSpectralDeviationType
     
     * @return Mp7JrsPtr< Mp7JrsAudioLLDScalarType >
     */
    virtual Mp7JrsPtr< Mp7JrsAudioLLDScalarType > GetBase() const;
    /*
     * Get confidence attribute.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return Mp7JrszeroToOnePtr
     */
    virtual Mp7JrszeroToOnePtr Getconfidence() const;

    /*
     * Get confidence attribute validity information.
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existconfidence() const;

    /*
     * Set confidence attribute.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item const Mp7JrszeroToOnePtr &
     */
    virtual void Setconfidence(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate confidence attribute.
     * (Inherited from Mp7JrsAudioLLDScalarType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidateconfidence();

        /* @name Choice

         */
        //@{
    /*
     * Get Scalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return float
     */
    virtual float GetScalar() const;

    /*
     * Set Scalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item float
     */
    // Mandatory			
    virtual void SetScalar(float item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get SeriesOfScalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @return Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr
     */
    virtual Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr GetSeriesOfScalar() const;

    /*
     * Set SeriesOfScalar element.
<br>
     * (Inherited from Mp7JrsAudioLLDScalarType)
     * @param item const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr &
     */
    // Mandatory collection
    virtual void SetSeriesOfScalar(const Mp7JrsAudioLLDScalarType_SeriesOfScalar_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}
    /*
     * Get channels attribute.
<br>
     * (Inherited from Mp7JrsAudioDType)
     * @return Mp7JrsintegerVectorPtr
     */
    virtual Mp7JrsintegerVectorPtr Getchannels() const;

    /*
     * Get channels attribute validity information.
     * (Inherited from Mp7JrsAudioDType)
     * @return true if attribute value is valid, false if not.
     */
    virtual bool Existchannels() const;

    /*
     * Set channels attribute.
<br>
     * (Inherited from Mp7JrsAudioDType)
     * @param item const Mp7JrsintegerVectorPtr &
     */
    virtual void Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


    /*
     * Invalidate channels attribute.
     * (Inherited from Mp7JrsAudioDType)
     
     * (Validate it again by setting a value)
     */
    virtual void Invalidatechannels();

    /*
     * Gets or creates Mp7JrsNodePtr child elements of HarmonicSpectralDeviationType.
     * Currently this type contains one child element of type "Mp7JrsNodePtr".

     * <ul>
     * <li>urn:mpeg:mpeg7:schema:2004:SeriesOfScalar</li>
     * </ul>
     * 
     * Supported XPath expressions for GetOrCreateFromXPath
     * 
     * \par<code>/</code>
     *  - Get the root of this node.
     * \par<code>..</code>
     *  - This feature is experimental.
     *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
     * 
     * \par<code>A</code> 
     * - Select all child elements named <code>A</code>.
     * - In case of no element, create a new one.
     * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
     * \par<code>A[i]</code>
     * - Select the <code>i</code>th child element of all <code>A</code>.
     * - Please note, that XPath indexes start at 1.
     * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
     * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
     * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
     * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
     * 
     * \par <code>A[\@xsi:type="T"]</code>
     *     - Select all child elements named <code>A</code> of type <code>T</code>.
     *     - Currently only typenames without namespace are recognised.
     *     - If there is no such element, create and append a new one.
     * \par <code>A[i][\@xsi:type="T"]</code>
     *     - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
     *     - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
     * \par <code>A[\@xsi:type="T"][i]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
     *     - If there is no such element at index <code>i</code>, create and append one.
     * 
     * \par <code>A[last()]</code>
     *     - Select the last child element named <code>A</code>.
     *     - In case of no element, create a new one.
     * \par <code>A[last()][\@xsi:type="T"]</code>
     *     - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[\@xsi:type="T"][last()]</code>
     *     - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
     *     - For collections: in case of no such type, create and append a new one.
     *     - For single elements: if an element with different type exists, return the empty list.
     * 
     * \par <code>A[position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> with its default type.
     *     - For collections: create and append the default element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - For collections: create and append the element.
     *     - For single elements: if any element exists, an exception is thrown.
     *
     * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
     *     - Force creation of a child element named <code>A</code> of type <code>T</code>.
     *     - Behaves the same way as the previous expression.
     * 
     * 
     * Supported XPath expressions for GetFromXPath<br>
     * The same expressions like GetOrCreateFromXPath plus
     * \par <code>A[position() \< i] </code>
     *     - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
     *     - <code>i</code> must be greater than -1, otherwise an exception is thrown.
     * \par <code>A[position() \> i | position() \< j] </code>
     *     - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
     *     - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
     *     - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
     *
     * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
     *
     * @param xpath  the xpath expression to get or create.
     * @param client the ID in case of locking.
     * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
     */
    // xpath: mandatory
    // client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

    

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralDeviationType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsHarmonicSpectralDeviationType();

protected:
    Mp7JrsHarmonicSpectralDeviationType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

    // Base Class
    Mp7JrsPtr< Mp7JrsAudioLLDScalarType > m_Base;


// no includefile for extension defined 
// file Mp7JrsHarmonicSpectralDeviationType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1007MP7JRSHARMONICSPECTRALDEVIATIONTYPE_H

