/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _1021MP7JRSHIERARCHICALSUMMARYTYPE_COMPONENTS_LOCALTYPE_H
#define _1021MP7JRSHIERARCHICALSUMMARYTYPE_COMPONENTS_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_components_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsHierarchicalSummaryType_components_LocalType<br>
 * Located at: mpeg7-2004.xsd, line 7051<br>
 * Enumerations: <br>
 * keyAudioVisualClips (mapped to XML keyAudioVisualClips) <br>
 * keyVideoClips (mapped to XML keyVideoClips) <br>
 * keyAudioClips (mapped to XML keyAudioClips) <br>
 * keyFrames (mapped to XML keyFrames) <br>
 * keySounds (mapped to XML keySounds) <br>
 * keyThemes (mapped to XML keyThemes) <br>
 */
class MP7JRS_EXPORT Mp7JrsHierarchicalSummaryType_components_LocalType
{
public:
	/** Mp7JrsHierarchicalSummaryType_components_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		keyAudioVisualClips, // Mapped to keyAudioVisualClips
		keyVideoClips, // Mapped to keyVideoClips
		keyAudioClips, // Mapped to keyAudioClips
		keyFrames, // Mapped to keyFrames
		keySounds, // Mapped to keySounds
		keyThemes, // Mapped to keyThemes
	};
	

// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_components_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsHierarchicalSummaryType_components_LocalType::Enumeration item);
	static Mp7JrsHierarchicalSummaryType_components_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsHierarchicalSummaryType_components_LocalType_ExtPropDef.h



};
#endif // _1021MP7JRSHIERARCHICALSUMMARYTYPE_COMPONENTS_LOCALTYPE_H
