/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1529MP7JRSNONDEPENDENCYSTRUCTUREPHRASETYPE_LOCALTYPE_H
#define _1529MP7JRSNONDEPENDENCYSTRUCTUREPHRASETYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsNonDependencyStructurePhraseType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtInclude.h


class IMp7JrsDependencyStructurePhraseType;
class IMp7JrsNonDependencyStructurePhraseType;
class IMp7JrsNonDependencyStructurePhraseType_LocalType;
class IMp7JrsWordFormType;
typedef Mp7JrsPtr< IMp7JrsDependencyStructurePhraseType > Mp7JrsDependencyStructurePhrasePtr;
typedef Mp7JrsPtr< IMp7JrsNonDependencyStructurePhraseType > Mp7JrsNonDependencyStructurePhrasePtr;
typedef Mp7JrsPtr< IMp7JrsNonDependencyStructurePhraseType_LocalType> Mp7JrsNonDependencyStructurePhraseType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsWordFormType > Mp7JrsWordFormPtr;

/** 
 * Generated interface IMp7JrsNonDependencyStructurePhraseType_LocalType for class Mp7JrsNonDependencyStructurePhraseType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsNonDependencyStructurePhraseType_LocalType 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsNonDependencyStructurePhraseType_LocalType();
    virtual ~IMp7JrsNonDependencyStructurePhraseType_LocalType();
        /** @name Choice

         */
        //@{
    /**
     * Get Quotation element.
     * @return Mp7JrsDependencyStructurePhrasePtr
     */
    virtual Mp7JrsDependencyStructurePhrasePtr GetQuotation() const = 0;

    /**
     * Set Quotation element.
     * @param item const Mp7JrsDependencyStructurePhrasePtr &
     */
    // Mandatory			
    virtual void SetQuotation(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Phrase element.
     * @return Mp7JrsDependencyStructurePhrasePtr
     */
    virtual Mp7JrsDependencyStructurePhrasePtr GetPhrase() const = 0;

    /**
     * Set Phrase element.
     * @param item const Mp7JrsDependencyStructurePhrasePtr &
     */
    // Mandatory			
    virtual void SetPhrase(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get Word element.
     * @return Mp7JrsWordFormPtr
     */
    virtual Mp7JrsWordFormPtr GetWord() const = 0;

    /**
     * Set Word element.
     * @param item const Mp7JrsWordFormPtr &
     */
    // Mandatory			
    virtual void SetWord(const Mp7JrsWordFormPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get NonDependencyPhrase element.
     * @return Mp7JrsNonDependencyStructurePhrasePtr
     */
    virtual Mp7JrsNonDependencyStructurePhrasePtr GetNonDependencyPhrase() const = 0;

    /**
     * Set NonDependencyPhrase element.
     * @param item const Mp7JrsNonDependencyStructurePhrasePtr &
     */
    // Mandatory			
    virtual void SetNonDependencyPhrase(const Mp7JrsNonDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsNonDependencyStructurePhraseType_LocalType<br>
 * Defined in mpeg7-2004.xsd, line 3870.<br>
 */
class MP7JRS_EXPORT Mp7JrsNonDependencyStructurePhraseType_LocalType :
        public IMp7JrsNonDependencyStructurePhraseType_LocalType
{
    friend class Mp7JrsNonDependencyStructurePhraseType_LocalTypeFactory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get Quotation element.
     * @return Mp7JrsDependencyStructurePhrasePtr
     */
    virtual Mp7JrsDependencyStructurePhrasePtr GetQuotation() const;

    /*
     * Set Quotation element.
     * @param item const Mp7JrsDependencyStructurePhrasePtr &
     */
    // Mandatory			
    virtual void SetQuotation(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Phrase element.
     * @return Mp7JrsDependencyStructurePhrasePtr
     */
    virtual Mp7JrsDependencyStructurePhrasePtr GetPhrase() const;

    /*
     * Set Phrase element.
     * @param item const Mp7JrsDependencyStructurePhrasePtr &
     */
    // Mandatory			
    virtual void SetPhrase(const Mp7JrsDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get Word element.
     * @return Mp7JrsWordFormPtr
     */
    virtual Mp7JrsWordFormPtr GetWord() const;

    /*
     * Set Word element.
     * @param item const Mp7JrsWordFormPtr &
     */
    // Mandatory			
    virtual void SetWord(const Mp7JrsWordFormPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get NonDependencyPhrase element.
     * @return Mp7JrsNonDependencyStructurePhrasePtr
     */
    virtual Mp7JrsNonDependencyStructurePhrasePtr GetNonDependencyPhrase() const;

    /*
     * Set NonDependencyPhrase element.
     * @param item const Mp7JrsNonDependencyStructurePhrasePtr &
     */
    // Mandatory			
    virtual void SetNonDependencyPhrase(const Mp7JrsNonDependencyStructurePhrasePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsNonDependencyStructurePhraseType_LocalType();

protected:
    Mp7JrsNonDependencyStructurePhraseType_LocalType();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsDependencyStructurePhrasePtr m_Quotation;
    Mp7JrsDependencyStructurePhrasePtr m_Phrase;
    Mp7JrsWordFormPtr m_Word;
    Mp7JrsNonDependencyStructurePhrasePtr m_NonDependencyPhrase;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsNonDependencyStructurePhraseType_LocalType_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _1529MP7JRSNONDEPENDENCYSTRUCTUREPHRASETYPE_LOCALTYPE_H

