/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _2701MP7JRSVIDEOVIEWGRAPHTYPE_LOCALTYPE0_H
#define _2701MP7JRSVIDEOVIEWGRAPHTYPE_LOCALTYPE0_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsVideoViewGraphType_LocalType0Factory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtInclude.h


class IMp7JrsReferenceType;
class IMp7JrsVideoViewGraphType;
class IMp7JrsVideoViewGraphType_LocalType0;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType > Mp7JrsVideoViewGraphPtr;
typedef Mp7JrsPtr< IMp7JrsVideoViewGraphType_LocalType0> Mp7JrsVideoViewGraphType_Local0Ptr;

/** 
 * Generated interface IMp7JrsVideoViewGraphType_LocalType0 for class Mp7JrsVideoViewGraphType_LocalType0<br>
 */
class MP7JRS_EXPORT IMp7JrsVideoViewGraphType_LocalType0 
 :
        public Mp7JrsNode
{
public:
    // TODO: make these protected?
    IMp7JrsVideoViewGraphType_LocalType0();
    virtual ~IMp7JrsVideoViewGraphType_LocalType0();
        /** @name Choice

         */
        //@{
    /**
     * Get TimeFrequencyChild element.
     * @return Mp7JrsVideoViewGraphPtr
     */
    virtual Mp7JrsVideoViewGraphPtr GetTimeFrequencyChild() const = 0;

    /**
     * Set TimeFrequencyChild element.
     * @param item const Mp7JrsVideoViewGraphPtr &
     */
    virtual void SetTimeFrequencyChild(const Mp7JrsVideoViewGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

    /**
     * Get TimeFrequencyChildRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetTimeFrequencyChildRef() const = 0;

    /**
     * Set TimeFrequencyChildRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetTimeFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

        //@}
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtPropDef.h

};




/*
 * Generated class Mp7JrsVideoViewGraphType_LocalType0<br>
 * Defined in mpeg7-2004.xsd, line 7672.<br>
 */
class MP7JRS_EXPORT Mp7JrsVideoViewGraphType_LocalType0 :
        public IMp7JrsVideoViewGraphType_LocalType0
{
    friend class Mp7JrsVideoViewGraphType_LocalType0Factory; // constructs objects

public:
        /* @name Choice

         */
        //@{
    /*
     * Get TimeFrequencyChild element.
     * @return Mp7JrsVideoViewGraphPtr
     */
    virtual Mp7JrsVideoViewGraphPtr GetTimeFrequencyChild() const;

    /*
     * Set TimeFrequencyChild element.
     * @param item const Mp7JrsVideoViewGraphPtr &
     */
    virtual void SetTimeFrequencyChild(const Mp7JrsVideoViewGraphPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

    /*
     * Get TimeFrequencyChildRef element.
     * @return Mp7JrsReferencePtr
     */
    virtual Mp7JrsReferencePtr GetTimeFrequencyChildRef() const;

    /*
     * Set TimeFrequencyChildRef element.
     * @param item const Mp7JrsReferencePtr &
     */
    virtual void SetTimeFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

        //@}

    /* Get the class name.
     * @return The name of this class.
     */
    virtual XMLCh * ToText() const;

    /* Parse this type.
     * @param txt buffer to parse from.
     * @return true if parsing was successful, false otherwise.
     */
    virtual bool Parse(const XMLCh * const txt);

    /* Serialialize this object to a DOM tree.
     * @param doc DOM document.
     * @param parent Parent node in DOM tree.
     */
    virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

    /* Deserialize this object from a DOM tree.
     * @param doc DOM document.
     * @param parent Parent element in DOM tree.
     * @param current Current element in DOM tree.
     */
    virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

    /* Creates and inserts a Childnode of the specified Type
     * @param type The tag type of the child to be created (tag name).
     * @param xsitype The xsi type of the child to be created if available.
     * @return the created child with the correct dynamic type for the specified type.
     */
    virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
         
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtMyMethodDef.h


public:

    virtual ~Mp7JrsVideoViewGraphType_LocalType0();

protected:
    Mp7JrsVideoViewGraphType_LocalType0();
    virtual void DeepCopy(const Mp7JrsNodePtr &original);

    virtual Mp7JrsNodeEnum GetAllChildElements() const;

    virtual Mp7JrsNodePtr GetBaseRoot();
    virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
    Mp7JrsVideoViewGraphPtr m_TimeFrequencyChild;
    Mp7JrsReferencePtr m_TimeFrequencyChildRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType0_ExtMyPropDef.h


public:
    virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
    void Cleanup();
};

#endif // _2701MP7JRSVIDEOVIEWGRAPHTYPE_LOCALTYPE0_H

