/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _721MP7JRSDEGREENOTETYPE_H
#define _721MP7JRSDEGREENOTETYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsdegreeNoteType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsdegreeNoteType<br>
 * Located at: mpeg7-2004.xsd, line 2356<br>
 * Enumerations: <br>
 * C (mapped to XML C) <br>
 * D (mapped to XML D) <br>
 * E (mapped to XML E) <br>
 * F (mapped to XML F) <br>
 * G (mapped to XML G) <br>
 * A (mapped to XML A) <br>
 * B (mapped to XML B) <br>
 */
class MP7JRS_EXPORT Mp7JrsdegreeNoteType
{
public:
	/** Mp7JrsdegreeNoteType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		C, // Mapped to C
		D, // Mapped to D
		E, // Mapped to E
		F, // Mapped to F
		G, // Mapped to G
		A, // Mapped to A
		B, // Mapped to B
	};
	

// no includefile for extension defined 
// file Mp7JrsdegreeNoteType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsdegreeNoteType::Enumeration item);
	static Mp7JrsdegreeNoteType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsdegreeNoteType_ExtPropDef.h



};
#endif // _721MP7JRSDEGREENOTETYPE_H
