/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _2601MP7JRSUSERCHOICETYPE_H
#define _2601MP7JRSUSERCHOICETYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsuserChoiceType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsuserChoiceType<br>
 * Located at: mpeg7-2004.xsd, line 8415<br>
 * Enumerations: <br>
 * _true (mapped to XML true) <br>
 * _false (mapped to XML false) <br>
 * user (mapped to XML user) <br>
 */
class MP7JRS_EXPORT Mp7JrsuserChoiceType
{
public:
	/** Mp7JrsuserChoiceType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		_true, // Mapped to true
		_false, // Mapped to false
		user, // Mapped to user
	};
	

// no includefile for extension defined 
// file Mp7JrsuserChoiceType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsuserChoiceType::Enumeration item);
	static Mp7JrsuserChoiceType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsuserChoiceType_ExtPropDef.h



};
#endif // _2601MP7JRSUSERCHOICETYPE_H
