 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_LocalType_ExtImplInclude.h



#include "Mp7JrsAnalyticModelType_Label_LocalType.h"
#include "Mp7JrsAnalyticModelType_Semantics_LocalType.h"
#include "Mp7JrsAnalyticModelType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsAnalyticModelType_LocalType::IMp7JrsAnalyticModelType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_LocalType_ExtPropInit.h

}

IMp7JrsAnalyticModelType_LocalType::~IMp7JrsAnalyticModelType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_LocalType_ExtPropCleanup.h

}

Mp7JrsAnalyticModelType_LocalType::Mp7JrsAnalyticModelType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAnalyticModelType_LocalType::~Mp7JrsAnalyticModelType_LocalType()
{
	Cleanup();
}

void Mp7JrsAnalyticModelType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Label = Mp7JrsAnalyticModelType_Label_LocalPtr(); // Class
	m_Semantics = Mp7JrsAnalyticModelType_Semantics_LocalPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_LocalType_ExtMyPropInit.h

}

void Mp7JrsAnalyticModelType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Label);
	// Mp7JrsFactory::DeleteObject(m_Semantics);
}

void Mp7JrsAnalyticModelType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AnalyticModelType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IAnalyticModelType_LocalType
    const Mp7JrsPtr< Mp7JrsAnalyticModelType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Label);
		this->SetLabel(Mp7JrsFactory::CloneObject(tmp->GetLabel()));
		// Mp7JrsFactory::DeleteObject(m_Semantics);
		this->SetSemantics(Mp7JrsFactory::CloneObject(tmp->GetSemantics()));
}

Mp7JrsNodePtr Mp7JrsAnalyticModelType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsAnalyticModelType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsAnalyticModelType_Label_LocalPtr Mp7JrsAnalyticModelType_LocalType::GetLabel() const
{
	return m_Label;
}

Mp7JrsAnalyticModelType_Semantics_LocalPtr Mp7JrsAnalyticModelType_LocalType::GetSemantics() const
{
	return m_Semantics;
}

// implementing setter for choice 
/* element */
void Mp7JrsAnalyticModelType_LocalType::SetLabel(const Mp7JrsAnalyticModelType_Label_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticModelType_LocalType::SetLabel().");
	}
	if (m_Label != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Label);
		m_Label = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Label) m_Label->SetParent(m_myself.getPointer());
		if (m_Label && m_Label->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AnalyticModelType_Label_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Label->UseTypeAttribute = true;
		}
		if(m_Label != Mp7JrsAnalyticModelType_Label_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Label->SetContentName(XMLString::transcode("Label"));
		}
	// Mp7JrsFactory::DeleteObject(m_Semantics);
	m_Semantics = Mp7JrsAnalyticModelType_Semantics_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAnalyticModelType_LocalType::SetSemantics(const Mp7JrsAnalyticModelType_Semantics_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAnalyticModelType_LocalType::SetSemantics().");
	}
	if (m_Semantics != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Semantics);
		m_Semantics = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Semantics) m_Semantics->SetParent(m_myself.getPointer());
		if (m_Semantics && m_Semantics->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:AnalyticModelType_Semantics_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Semantics->UseTypeAttribute = true;
		}
		if(m_Semantics != Mp7JrsAnalyticModelType_Semantics_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Semantics->SetContentName(XMLString::transcode("Semantics"));
		}
	// Mp7JrsFactory::DeleteObject(m_Label);
	m_Label = Mp7JrsAnalyticModelType_Label_LocalPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: AnalyticModelType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsAnalyticModelType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsAnalyticModelType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsAnalyticModelType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsAnalyticModelType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_Label != Mp7JrsAnalyticModelType_Label_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Label->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Label"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Label->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Semantics != Mp7JrsAnalyticModelType_Semantics_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Semantics->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Semantics"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Semantics->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsAnalyticModelType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Label"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Label")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAnalyticModelType_Label_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetLabel(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Semantics"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Semantics")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateAnalyticModelType_Semantics_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSemantics(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAnalyticModelType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Label")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAnalyticModelType_Label_LocalType;
    }
    this->SetLabel(child);
  }
  if (XMLString::compareString(elementname, X("Semantics")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateAnalyticModelType_Semantics_LocalType;
    }
    this->SetSemantics(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAnalyticModelType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetLabel() != Mp7JrsNodePtr())
		result.Insert(GetLabel());
	if (GetSemantics() != Mp7JrsNodePtr())
		result.Insert(GetSemantics());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAnalyticModelType_LocalType_ExtMethodImpl.h


