 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtImplInclude.h



#include "Mp7JrsTimeType.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionType.h"
#include "Mp7JrstimePointType.h"
#include "Mp7JrsRelTimePointType.h"
#include "Mp7JrsRelIncrTimePointType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsIncrDurationType.h"
#include "Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType::IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtPropInit.h

}

IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType::~IMp7JrsAvailabilityType_AvailabilityPeriod_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtPropCleanup.h

}

Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::~Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType()
{
	Cleanup();
}

void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Init()
{
	// Init base
	m_Base = CreateTimeType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_type = Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr(); // Collection
	m_type_Exist = false;



// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtMyPropInit.h

}

void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_type);
}

void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use AvailabilityType_AvailabilityPeriod_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IAvailabilityType_AvailabilityPeriod_LocalType
    const Mp7JrsPtr< Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsTimePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	// Mp7JrsFactory::DeleteObject(m_type);
	if (tmp->Existtype())
	{
		this->Settype(Mp7JrsFactory::CloneObject(tmp->Gettype()));
	}
	else
	{
		Invalidatetype();
	}
	}
}

Mp7JrsNodePtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsTimeType > Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Gettype() const
{
	return m_type;
}

bool Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Existtype() const
{
	return m_type_Exist;
}
void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Settype(const Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Settype().");
	}
    m_type = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_type) m_type->SetParent(m_myself.getPointer());
	m_type_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Invalidatetype()
{
	m_type_Exist = false;
}
Mp7JrstimePointPtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetTimePoint() const
{
	return GetBase()->GetTimePoint();
}

Mp7JrsRelTimePointPtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetRelTimePoint() const
{
	return GetBase()->GetRelTimePoint();
}

Mp7JrsRelIncrTimePointPtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetRelIncrTimePoint() const
{
	return GetBase()->GetRelIncrTimePoint();
}

Mp7JrsdurationPtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetDuration() const
{
	return GetBase()->GetDuration();
}

Mp7JrsIncrDurationPtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetIncrDuration() const
{
	return GetBase()->GetIncrDuration();
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetTimePoint(const Mp7JrstimePointPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetTimePoint().");
	}
	GetBase()->SetTimePoint(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetRelTimePoint(const Mp7JrsRelTimePointPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetRelTimePoint().");
	}
	GetBase()->SetRelTimePoint(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetRelIncrTimePoint(const Mp7JrsRelIncrTimePointPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetRelIncrTimePoint().");
	}
	GetBase()->SetRelIncrTimePoint(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetDuration(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetDuration().");
	}
	GetBase()->SetDuration(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetIncrDuration(const Mp7JrsIncrDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::SetIncrDuration().");
	}
	GetBase()->SetIncrDuration(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for AvailabilityType_AvailabilityPeriod_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "AvailabilityType_AvailabilityPeriod_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("AvailabilityType_AvailabilityPeriod_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_type_Exist)
	{
	// Collection
	if(m_type != Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr())
	{
		XMLCh * tmp = m_type->ToText();
		element->setAttributeNS(X(""), X("type"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("type")))
	{
        // Deserialize collection type
		Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr tmp = CreateAvailabilityType_AvailabilityPeriod_type_CollectionType;
		tmp->Parse(parent->getAttributeNS(X(""), X("type")));
        this->Settype(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("type")))
	{
     
		// Deserialize collection type
        Mp7JrsAvailabilityType_AvailabilityPeriod_type_CollectionPtr tmp = CreateAvailabilityType_AvailabilityPeriod_type_CollectionType;
        tmp->Parse(parent->getAttribute(X("type")));
        this->Settype(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsTimeType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetTimePoint());
	if (GetRelTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetRelTimePoint());
	if (GetRelIncrTimePoint() != Mp7JrsNodePtr())
		result.Insert(GetRelIncrTimePoint());
	if (GetDuration() != Mp7JrsNodePtr())
		result.Insert(GetDuration());
	if (GetIncrDuration() != Mp7JrsNodePtr())
		result.Insert(GetIncrDuration());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_LocalType_ExtMethodImpl.h


