 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrspreferenceValueType.h"
#include "Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionType.h"
#include "Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsBrowsingPreferencesType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsSummaryPreferencesType.h" // Element collection urn:mpeg:mpeg7:schema:2004:SummaryPreferences
#include "Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:PreferenceCondition

#include <assert.h>
IMp7JrsBrowsingPreferencesType::IMp7JrsBrowsingPreferencesType()
{

// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_ExtPropInit.h

}

IMp7JrsBrowsingPreferencesType::~IMp7JrsBrowsingPreferencesType()
{
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_ExtPropCleanup.h

}

Mp7JrsBrowsingPreferencesType::Mp7JrsBrowsingPreferencesType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsBrowsingPreferencesType::~Mp7JrsBrowsingPreferencesType()
{
	Cleanup();
}

void Mp7JrsBrowsingPreferencesType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_protected = Mp7JrsuserChoiceType::UninitializedEnumeration;
// old	m_protected = Mp7JrsuserChoiceType::Enumeration::;
// old	m_protected_Default = Mp7JrsuserChoiceType::Enumeration::_true;
	m_protected_Default = Mp7JrsuserChoiceType::_true;
	m_protected_Exist = false;
	m_preferenceValue = CreatepreferenceValueType; // Create a valid class
	m_preferenceValue->SetContent(-100); // Use Value initialiser (xxx2)
	m_preferenceValue_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_SummaryPreferences = Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr(); // Collection
	m_PreferenceCondition = Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_ExtMyPropInit.h

}

void Mp7JrsBrowsingPreferencesType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	// Mp7JrsFactory::DeleteObject(m_SummaryPreferences);
	// Mp7JrsFactory::DeleteObject(m_PreferenceCondition);
}

void Mp7JrsBrowsingPreferencesType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use BrowsingPreferencesTypePtr, since we
	// might need GetBase(), which isn't defined in IBrowsingPreferencesType
    const Mp7JrsPtr< Mp7JrsBrowsingPreferencesType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsBrowsingPreferencesType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	if (tmp->Existprotected())
	{
		this->Setprotected(tmp->Getprotected());
	}
	else
	{
		Invalidateprotected();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_preferenceValue);
	if (tmp->ExistpreferenceValue())
	{
		this->SetpreferenceValue(Mp7JrsFactory::CloneObject(tmp->GetpreferenceValue()));
	}
	else
	{
		InvalidatepreferenceValue();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_SummaryPreferences);
		this->SetSummaryPreferences(Mp7JrsFactory::CloneObject(tmp->GetSummaryPreferences()));
		// Mp7JrsFactory::DeleteObject(m_PreferenceCondition);
		this->SetPreferenceCondition(Mp7JrsFactory::CloneObject(tmp->GetPreferenceCondition()));
}

Mp7JrsNodePtr Mp7JrsBrowsingPreferencesType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsBrowsingPreferencesType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsBrowsingPreferencesType::GetBase() const
{
	return m_Base;
}

Mp7JrsuserChoiceType::Enumeration Mp7JrsBrowsingPreferencesType::Getprotected() const
{
	if (this->Existprotected()) {
		return m_protected;
	} else {
		return m_protected_Default;
	}
}

bool Mp7JrsBrowsingPreferencesType::Existprotected() const
{
	return m_protected_Exist;
}
void Mp7JrsBrowsingPreferencesType::Setprotected(Mp7JrsuserChoiceType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::Setprotected().");
	}
    m_protected = item;
	m_protected_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType::Invalidateprotected()
{
	m_protected_Exist = false;
}
Mp7JrspreferenceValuePtr Mp7JrsBrowsingPreferencesType::GetpreferenceValue() const
{
	if (this->ExistpreferenceValue()) {
		return m_preferenceValue;
	} else {
		return m_preferenceValue_Default;
	}
}

bool Mp7JrsBrowsingPreferencesType::ExistpreferenceValue() const
{
	return m_preferenceValue_Exist;
}
void Mp7JrsBrowsingPreferencesType::SetpreferenceValue(const Mp7JrspreferenceValuePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::SetpreferenceValue().");
	}
    m_preferenceValue = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_preferenceValue) m_preferenceValue->SetParent(m_myself.getPointer());
	m_preferenceValue_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType::InvalidatepreferenceValue()
{
	m_preferenceValue_Exist = false;
}
Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr Mp7JrsBrowsingPreferencesType::GetSummaryPreferences() const
{
	return m_SummaryPreferences;
}

Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr Mp7JrsBrowsingPreferencesType::GetPreferenceCondition() const
{
	return m_PreferenceCondition;
}

void Mp7JrsBrowsingPreferencesType::SetSummaryPreferences(const Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::SetSummaryPreferences().");
	}
	if (m_SummaryPreferences != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SummaryPreferences);
		m_SummaryPreferences = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SummaryPreferences) m_SummaryPreferences->SetParent(m_myself.getPointer());
		if(m_SummaryPreferences != Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SummaryPreferences->SetContentName(XMLString::transcode("SummaryPreferences"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType::SetPreferenceCondition(const Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::SetPreferenceCondition().");
	}
	if (m_PreferenceCondition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_PreferenceCondition);
		m_PreferenceCondition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PreferenceCondition) m_PreferenceCondition->SetParent(m_myself.getPointer());
		if(m_PreferenceCondition != Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PreferenceCondition->SetContentName(XMLString::transcode("PreferenceCondition"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsBrowsingPreferencesType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsBrowsingPreferencesType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsBrowsingPreferencesType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsBrowsingPreferencesType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsBrowsingPreferencesType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsBrowsingPreferencesType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsBrowsingPreferencesType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsBrowsingPreferencesType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsBrowsingPreferencesType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsBrowsingPreferencesType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsBrowsingPreferencesType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsBrowsingPreferencesType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsBrowsingPreferencesType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsBrowsingPreferencesType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsBrowsingPreferencesType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsBrowsingPreferencesType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsBrowsingPreferencesType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsBrowsingPreferencesType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("SummaryPreferences")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:SummaryPreferences is item of type SummaryPreferencesType
		// in element collection BrowsingPreferencesType_SummaryPreferences_CollectionType
		
		context->Found = true;
		Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr coll = GetSummaryPreferences();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateBrowsingPreferencesType_SummaryPreferences_CollectionType;
				SetSummaryPreferences(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SummaryPreferencesType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSummaryPreferencesPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PreferenceCondition")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:PreferenceCondition is item of type BrowsingPreferencesType_PreferenceCondition_LocalType
		// in element collection BrowsingPreferencesType_PreferenceCondition_CollectionType
		
		context->Found = true;
		Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr coll = GetPreferenceCondition();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateBrowsingPreferencesType_PreferenceCondition_CollectionType;
				SetPreferenceCondition(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:BrowsingPreferencesType_PreferenceCondition_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for BrowsingPreferencesType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "BrowsingPreferencesType");
	}		
	
	return result;
}

XMLCh * Mp7JrsBrowsingPreferencesType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsBrowsingPreferencesType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsBrowsingPreferencesType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("BrowsingPreferencesType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_protected_Exist)
	{
	// Enumeration
	if(m_protected != Mp7JrsuserChoiceType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsuserChoiceType::ToText(m_protected);
		element->setAttributeNS(X(""), X("protected"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_preferenceValue_Exist)
	{
	// Class
	if (m_preferenceValue != Mp7JrspreferenceValuePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_preferenceValue->ToText();
		element->setAttributeNS(X(""), X("preferenceValue"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_SummaryPreferences != Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SummaryPreferences->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_PreferenceCondition != Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_PreferenceCondition->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsBrowsingPreferencesType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("protected")))
	{
        this->Setprotected(Mp7JrsuserChoiceType::Parse(parent->getAttributeNS(X(""), X("protected"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("protected")))
	{
        this->Setprotected(Mp7JrsuserChoiceType::Parse(parent->getAttribute(X("protected"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("preferenceValue")))
	{
        // Deserialize class type
		Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
		tmp->Parse(parent->getAttributeNS(X(""), X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("preferenceValue")))
	{
		// Deserialize class type
        Mp7JrspreferenceValuePtr tmp = CreatepreferenceValueType;
        tmp->Parse(parent->getAttribute(X("preferenceValue")));
        this->SetpreferenceValue(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("SummaryPreferences"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("SummaryPreferences")) == 0))
        {
            // Deserialize factory type
            Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr tmp = CreateBrowsingPreferencesType_SummaryPreferences_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSummaryPreferences(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("PreferenceCondition"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("PreferenceCondition")) == 0))
        {
            // Deserialize factory type
            Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr tmp = CreateBrowsingPreferencesType_PreferenceCondition_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetPreferenceCondition(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsBrowsingPreferencesType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("SummaryPreferences")) == 0))
  {
    Mp7JrsBrowsingPreferencesType_SummaryPreferences_CollectionPtr tmp = CreateBrowsingPreferencesType_SummaryPreferences_CollectionType;
    this->SetSummaryPreferences(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("PreferenceCondition")) == 0))
  {
    Mp7JrsBrowsingPreferencesType_PreferenceCondition_CollectionPtr tmp = CreateBrowsingPreferencesType_PreferenceCondition_CollectionType;
    this->SetPreferenceCondition(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsBrowsingPreferencesType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSummaryPreferences() != Mp7JrsNodePtr())
		result.Insert(GetSummaryPreferences());
	if (GetPreferenceCondition() != Mp7JrsNodePtr())
		result.Insert(GetPreferenceCondition());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_ExtMethodImpl.h


