 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtImplInclude.h



#include "Mp7JrsPreferenceConditionType.h"
#include "Mp7JrsTermUseType.h"
#include "Mp7JrsPlaceType.h"
#include "Mp7JrsPreferenceConditionType_Time_CollectionType.h"
#include "Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsPreferenceConditionType_Time_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Time

#include <assert.h>
IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtPropInit.h

}

IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::~IMp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtPropCleanup.h

}

Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::~Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType()
{
	Cleanup();
}

void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::Init()
{
	// Init base
	m_Base = CreatePreferenceConditionType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_Genre = Mp7JrsTermUsePtr(); // Class
	m_Genre_Exist = false;


// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtMyPropInit.h

}

void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_Genre);
}

void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use BrowsingPreferencesType_PreferenceCondition_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IBrowsingPreferencesType_PreferenceCondition_LocalType
    const Mp7JrsPtr< Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsPreferenceConditionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	if (tmp->IsValidGenre())
	{
		// Mp7JrsFactory::DeleteObject(m_Genre);
		this->SetGenre(Mp7JrsFactory::CloneObject(tmp->GetGenre()));
	}
	else
	{
		InvalidateGenre();
	}
}

Mp7JrsNodePtr Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsPreferenceConditionType > Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsTermUsePtr Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::GetGenre() const
{
	return m_Genre;
}

// Element is optional
bool Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::IsValidGenre() const
{
	return m_Genre_Exist;
}

void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::SetGenre(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::SetGenre().");
	}
	if (m_Genre != item || m_Genre_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Genre);
		m_Genre = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Genre) m_Genre->SetParent(m_myself.getPointer());
		if (m_Genre && m_Genre->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Genre->UseTypeAttribute = true;
		}
		m_Genre_Exist = true;
		if(m_Genre != Mp7JrsTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Genre->SetContentName(XMLString::transcode("Genre"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::InvalidateGenre()
{
	m_Genre_Exist = false;
}
Mp7JrsPlacePtr Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::GetPlace() const
{
	return GetBase()->GetPlace();
}

// Element is optional
bool Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::IsValidPlace() const
{
	return GetBase()->IsValidPlace();
}

Mp7JrsPreferenceConditionType_Time_CollectionPtr Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::GetTime() const
{
	return GetBase()->GetTime();
}

void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::SetPlace(const Mp7JrsPlacePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::SetPlace().");
	}
	GetBase()->SetPlace(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::InvalidatePlace()
{
	GetBase()->InvalidatePlace();
}
void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::SetTime(const Mp7JrsPreferenceConditionType_Time_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::SetTime().");
	}
	GetBase()->SetTime(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Genre")) == 0)
	{
		// Genre is simple element TermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetGenre()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetGenre(p, client);
					if((p = GetGenre()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for BrowsingPreferencesType_PreferenceCondition_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "BrowsingPreferencesType_PreferenceCondition_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("BrowsingPreferencesType_PreferenceCondition_LocalType"));
	// Element serialization:
	// Class
	
	if (m_Genre != Mp7JrsTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Genre->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Genre"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Genre->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsPreferenceConditionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Genre"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Genre")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetGenre(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  if (XMLString::compareString(elementname, X("Genre")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTermUseType;
    }
    this->SetGenre(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetGenre() != Mp7JrsNodePtr())
		result.Insert(GetGenre());
	if (GetPlace() != Mp7JrsNodePtr())
		result.Insert(GetPlace());
	if (GetTime() != Mp7JrsNodePtr())
		result.Insert(GetTime());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsBrowsingPreferencesType_PreferenceCondition_LocalType_ExtMethodImpl.h


