 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtImplInclude.h



#include "Mp7JrsTermUseType.h"
#include "Mp7JrsColorSamplingType_Field_Component_Offset_LocalType.h"
#include "Mp7JrsColorSamplingType_Field_Component_Period_LocalType.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrsInlineTermDefinitionType_Name_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Definition_CollectionType.h"
#include "Mp7JrsInlineTermDefinitionType_Term_CollectionType.h"
#include "Mp7JrsColorSamplingType_Field_Component_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsInlineTermDefinitionType_Name_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Definition
#include "Mp7JrsInlineTermDefinitionType_Term_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Term

#include <assert.h>
IMp7JrsColorSamplingType_Field_Component_LocalType::IMp7JrsColorSamplingType_Field_Component_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtPropInit.h

}

IMp7JrsColorSamplingType_Field_Component_LocalType::~IMp7JrsColorSamplingType_Field_Component_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtPropCleanup.h

}

Mp7JrsColorSamplingType_Field_Component_LocalType::Mp7JrsColorSamplingType_Field_Component_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsColorSamplingType_Field_Component_LocalType::~Mp7JrsColorSamplingType_Field_Component_LocalType()
{
	Cleanup();
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::Init()
{
	// Init base
	m_Base = CreateTermUseType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_Offset = Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr(); // Class
	m_Offset_Exist = false;
	m_Period = Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr(); // Class
	m_Period_Exist = false;


// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtMyPropInit.h

}

void Mp7JrsColorSamplingType_Field_Component_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_Offset);
	// Mp7JrsFactory::DeleteObject(m_Period);
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ColorSamplingType_Field_Component_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IColorSamplingType_Field_Component_LocalType
    const Mp7JrsPtr< Mp7JrsColorSamplingType_Field_Component_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsTermUsePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsColorSamplingType_Field_Component_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	if (tmp->IsValidOffset())
	{
		// Mp7JrsFactory::DeleteObject(m_Offset);
		this->SetOffset(Mp7JrsFactory::CloneObject(tmp->GetOffset()));
	}
	else
	{
		InvalidateOffset();
	}
	if (tmp->IsValidPeriod())
	{
		// Mp7JrsFactory::DeleteObject(m_Period);
		this->SetPeriod(Mp7JrsFactory::CloneObject(tmp->GetPeriod()));
	}
	else
	{
		InvalidatePeriod();
	}
}

Mp7JrsNodePtr Mp7JrsColorSamplingType_Field_Component_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsColorSamplingType_Field_Component_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsTermUseType > Mp7JrsColorSamplingType_Field_Component_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr Mp7JrsColorSamplingType_Field_Component_LocalType::GetOffset() const
{
	return m_Offset;
}

// Element is optional
bool Mp7JrsColorSamplingType_Field_Component_LocalType::IsValidOffset() const
{
	return m_Offset_Exist;
}

Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr Mp7JrsColorSamplingType_Field_Component_LocalType::GetPeriod() const
{
	return m_Period;
}

// Element is optional
bool Mp7JrsColorSamplingType_Field_Component_LocalType::IsValidPeriod() const
{
	return m_Period_Exist;
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::SetOffset(const Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorSamplingType_Field_Component_LocalType::SetOffset().");
	}
	if (m_Offset != item || m_Offset_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Offset);
		m_Offset = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Offset) m_Offset->SetParent(m_myself.getPointer());
		if (m_Offset && m_Offset->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ColorSamplingType_Field_Component_Offset_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Offset->UseTypeAttribute = true;
		}
		m_Offset_Exist = true;
		if(m_Offset != Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Offset->SetContentName(XMLString::transcode("Offset"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::InvalidateOffset()
{
	m_Offset_Exist = false;
}
void Mp7JrsColorSamplingType_Field_Component_LocalType::SetPeriod(const Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorSamplingType_Field_Component_LocalType::SetPeriod().");
	}
	if (m_Period != item || m_Period_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Period);
		m_Period = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Period) m_Period->SetParent(m_myself.getPointer());
		if (m_Period && m_Period->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ColorSamplingType_Field_Component_Period_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Period->UseTypeAttribute = true;
		}
		m_Period_Exist = true;
		if(m_Period != Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Period->SetContentName(XMLString::transcode("Period"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::InvalidatePeriod()
{
	m_Period_Exist = false;
}
Mp7JrstermReferencePtr Mp7JrsColorSamplingType_Field_Component_LocalType::Gethref() const
{
	return GetBase()->Gethref();
}

bool Mp7JrsColorSamplingType_Field_Component_LocalType::Existhref() const
{
	return GetBase()->Existhref();
}
void Mp7JrsColorSamplingType_Field_Component_LocalType::Sethref(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorSamplingType_Field_Component_LocalType::Sethref().");
	}
	GetBase()->Sethref(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::Invalidatehref()
{
	GetBase()->Invalidatehref();
}
Mp7JrsInlineTermDefinitionType_Name_CollectionPtr Mp7JrsColorSamplingType_Field_Component_LocalType::GetName() const
{
	return GetBase()->GetBase()->GetName();
}

Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr Mp7JrsColorSamplingType_Field_Component_LocalType::GetDefinition() const
{
	return GetBase()->GetBase()->GetDefinition();
}

Mp7JrsInlineTermDefinitionType_Term_CollectionPtr Mp7JrsColorSamplingType_Field_Component_LocalType::GetTerm() const
{
	return GetBase()->GetBase()->GetTerm();
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::SetName(const Mp7JrsInlineTermDefinitionType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorSamplingType_Field_Component_LocalType::SetName().");
	}
	GetBase()->GetBase()->SetName(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::SetDefinition(const Mp7JrsInlineTermDefinitionType_Definition_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorSamplingType_Field_Component_LocalType::SetDefinition().");
	}
	GetBase()->GetBase()->SetDefinition(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsColorSamplingType_Field_Component_LocalType::SetTerm(const Mp7JrsInlineTermDefinitionType_Term_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsColorSamplingType_Field_Component_LocalType::SetTerm().");
	}
	GetBase()->GetBase()->SetTerm(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsColorSamplingType_Field_Component_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Offset")) == 0)
	{
		// Offset is simple element ColorSamplingType_Field_Component_Offset_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetOffset()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ColorSamplingType_Field_Component_Offset_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetOffset(p, client);
					if((p = GetOffset()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Period")) == 0)
	{
		// Period is simple element ColorSamplingType_Field_Component_Period_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPeriod()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ColorSamplingType_Field_Component_Period_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPeriod(p, client);
					if((p = GetPeriod()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for ColorSamplingType_Field_Component_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "ColorSamplingType_Field_Component_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsColorSamplingType_Field_Component_LocalType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsColorSamplingType_Field_Component_LocalType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsColorSamplingType_Field_Component_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("ColorSamplingType_Field_Component_LocalType"));
	// Element serialization:
	// Class
	
	if (m_Offset != Mp7JrsColorSamplingType_Field_Component_Offset_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Offset->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Offset"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Offset->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Period != Mp7JrsColorSamplingType_Field_Component_Period_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Period->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Period"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Period->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsColorSamplingType_Field_Component_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsTermUseType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Offset"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Offset")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateColorSamplingType_Field_Component_Offset_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetOffset(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Period"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Period")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateColorSamplingType_Field_Component_Period_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPeriod(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsColorSamplingType_Field_Component_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  if (XMLString::compareString(elementname, X("Offset")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateColorSamplingType_Field_Component_Offset_LocalType;
    }
    this->SetOffset(child);
  }
  if (XMLString::compareString(elementname, X("Period")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateColorSamplingType_Field_Component_Period_LocalType;
    }
    this->SetPeriod(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsColorSamplingType_Field_Component_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetOffset() != Mp7JrsNodePtr())
		result.Insert(GetOffset());
	if (GetPeriod() != Mp7JrsNodePtr())
		result.Insert(GetPeriod());
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetDefinition() != Mp7JrsNodePtr())
		result.Insert(GetDefinition());
	if (GetTerm() != Mp7JrsNodePtr())
		result.Insert(GetTerm());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsColorSamplingType_Field_Component_LocalType_ExtMethodImpl.h


