
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsColorSpaceType_type_LocalType_ExtImplInclude.h


#include "Mp7JrsColorSpaceType_type_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsColorSpaceType_type_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsColorSpaceType_type_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsColorSpaceType_type_LocalType::ToText(Mp7JrsColorSpaceType_type_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/RGB:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("RGB");
			break;
		case /*Enumeration::*/YCbCr:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("YCbCr");
			break;
		case /*Enumeration::*/HSV:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("HSV");
			break;
		case /*Enumeration::*/HMMD:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("HMMD");
			break;
		case /*Enumeration::*/LinearMatrix:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("LinearMatrix");
			break;
		case /*Enumeration::*/Monochrome:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("Monochrome");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsColorSpaceType_type_LocalType::Enumeration Mp7JrsColorSpaceType_type_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsColorSpaceType_type_LocalType::Enumeration result = Mp7JrsColorSpaceType_type_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "RGB") == 0)
	{
		result = Mp7JrsColorSpaceType_type_LocalType::/*Enumeration::*/RGB;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "YCbCr") == 0)
	{
		result = Mp7JrsColorSpaceType_type_LocalType::/*Enumeration::*/YCbCr;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "HSV") == 0)
	{
		result = Mp7JrsColorSpaceType_type_LocalType::/*Enumeration::*/HSV;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "HMMD") == 0)
	{
		result = Mp7JrsColorSpaceType_type_LocalType::/*Enumeration::*/HMMD;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "LinearMatrix") == 0)
	{
		result = Mp7JrsColorSpaceType_type_LocalType::/*Enumeration::*/LinearMatrix;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "Monochrome") == 0)
	{
		result = Mp7JrsColorSpaceType_type_LocalType::/*Enumeration::*/Monochrome;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
