 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_ExtImplInclude.h



#include "Mp7JrsTemporalSegmentDecompositionType.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType.h" // Sequence collection IntraCompositionShot
#include "Mp7JrsIntraCompositionShotType.h" // Sequence collection element IntraCompositionShot
#include "Mp7JrsReferenceType.h" // Sequence collection element IntraCompositionShotRef
#include "Mp7JrsInternalTransitionType.h" // Sequence collection element InternalTransition

#include <assert.h>
IMp7JrsCompositionShotEditingTemporalDecompositionType::IMp7JrsCompositionShotEditingTemporalDecompositionType()
{

// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_ExtPropInit.h

}

IMp7JrsCompositionShotEditingTemporalDecompositionType::~IMp7JrsCompositionShotEditingTemporalDecompositionType()
{
// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_ExtPropCleanup.h

}

Mp7JrsCompositionShotEditingTemporalDecompositionType::Mp7JrsCompositionShotEditingTemporalDecompositionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsCompositionShotEditingTemporalDecompositionType::~Mp7JrsCompositionShotEditingTemporalDecompositionType()
{
	Cleanup();
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::Init()
{
	// Init base
	m_Base = CreateTemporalSegmentDecompositionType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_CompositionShotEditingTemporalDecompositionType_LocalType = Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_ExtMyPropInit.h

}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_CompositionShotEditingTemporalDecompositionType_LocalType);
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use CompositionShotEditingTemporalDecompositionTypePtr, since we
	// might need GetBase(), which isn't defined in ICompositionShotEditingTemporalDecompositionType
    const Mp7JrsPtr< Mp7JrsCompositionShotEditingTemporalDecompositionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsTemporalSegmentDecompositionPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsCompositionShotEditingTemporalDecompositionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_CompositionShotEditingTemporalDecompositionType_LocalType);
		this->SetCompositionShotEditingTemporalDecompositionType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetCompositionShotEditingTemporalDecompositionType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsCompositionShotEditingTemporalDecompositionType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsCompositionShotEditingTemporalDecompositionType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsTemporalSegmentDecompositionType > Mp7JrsCompositionShotEditingTemporalDecompositionType::GetBase() const
{
	return m_Base;
}

Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr Mp7JrsCompositionShotEditingTemporalDecompositionType::GetCompositionShotEditingTemporalDecompositionType_LocalType() const
{
	return m_CompositionShotEditingTemporalDecompositionType_LocalType;
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::SetCompositionShotEditingTemporalDecompositionType_LocalType(const Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::SetCompositionShotEditingTemporalDecompositionType_LocalType().");
	}
	if (m_CompositionShotEditingTemporalDecompositionType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CompositionShotEditingTemporalDecompositionType_LocalType);
		m_CompositionShotEditingTemporalDecompositionType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CompositionShotEditingTemporalDecompositionType_LocalType) m_CompositionShotEditingTemporalDecompositionType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsCompositionShotEditingTemporalDecompositionType::Getcriteria() const
{
	return GetBase()->GetBase()->Getcriteria();
}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::Existcriteria() const
{
	return GetBase()->GetBase()->Existcriteria();
}
void Mp7JrsCompositionShotEditingTemporalDecompositionType::Setcriteria(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::Setcriteria().");
	}
	GetBase()->GetBase()->Setcriteria(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::Invalidatecriteria()
{
	GetBase()->GetBase()->Invalidatecriteria();
}
bool Mp7JrsCompositionShotEditingTemporalDecompositionType::Getoverlap() const
{
	return GetBase()->GetBase()->Getoverlap();
}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::Existoverlap() const
{
	return GetBase()->GetBase()->Existoverlap();
}
void Mp7JrsCompositionShotEditingTemporalDecompositionType::Setoverlap(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::Setoverlap().");
	}
	GetBase()->GetBase()->Setoverlap(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::Invalidateoverlap()
{
	GetBase()->GetBase()->Invalidateoverlap();
}
bool Mp7JrsCompositionShotEditingTemporalDecompositionType::Getgap() const
{
	return GetBase()->GetBase()->Getgap();
}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::Existgap() const
{
	return GetBase()->GetBase()->Existgap();
}
void Mp7JrsCompositionShotEditingTemporalDecompositionType::Setgap(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::Setgap().");
	}
	GetBase()->GetBase()->Setgap(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::Invalidategap()
{
	GetBase()->GetBase()->Invalidategap();
}
XMLCh * Mp7JrsCompositionShotEditingTemporalDecompositionType::Getid() const
{
	return GetBase()->GetBase()->GetBase()->Getid();
}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::Existid() const
{
	return GetBase()->GetBase()->GetBase()->Existid();
}
void Mp7JrsCompositionShotEditingTemporalDecompositionType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::Setid().");
	}
	GetBase()->GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::Invalidateid()
{
	GetBase()->GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsCompositionShotEditingTemporalDecompositionType::GettimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::ExisttimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsCompositionShotEditingTemporalDecompositionType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::SettimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::InvalidatetimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsCompositionShotEditingTemporalDecompositionType::GettimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsCompositionShotEditingTemporalDecompositionType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::SettimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsCompositionShotEditingTemporalDecompositionType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsCompositionShotEditingTemporalDecompositionType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsCompositionShotEditingTemporalDecompositionType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsCompositionShotEditingTemporalDecompositionType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsCompositionShotEditingTemporalDecompositionType::GetHeader() const
{
	return GetBase()->GetBase()->GetBase()->GetHeader();
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType::SetHeader().");
	}
	GetBase()->GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsCompositionShotEditingTemporalDecompositionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("IntraCompositionShot")) == 0)
	{
		// IntraCompositionShot is contained in itemtype CompositionShotEditingTemporalDecompositionType_LocalType
		// in sequence collection CompositionShotEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr coll = GetCompositionShotEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCompositionShotEditingTemporalDecompositionType_CollectionType;
				SetCompositionShotEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetIntraCompositionShot()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr item = CreateCompositionShotEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetIntraCompositionShot(
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetIntraCompositionShot());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetIntraCompositionShot(
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetIntraCompositionShot());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:IntraCompositionShotType")))) != empty)
			{
				// Is type allowed
				Mp7JrsIntraCompositionShotPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetIntraCompositionShot(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetIntraCompositionShot()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("IntraCompositionShotRef")) == 0)
	{
		// IntraCompositionShotRef is contained in itemtype CompositionShotEditingTemporalDecompositionType_LocalType
		// in sequence collection CompositionShotEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr coll = GetCompositionShotEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCompositionShotEditingTemporalDecompositionType_CollectionType;
				SetCompositionShotEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetIntraCompositionShotRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr item = CreateCompositionShotEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetIntraCompositionShotRef(
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetIntraCompositionShotRef());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetIntraCompositionShotRef(
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetIntraCompositionShotRef());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetIntraCompositionShotRef(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetIntraCompositionShotRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("InternalTransition")) == 0)
	{
		// InternalTransition is contained in itemtype CompositionShotEditingTemporalDecompositionType_LocalType
		// in sequence collection CompositionShotEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr coll = GetCompositionShotEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCompositionShotEditingTemporalDecompositionType_CollectionType;
				SetCompositionShotEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetInternalTransition()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr item = CreateCompositionShotEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetInternalTransition(
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetInternalTransition());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetInternalTransition(
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetInternalTransition());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InternalTransitionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsInternalTransitionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetInternalTransition(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetInternalTransition()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("InternalTransitionRef")) == 0)
	{
		// InternalTransitionRef is contained in itemtype CompositionShotEditingTemporalDecompositionType_LocalType
		// in sequence collection CompositionShotEditingTemporalDecompositionType_CollectionType

		context->Found = true;
		Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr coll = GetCompositionShotEditingTemporalDecompositionType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateCompositionShotEditingTemporalDecompositionType_CollectionType;
				SetCompositionShotEditingTemporalDecompositionType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetInternalTransitionRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr item = CreateCompositionShotEditingTemporalDecompositionType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetInternalTransitionRef(
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j+1))->GetInternalTransitionRef());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j))->SetInternalTransitionRef(
						((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(j-1))->GetInternalTransitionRef());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->SetInternalTransitionRef(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalPtr)coll->elementAt(i))->GetInternalTransitionRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for CompositionShotEditingTemporalDecompositionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "CompositionShotEditingTemporalDecompositionType");
	}		
	
	return result;
}

XMLCh * Mp7JrsCompositionShotEditingTemporalDecompositionType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsCompositionShotEditingTemporalDecompositionType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsCompositionShotEditingTemporalDecompositionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("CompositionShotEditingTemporalDecompositionType"));
	// Element serialization:
	if (m_CompositionShotEditingTemporalDecompositionType_LocalType != Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_CompositionShotEditingTemporalDecompositionType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsTemporalSegmentDecompositionType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Sequence Collection
        if((parent != NULL) && (
            (XMLString::compareString(parent->getNodeName()
            , X("urn:mpeg:mpeg7:schema:2004:IntraCompositionShot")) == 0)
                ||
            (XMLString::compareString(parent->getNodeName()
            , X("urn:mpeg:mpeg7:schema:2004:IntraCompositionShotRef")) == 0)
                ||
            (XMLString::compareString(parent->getNodeName()
            , X("urn:mpeg:mpeg7:schema:2004:InternalTransition")) == 0)
                ||
            (XMLString::compareString(parent->getNodeName()
            , X("urn:mpeg:mpeg7:schema:2004:InternalTransitionRef")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr tmp = CreateCompositionShotEditingTemporalDecompositionType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetCompositionShotEditingTemporalDecompositionType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsCompositionShotEditingTemporalDecompositionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
    // local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
    Mp7JrsCompositionShotEditingTemporalDecompositionType_CollectionPtr tmp = CreateCompositionShotEditingTemporalDecompositionType_CollectionType;
    this->SetCompositionShotEditingTemporalDecompositionType_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsCompositionShotEditingTemporalDecompositionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetCompositionShotEditingTemporalDecompositionType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetCompositionShotEditingTemporalDecompositionType_LocalType());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_ExtMethodImpl.h


