 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType_ExtImplInclude.h



#include "Mp7JrsIntraCompositionShotType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsInternalTransitionType.h"
#include "Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::IMp7JrsCompositionShotEditingTemporalDecompositionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType_ExtPropInit.h

}

IMp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::~IMp7JrsCompositionShotEditingTemporalDecompositionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType_ExtPropCleanup.h

}

Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::~Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType()
{
	Cleanup();
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_IntraCompositionShot = Mp7JrsIntraCompositionShotPtr(); // Class
	m_IntraCompositionShotRef = Mp7JrsReferencePtr(); // Class
	m_InternalTransition = Mp7JrsInternalTransitionPtr(); // Class
	m_InternalTransitionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShot);
	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotRef);
	// Mp7JrsFactory::DeleteObject(m_InternalTransition);
	// Mp7JrsFactory::DeleteObject(m_InternalTransitionRef);
}

void Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use CompositionShotEditingTemporalDecompositionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ICompositionShotEditingTemporalDecompositionType_LocalType
    const Mp7JrsPtr< Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_IntraCompositionShot);
		this->SetIntraCompositionShot(Mp7JrsFactory::CloneObject(tmp->GetIntraCompositionShot()));
		// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotRef);
		this->SetIntraCompositionShotRef(Mp7JrsFactory::CloneObject(tmp->GetIntraCompositionShotRef()));
		// Mp7JrsFactory::DeleteObject(m_InternalTransition);
		this->SetInternalTransition(Mp7JrsFactory::CloneObject(tmp->GetInternalTransition()));
		// Mp7JrsFactory::DeleteObject(m_InternalTransitionRef);
		this->SetInternalTransitionRef(Mp7JrsFactory::CloneObject(tmp->GetInternalTransitionRef()));
}

Mp7JrsNodePtr Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsIntraCompositionShotPtr Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::GetIntraCompositionShot() const
{
	return m_IntraCompositionShot;
}

Mp7JrsReferencePtr Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::GetIntraCompositionShotRef() const
{
	return m_IntraCompositionShotRef;
}

Mp7JrsInternalTransitionPtr Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::GetInternalTransition() const
{
	return m_InternalTransition;
}

Mp7JrsReferencePtr Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::GetInternalTransitionRef() const
{
	return m_InternalTransitionRef;
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* choice */
// implementing setter for choice 
/* element */
void Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::SetIntraCompositionShot(const Mp7JrsIntraCompositionShotPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::SetIntraCompositionShot().");
	}
	if (m_IntraCompositionShot != item)
	{
		// Mp7JrsFactory::DeleteObject(m_IntraCompositionShot);
		m_IntraCompositionShot = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_IntraCompositionShot) m_IntraCompositionShot->SetParent(m_myself.getPointer());
		if (m_IntraCompositionShot && m_IntraCompositionShot->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:IntraCompositionShotType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_IntraCompositionShot->UseTypeAttribute = true;
		}
		if(m_IntraCompositionShot != Mp7JrsIntraCompositionShotPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_IntraCompositionShot->SetContentName(XMLString::transcode("IntraCompositionShot"));
		}
	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotRef);
	m_IntraCompositionShotRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_InternalTransition);
	m_InternalTransition = Mp7JrsInternalTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_InternalTransitionRef);
	m_InternalTransitionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::SetIntraCompositionShotRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::SetIntraCompositionShotRef().");
	}
	if (m_IntraCompositionShotRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotRef);
		m_IntraCompositionShotRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_IntraCompositionShotRef) m_IntraCompositionShotRef->SetParent(m_myself.getPointer());
		if (m_IntraCompositionShotRef && m_IntraCompositionShotRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_IntraCompositionShotRef->UseTypeAttribute = true;
		}
		if(m_IntraCompositionShotRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_IntraCompositionShotRef->SetContentName(XMLString::transcode("IntraCompositionShotRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShot);
	m_IntraCompositionShot = Mp7JrsIntraCompositionShotPtr();
	// Mp7JrsFactory::DeleteObject(m_InternalTransition);
	m_InternalTransition = Mp7JrsInternalTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_InternalTransitionRef);
	m_InternalTransitionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* choice */
// implementing setter for choice 
/* element */
void Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::SetInternalTransition(const Mp7JrsInternalTransitionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::SetInternalTransition().");
	}
	if (m_InternalTransition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_InternalTransition);
		m_InternalTransition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_InternalTransition) m_InternalTransition->SetParent(m_myself.getPointer());
		if (m_InternalTransition && m_InternalTransition->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:InternalTransitionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_InternalTransition->UseTypeAttribute = true;
		}
		if(m_InternalTransition != Mp7JrsInternalTransitionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_InternalTransition->SetContentName(XMLString::transcode("InternalTransition"));
		}
	// Mp7JrsFactory::DeleteObject(m_InternalTransitionRef);
	m_InternalTransitionRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShot);
	m_IntraCompositionShot = Mp7JrsIntraCompositionShotPtr();
	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotRef);
	m_IntraCompositionShotRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::SetInternalTransitionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::SetInternalTransitionRef().");
	}
	if (m_InternalTransitionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_InternalTransitionRef);
		m_InternalTransitionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_InternalTransitionRef) m_InternalTransitionRef->SetParent(m_myself.getPointer());
		if (m_InternalTransitionRef && m_InternalTransitionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_InternalTransitionRef->UseTypeAttribute = true;
		}
		if(m_InternalTransitionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_InternalTransitionRef->SetContentName(XMLString::transcode("InternalTransitionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_InternalTransition);
	m_InternalTransition = Mp7JrsInternalTransitionPtr();
	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShot);
	m_IntraCompositionShot = Mp7JrsIntraCompositionShotPtr();
	// Mp7JrsFactory::DeleteObject(m_IntraCompositionShotRef);
	m_IntraCompositionShotRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: CompositionShotEditingTemporalDecompositionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("CompositionShotEditingTemporalDecompositionType_LocalType"));
	// Element serialization:
	// Class
	
	if (m_IntraCompositionShot != Mp7JrsIntraCompositionShotPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_IntraCompositionShot->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("IntraCompositionShot"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_IntraCompositionShot->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_IntraCompositionShotRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_IntraCompositionShotRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("IntraCompositionShotRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_IntraCompositionShotRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_InternalTransition != Mp7JrsInternalTransitionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_InternalTransition->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("InternalTransition"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_InternalTransition->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_InternalTransitionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_InternalTransitionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("InternalTransitionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_InternalTransitionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("IntraCompositionShot"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("IntraCompositionShot")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateIntraCompositionShotType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetIntraCompositionShot(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("IntraCompositionShotRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("IntraCompositionShotRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetIntraCompositionShotRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("InternalTransition"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("InternalTransition")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateInternalTransitionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetInternalTransition(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("InternalTransitionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("InternalTransitionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetInternalTransitionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
	} while(false);
// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("IntraCompositionShot")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateIntraCompositionShotType;
    }
    this->SetIntraCompositionShot(child);
  }
  if (XMLString::compareString(elementname, X("IntraCompositionShotRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetIntraCompositionShotRef(child);
  }
  if (XMLString::compareString(elementname, X("InternalTransition")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateInternalTransitionType;
    }
    this->SetInternalTransition(child);
  }
  if (XMLString::compareString(elementname, X("InternalTransitionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetInternalTransitionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetIntraCompositionShot() != Mp7JrsNodePtr())
		result.Insert(GetIntraCompositionShot());
	if (GetIntraCompositionShotRef() != Mp7JrsNodePtr())
		result.Insert(GetIntraCompositionShotRef());
	if (GetInternalTransition() != Mp7JrsNodePtr())
		result.Insert(GetInternalTransition());
	if (GetInternalTransitionRef() != Mp7JrsNodePtr())
		result.Insert(GetInternalTransitionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsCompositionShotEditingTemporalDecompositionType_LocalType_ExtMethodImpl.h


