 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtImplInclude.h



#include "Mp7JrsContentCollectionType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsContentCollectionType_LocalType1.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsContentCollectionType_LocalType1::IMp7JrsContentCollectionType_LocalType1()
{

// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtPropInit.h

}

IMp7JrsContentCollectionType_LocalType1::~IMp7JrsContentCollectionType_LocalType1()
{
// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtPropCleanup.h

}

Mp7JrsContentCollectionType_LocalType1::Mp7JrsContentCollectionType_LocalType1()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsContentCollectionType_LocalType1::~Mp7JrsContentCollectionType_LocalType1()
{
	Cleanup();
}

void Mp7JrsContentCollectionType_LocalType1::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_ContentCollection = Mp7JrsContentCollectionPtr(); // Class
	m_ContentCollectionRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtMyPropInit.h

}

void Mp7JrsContentCollectionType_LocalType1::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_ContentCollection);
	// Mp7JrsFactory::DeleteObject(m_ContentCollectionRef);
}

void Mp7JrsContentCollectionType_LocalType1::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use ContentCollectionType_LocalType1Ptr, since we
	// might need GetBase(), which isn't defined in IContentCollectionType_LocalType1
    const Mp7JrsPtr< Mp7JrsContentCollectionType_LocalType1 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_ContentCollection);
		this->SetContentCollection(Mp7JrsFactory::CloneObject(tmp->GetContentCollection()));
		// Mp7JrsFactory::DeleteObject(m_ContentCollectionRef);
		this->SetContentCollectionRef(Mp7JrsFactory::CloneObject(tmp->GetContentCollectionRef()));
}

Mp7JrsNodePtr Mp7JrsContentCollectionType_LocalType1::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsContentCollectionType_LocalType1::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsContentCollectionPtr Mp7JrsContentCollectionType_LocalType1::GetContentCollection() const
{
	return m_ContentCollection;
}

Mp7JrsReferencePtr Mp7JrsContentCollectionType_LocalType1::GetContentCollectionRef() const
{
	return m_ContentCollectionRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsContentCollectionType_LocalType1::SetContentCollection(const Mp7JrsContentCollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContentCollectionType_LocalType1::SetContentCollection().");
	}
	if (m_ContentCollection != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ContentCollection);
		m_ContentCollection = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ContentCollection) m_ContentCollection->SetParent(m_myself.getPointer());
		if (m_ContentCollection && m_ContentCollection->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ContentCollectionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ContentCollection->UseTypeAttribute = true;
		}
		if(m_ContentCollection != Mp7JrsContentCollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ContentCollection->SetContentName(XMLString::transcode("ContentCollection"));
		}
	// Mp7JrsFactory::DeleteObject(m_ContentCollectionRef);
	m_ContentCollectionRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsContentCollectionType_LocalType1::SetContentCollectionRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsContentCollectionType_LocalType1::SetContentCollectionRef().");
	}
	if (m_ContentCollectionRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_ContentCollectionRef);
		m_ContentCollectionRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ContentCollectionRef) m_ContentCollectionRef->SetParent(m_myself.getPointer());
		if (m_ContentCollectionRef && m_ContentCollectionRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ContentCollectionRef->UseTypeAttribute = true;
		}
		if(m_ContentCollectionRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ContentCollectionRef->SetContentName(XMLString::transcode("ContentCollectionRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_ContentCollection);
	m_ContentCollection = Mp7JrsContentCollectionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: ContentCollectionType_LocalType1: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsContentCollectionType_LocalType1::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsContentCollectionType_LocalType1::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsContentCollectionType_LocalType1::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsContentCollectionType_LocalType1::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_ContentCollection != Mp7JrsContentCollectionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ContentCollection->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ContentCollection"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ContentCollection->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ContentCollectionRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ContentCollectionRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ContentCollectionRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ContentCollectionRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsContentCollectionType_LocalType1::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ContentCollection"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ContentCollection")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateContentCollectionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetContentCollection(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ContentCollectionRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ContentCollectionRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetContentCollectionRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsContentCollectionType_LocalType1::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("ContentCollection")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateContentCollectionType;
    }
    this->SetContentCollection(child);
  }
  if (XMLString::compareString(elementname, X("ContentCollectionRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetContentCollectionRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsContentCollectionType_LocalType1::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetContentCollection() != Mp7JrsNodePtr())
		result.Insert(GetContentCollection());
	if (GetContentCollectionRef() != Mp7JrsNodePtr())
		result.Insert(GetContentCollectionRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsContentCollectionType_LocalType1_ExtMethodImpl.h


