 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtImplInclude.h



#include "Mp7JrsdependencyOperatorType.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrsDependencyStructurePhraseType_operator_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsDependencyStructurePhraseType_operator_LocalType::IMp7JrsDependencyStructurePhraseType_operator_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtPropInit.h

}

IMp7JrsDependencyStructurePhraseType_operator_LocalType::~IMp7JrsDependencyStructurePhraseType_operator_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtPropCleanup.h

}

Mp7JrsDependencyStructurePhraseType_operator_LocalType::Mp7JrsDependencyStructurePhraseType_operator_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsDependencyStructurePhraseType_operator_LocalType::~Mp7JrsDependencyStructurePhraseType_operator_LocalType()
{
	Cleanup();
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_dependencyOperatorType = Mp7JrsdependencyOperatorPtr(); // Class
	m_termReferenceType = Mp7JrstermReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtMyPropInit.h

}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_dependencyOperatorType);
	// Mp7JrsFactory::DeleteObject(m_termReferenceType);
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use DependencyStructurePhraseType_operator_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IDependencyStructurePhraseType_operator_LocalType
    const Mp7JrsPtr< Mp7JrsDependencyStructurePhraseType_operator_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if(tmp->GetdependencyOperatorType() != Mp7JrsdependencyOperatorPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		this->SetdependencyOperatorType(Mp7JrsFactory::CloneObject(tmp->GetdependencyOperatorType()));
		return; 
	}
	if(tmp->GettermReferenceType() != Mp7JrstermReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		this->SettermReferenceType(Mp7JrsFactory::CloneObject(tmp->GettermReferenceType()));
		return; 
	}
	}
}

Mp7JrsNodePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsdependencyOperatorPtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetdependencyOperatorType() const
{
	return m_dependencyOperatorType;
}

Mp7JrstermReferencePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::GettermReferenceType() const
{
	return m_termReferenceType;
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::SetdependencyOperatorType(const Mp7JrsdependencyOperatorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDependencyStructurePhraseType_operator_LocalType::SetdependencyOperatorType().");
	}
	if (m_dependencyOperatorType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_dependencyOperatorType);
		m_dependencyOperatorType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_dependencyOperatorType) m_dependencyOperatorType->SetParent(m_myself.getPointer());
		if (m_dependencyOperatorType && m_dependencyOperatorType->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:dependencyOperatorType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_dependencyOperatorType->UseTypeAttribute = true;
		}
		if(m_dependencyOperatorType != Mp7JrsdependencyOperatorPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_dependencyOperatorType->SetContentName(XMLString::transcode("dependencyOperatorType"));
		}
	// Mp7JrsFactory::DeleteObject(m_termReferenceType);
	m_termReferenceType = Mp7JrstermReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::SettermReferenceType(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDependencyStructurePhraseType_operator_LocalType::SettermReferenceType().");
	}
	if (m_termReferenceType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_termReferenceType);
		m_termReferenceType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_termReferenceType) m_termReferenceType->SetParent(m_myself.getPointer());
		if (m_termReferenceType && m_termReferenceType->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:termReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_termReferenceType->UseTypeAttribute = true;
		}
		if(m_termReferenceType != Mp7JrstermReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_termReferenceType->SetContentName(XMLString::transcode("termReferenceType"));
		}
	// Mp7JrsFactory::DeleteObject(m_dependencyOperatorType);
	m_dependencyOperatorType = Mp7JrsdependencyOperatorPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("dependencyOperatorType")) == 0)
	{
		// dependencyOperatorType is simple element dependencyOperatorType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetdependencyOperatorType()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:dependencyOperatorType")))) != empty)
			{
				// Is type allowed
				Mp7JrsdependencyOperatorPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetdependencyOperatorType(p, client);
					if((p = GetdependencyOperatorType()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("termReferenceType")) == 0)
	{
		// termReferenceType is simple element termReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GettermReferenceType()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:termReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrstermReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SettermReferenceType(p, client);
					if((p = GettermReferenceType()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for DependencyStructurePhraseType_operator_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "DependencyStructurePhraseType_operator_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsDependencyStructurePhraseType_operator_LocalType::ToText() const
{
	if(m_dependencyOperatorType != Mp7JrsdependencyOperatorPtr())
	{
		return m_dependencyOperatorType->ToText();
	}
	if(m_termReferenceType != Mp7JrstermReferencePtr())
	{
		return m_termReferenceType->ToText();
	}
	return XMLString::transcode("");
}


bool Mp7JrsDependencyStructurePhraseType_operator_LocalType::Parse(const XMLCh * const txt)
{
	// Parse stu factory type
	{
		Mp7JrsdependencyOperatorPtr tmp = CreatedependencyOperatorType;
		if(tmp->Parse(txt))
		{
			this->SetdependencyOperatorType(tmp);
			return true;
		}
		Mp7JrsFactory::DeleteObject(tmp);
	}
	// Parse stu factory type
	{
		Mp7JrstermReferencePtr tmp = CreatetermReferenceType;
		if(tmp->Parse(txt))
		{
			this->SettermReferenceType(tmp);
			return true;
		}
		Mp7JrsFactory::DeleteObject(tmp);
	}
	return false;
}

bool Mp7JrsDependencyStructurePhraseType_operator_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsDependencyStructurePhraseType_operator_LocalType has no attributes so forward it to Parse()
	return Parse(txt);
}
XMLCh* Mp7JrsDependencyStructurePhraseType_operator_LocalType::ContentToString() const
{
	// Mp7JrsDependencyStructurePhraseType_operator_LocalType has no attributes so forward it to ToText()
	return ToText();
}

void Mp7JrsDependencyStructurePhraseType_operator_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("DependencyStructurePhraseType_operator_LocalType"));
	// Element serialization:
	// Class
	
	if (m_dependencyOperatorType != Mp7JrsdependencyOperatorPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_dependencyOperatorType->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("dependencyOperatorType"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_dependencyOperatorType->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_termReferenceType != Mp7JrstermReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_termReferenceType->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("termReferenceType"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_termReferenceType->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsDependencyStructurePhraseType_operator_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("dependencyOperatorType"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("dependencyOperatorType")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreatedependencyOperatorType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetdependencyOperatorType(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("termReferenceType"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("termReferenceType")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreatetermReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SettermReferenceType(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsDependencyStructurePhraseType_operator_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("dependencyOperatorType")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreatedependencyOperatorType;
    }
    this->SetdependencyOperatorType(child);
  }
  if (XMLString::compareString(elementname, X("termReferenceType")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreatetermReferenceType;
    }
    this->SettermReferenceType(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsDependencyStructurePhraseType_operator_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetdependencyOperatorType() != Mp7JrsNodePtr())
		result.Insert(GetdependencyOperatorType());
	if (GettermReferenceType() != Mp7JrsNodePtr())
		result.Insert(GettermReferenceType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsDependencyStructurePhraseType_operator_LocalType_ExtMethodImpl.h


