 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtImplInclude.h



#include "Mp7Jrsunsigned5.h"
#include "Mp7JrsDominantColorType_Value_Index_LocalType.h"
#include "Mp7JrsDominantColorType_Value_ColorVariance_LocalType.h"
#include "Mp7JrsDominantColorType_Value_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsDominantColorType_Value_LocalType::IMp7JrsDominantColorType_Value_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtPropInit.h

}

IMp7JrsDominantColorType_Value_LocalType::~IMp7JrsDominantColorType_Value_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtPropCleanup.h

}

Mp7JrsDominantColorType_Value_LocalType::Mp7JrsDominantColorType_Value_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsDominantColorType_Value_LocalType::~Mp7JrsDominantColorType_Value_LocalType()
{
	Cleanup();
}

void Mp7JrsDominantColorType_Value_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Percentage = Mp7Jrsunsigned5Ptr(); // Class with content 
	m_Index = Mp7JrsDominantColorType_Value_Index_LocalPtr(); // Class
	m_ColorVariance = Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr(); // Class
	m_ColorVariance_Exist = false;


// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtMyPropInit.h

}

void Mp7JrsDominantColorType_Value_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Percentage);
	// Mp7JrsFactory::DeleteObject(m_Index);
	// Mp7JrsFactory::DeleteObject(m_ColorVariance);
}

void Mp7JrsDominantColorType_Value_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use DominantColorType_Value_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IDominantColorType_Value_LocalType
    const Mp7JrsPtr< Mp7JrsDominantColorType_Value_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Percentage);
		this->SetPercentage(Mp7JrsFactory::CloneObject(tmp->GetPercentage()));
		// Mp7JrsFactory::DeleteObject(m_Index);
		this->SetIndex(Mp7JrsFactory::CloneObject(tmp->GetIndex()));
	if (tmp->IsValidColorVariance())
	{
		// Mp7JrsFactory::DeleteObject(m_ColorVariance);
		this->SetColorVariance(Mp7JrsFactory::CloneObject(tmp->GetColorVariance()));
	}
	else
	{
		InvalidateColorVariance();
	}
}

Mp7JrsNodePtr Mp7JrsDominantColorType_Value_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsDominantColorType_Value_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7Jrsunsigned5Ptr Mp7JrsDominantColorType_Value_LocalType::GetPercentage() const
{
	return m_Percentage;
}

Mp7JrsDominantColorType_Value_Index_LocalPtr Mp7JrsDominantColorType_Value_LocalType::GetIndex() const
{
	return m_Index;
}

Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr Mp7JrsDominantColorType_Value_LocalType::GetColorVariance() const
{
	return m_ColorVariance;
}

// Element is optional
bool Mp7JrsDominantColorType_Value_LocalType::IsValidColorVariance() const
{
	return m_ColorVariance_Exist;
}

void Mp7JrsDominantColorType_Value_LocalType::SetPercentage(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDominantColorType_Value_LocalType::SetPercentage().");
	}
	if (m_Percentage != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Percentage);
		m_Percentage = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Percentage) m_Percentage->SetParent(m_myself.getPointer());
		if (m_Percentage && m_Percentage->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned5"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Percentage->UseTypeAttribute = true;
		}
		if(m_Percentage != Mp7Jrsunsigned5Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Percentage->SetContentName(XMLString::transcode("Percentage"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDominantColorType_Value_LocalType::SetIndex(const Mp7JrsDominantColorType_Value_Index_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDominantColorType_Value_LocalType::SetIndex().");
	}
	if (m_Index != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Index);
		m_Index = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Index) m_Index->SetParent(m_myself.getPointer());
		if (m_Index && m_Index->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DominantColorType_Value_Index_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Index->UseTypeAttribute = true;
		}
		if(m_Index != Mp7JrsDominantColorType_Value_Index_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Index->SetContentName(XMLString::transcode("Index"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDominantColorType_Value_LocalType::SetColorVariance(const Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsDominantColorType_Value_LocalType::SetColorVariance().");
	}
	if (m_ColorVariance != item || m_ColorVariance_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_ColorVariance);
		m_ColorVariance = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_ColorVariance) m_ColorVariance->SetParent(m_myself.getPointer());
		if (m_ColorVariance && m_ColorVariance->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DominantColorType_Value_ColorVariance_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_ColorVariance->UseTypeAttribute = true;
		}
		m_ColorVariance_Exist = true;
		if(m_ColorVariance != Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_ColorVariance->SetContentName(XMLString::transcode("ColorVariance"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsDominantColorType_Value_LocalType::InvalidateColorVariance()
{
	m_ColorVariance_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsDominantColorType_Value_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Percentage")) == 0)
	{
		// Percentage is simple element unsigned5
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPercentage()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned5")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned5Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPercentage(p, client);
					if((p = GetPercentage()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Index")) == 0)
	{
		// Index is simple element DominantColorType_Value_Index_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetIndex()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DominantColorType_Value_Index_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsDominantColorType_Value_Index_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetIndex(p, client);
					if((p = GetIndex()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("ColorVariance")) == 0)
	{
		// ColorVariance is simple element DominantColorType_Value_ColorVariance_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetColorVariance()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:DominantColorType_Value_ColorVariance_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetColorVariance(p, client);
					if((p = GetColorVariance()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for DominantColorType_Value_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "DominantColorType_Value_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsDominantColorType_Value_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsDominantColorType_Value_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsDominantColorType_Value_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("DominantColorType_Value_LocalType"));
	// Element serialization:
	// Class with content		
	
	if (m_Percentage != Mp7Jrsunsigned5Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Percentage->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Percentage"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Percentage->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Index != Mp7JrsDominantColorType_Value_Index_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Index->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Index"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Index->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_ColorVariance != Mp7JrsDominantColorType_Value_ColorVariance_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_ColorVariance->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("ColorVariance"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_ColorVariance->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsDominantColorType_Value_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Percentage"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Percentage")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = Createunsigned5;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPercentage(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Index"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Index")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateDominantColorType_Value_Index_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetIndex(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("ColorVariance"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("ColorVariance")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateDominantColorType_Value_ColorVariance_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetColorVariance(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsDominantColorType_Value_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Percentage")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = Createunsigned5;
    }
    this->SetPercentage(child);
  }
  if (XMLString::compareString(elementname, X("Index")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateDominantColorType_Value_Index_LocalType;
    }
    this->SetIndex(child);
  }
  if (XMLString::compareString(elementname, X("ColorVariance")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateDominantColorType_Value_ColorVariance_LocalType;
    }
    this->SetColorVariance(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsDominantColorType_Value_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetPercentage() != Mp7JrsNodePtr())
		result.Insert(GetPercentage());
	if (GetIndex() != Mp7JrsNodePtr())
		result.Insert(GetIndex());
	if (GetColorVariance() != Mp7JrsNodePtr())
		result.Insert(GetColorVariance());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsDominantColorType_Value_LocalType_ExtMethodImpl.h


