 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtImplInclude.h



#include "Mp7JrscurrencyCode.h"
#include "Mp7JrstimePointType.h"
#include "Mp7JrsTermUseType.h"
#include "Mp7JrsFinancialType_AccountItem_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsFinancialType_AccountItem_LocalType::IMp7JrsFinancialType_AccountItem_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtPropInit.h

}

IMp7JrsFinancialType_AccountItem_LocalType::~IMp7JrsFinancialType_AccountItem_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtPropCleanup.h

}

Mp7JrsFinancialType_AccountItem_LocalType::Mp7JrsFinancialType_AccountItem_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsFinancialType_AccountItem_LocalType::~Mp7JrsFinancialType_AccountItem_LocalType()
{
	Cleanup();
}

void Mp7JrsFinancialType_AccountItem_LocalType::Init()
{

	// Init attributes
	m_currency = Mp7JrscurrencyCodePtr(); // Pattern
	m_value = 0.0; // Value

	// Init elements (element, union sequence choice all any)
	
	m_EffectiveDate = Mp7JrstimePointPtr(); // Pattern
	m_EffectiveDate_Exist = false;
	m_CostType = Mp7JrsTermUsePtr(); // Class
	m_IncomeType = Mp7JrsTermUsePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtMyPropInit.h

}

void Mp7JrsFinancialType_AccountItem_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_currency); 
	// Mp7JrsFactory::DeleteObject(m_EffectiveDate);
	// Mp7JrsFactory::DeleteObject(m_CostType);
	// Mp7JrsFactory::DeleteObject(m_IncomeType);
}

void Mp7JrsFinancialType_AccountItem_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use FinancialType_AccountItem_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IFinancialType_AccountItem_LocalType
    const Mp7JrsPtr< Mp7JrsFinancialType_AccountItem_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_currency); 
		this->Setcurrency(Mp7JrsFactory::CloneObject(tmp->Getcurrency()));
	}
	{
		this->Setvalue(tmp->Getvalue());
	}
	if (tmp->IsValidEffectiveDate())
	{
		// Mp7JrsFactory::DeleteObject(m_EffectiveDate);
		this->SetEffectiveDate(Mp7JrsFactory::CloneObject(tmp->GetEffectiveDate()));
	}
	else
	{
		InvalidateEffectiveDate();
	}
		// Mp7JrsFactory::DeleteObject(m_CostType);
		this->SetCostType(Mp7JrsFactory::CloneObject(tmp->GetCostType()));
		// Mp7JrsFactory::DeleteObject(m_IncomeType);
		this->SetIncomeType(Mp7JrsFactory::CloneObject(tmp->GetIncomeType()));
}

Mp7JrsNodePtr Mp7JrsFinancialType_AccountItem_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsFinancialType_AccountItem_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrscurrencyCodePtr Mp7JrsFinancialType_AccountItem_LocalType::Getcurrency() const
{
	return m_currency;
}

void Mp7JrsFinancialType_AccountItem_LocalType::Setcurrency(const Mp7JrscurrencyCodePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFinancialType_AccountItem_LocalType::Setcurrency().");
	}
    m_currency = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_currency) m_currency->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

double Mp7JrsFinancialType_AccountItem_LocalType::Getvalue() const
{
	return m_value;
}

void Mp7JrsFinancialType_AccountItem_LocalType::Setvalue(double item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFinancialType_AccountItem_LocalType::Setvalue().");
	}
    m_value = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrstimePointPtr Mp7JrsFinancialType_AccountItem_LocalType::GetEffectiveDate() const
{
	return m_EffectiveDate;
}

// Element is optional
bool Mp7JrsFinancialType_AccountItem_LocalType::IsValidEffectiveDate() const
{
	return m_EffectiveDate_Exist;
}

Mp7JrsTermUsePtr Mp7JrsFinancialType_AccountItem_LocalType::GetCostType() const
{
	return m_CostType;
}

Mp7JrsTermUsePtr Mp7JrsFinancialType_AccountItem_LocalType::GetIncomeType() const
{
	return m_IncomeType;
}

void Mp7JrsFinancialType_AccountItem_LocalType::SetEffectiveDate(const Mp7JrstimePointPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFinancialType_AccountItem_LocalType::SetEffectiveDate().");
	}
	if (m_EffectiveDate != item || m_EffectiveDate_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_EffectiveDate);
		m_EffectiveDate = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_EffectiveDate) m_EffectiveDate->SetParent(m_myself.getPointer());
		if (m_EffectiveDate && m_EffectiveDate->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:timePointType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_EffectiveDate->UseTypeAttribute = true;
		}
		m_EffectiveDate_Exist = true;
		if(m_EffectiveDate != Mp7JrstimePointPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_EffectiveDate->SetContentName(XMLString::transcode("EffectiveDate"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsFinancialType_AccountItem_LocalType::InvalidateEffectiveDate()
{
	m_EffectiveDate_Exist = false;
}
	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsFinancialType_AccountItem_LocalType::SetCostType(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFinancialType_AccountItem_LocalType::SetCostType().");
	}
	if (m_CostType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CostType);
		m_CostType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CostType) m_CostType->SetParent(m_myself.getPointer());
		if (m_CostType && m_CostType->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CostType->UseTypeAttribute = true;
		}
		if(m_CostType != Mp7JrsTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CostType->SetContentName(XMLString::transcode("CostType"));
		}
	// Mp7JrsFactory::DeleteObject(m_IncomeType);
	m_IncomeType = Mp7JrsTermUsePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsFinancialType_AccountItem_LocalType::SetIncomeType(const Mp7JrsTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsFinancialType_AccountItem_LocalType::SetIncomeType().");
	}
	if (m_IncomeType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_IncomeType);
		m_IncomeType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_IncomeType) m_IncomeType->SetParent(m_myself.getPointer());
		if (m_IncomeType && m_IncomeType->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_IncomeType->UseTypeAttribute = true;
		}
		if(m_IncomeType != Mp7JrsTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_IncomeType->SetContentName(XMLString::transcode("IncomeType"));
		}
	// Mp7JrsFactory::DeleteObject(m_CostType);
	m_CostType = Mp7JrsTermUsePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsFinancialType_AccountItem_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("EffectiveDate")) == 0)
	{
		// EffectiveDate is simple element timePointType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetEffectiveDate()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:timePointType")))) != empty)
			{
				// Is type allowed
				Mp7JrstimePointPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetEffectiveDate(p, client);
					if((p = GetEffectiveDate()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("CostType")) == 0)
	{
		// CostType is simple element TermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetCostType()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetCostType(p, client);
					if((p = GetCostType()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("IncomeType")) == 0)
	{
		// IncomeType is simple element TermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetIncomeType()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetIncomeType(p, client);
					if((p = GetIncomeType()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for FinancialType_AccountItem_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "FinancialType_AccountItem_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsFinancialType_AccountItem_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsFinancialType_AccountItem_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsFinancialType_AccountItem_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("FinancialType_AccountItem_LocalType"));
    // Attribute Serialization:
	// Pattern
	if (m_currency != Mp7JrscurrencyCodePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_currency->ToText();
		element->setAttributeNS(X(""), X("currency"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_value);
		element->setAttributeNS(X(""), X("value"), tmp);
		XMLString::release(&tmp);
	}
	// Element serialization:
	if(m_EffectiveDate != Mp7JrstimePointPtr()) // Pattern FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Pattern
		// CON contentname already set in element setter -- not needed here
//		XMLCh * contentname = XMLString::transcode("EffectiveDate");
//		m_EffectiveDate->SetContentName(contentname);
		m_EffectiveDate->UseTypeAttribute = this->UseTypeAttribute;
		m_EffectiveDate->Serialize(doc, element);
	}
	// Class
	
	if (m_CostType != Mp7JrsTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CostType->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CostType"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CostType->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_IncomeType != Mp7JrsTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_IncomeType->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("IncomeType"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_IncomeType->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsFinancialType_AccountItem_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("currency")))
	{
        Mp7JrscurrencyCodePtr tmp = CreatecurrencyCode;
        tmp->Parse(parent->getAttributeNS(X(""), X("currency")));
        this->Setcurrency(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("currency")))
	{
        Mp7JrscurrencyCodePtr tmp = CreatecurrencyCode;
        tmp->Parse(parent->getAttribute(X("currency")));
        this->Setcurrency(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("value")))
	{
        // deserialize value type
        this->Setvalue(Mp7JrsConvert::TextToDouble(parent->getAttributeNS(X(""), X("value"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("value")))
	{
        // deserialize value type
        this->Setvalue(Mp7JrsConvert::TextToDouble(parent->getAttribute(X("value"))));
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize pattern element
	if(Mp7JrsUtil::HasNodeName(parent, X("EffectiveDate"), X("urn:mpeg:mpeg7:schema:2004")))
//	        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("EffectiveDate")) == 0))
        {
            Mp7JrstimePointPtr tmp = CreatetimePointType;
            tmp->Deserialize(doc, parent, current);
            this->SetEffectiveDate(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CostType"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CostType")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCostType(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("IncomeType"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("IncomeType")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetIncomeType(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsFinancialType_AccountItem_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("EffectiveDate")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreatetimePointType;
    }
    this->SetEffectiveDate(child);
  }
  if (XMLString::compareString(elementname, X("CostType")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTermUseType;
    }
    this->SetCostType(child);
  }
  if (XMLString::compareString(elementname, X("IncomeType")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateTermUseType;
    }
    this->SetIncomeType(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsFinancialType_AccountItem_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetEffectiveDate() != Mp7JrsNodePtr())
		result.Insert(GetEffectiveDate());
	if (GetCostType() != Mp7JrsNodePtr())
		result.Insert(GetCostType());
	if (GetIncomeType() != Mp7JrsNodePtr())
		result.Insert(GetIncomeType());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsFinancialType_AccountItem_LocalType_ExtMethodImpl.h


