 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtImplInclude.h



#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsHandWritingRecogResultType_Result_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsHandWritingRecogResultType_Result_LocalType::IMp7JrsHandWritingRecogResultType_Result_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtPropInit.h

}

IMp7JrsHandWritingRecogResultType_Result_LocalType::~IMp7JrsHandWritingRecogResultType_Result_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtPropCleanup.h

}

Mp7JrsHandWritingRecogResultType_Result_LocalType::Mp7JrsHandWritingRecogResultType_Result_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsHandWritingRecogResultType_Result_LocalType::~Mp7JrsHandWritingRecogResultType_Result_LocalType()
{
	Cleanup();
}

void Mp7JrsHandWritingRecogResultType_Result_LocalType::Init()
{

	// Init attributes
	m_score = CreatezeroToOneType; // Create a valid class
	m_score->SetContent(0.0); // Use Value initialiser (xxx2)
	m_score_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Text = XMLString::transcode(""); //  Mandatory String
	m_LexiconIndexRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtMyPropInit.h

}

void Mp7JrsHandWritingRecogResultType_Result_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_score);
	XMLString::release(&this->m_Text);
	this->m_Text = NULL;
	// Mp7JrsFactory::DeleteObject(m_LexiconIndexRef);
}

void Mp7JrsHandWritingRecogResultType_Result_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use HandWritingRecogResultType_Result_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IHandWritingRecogResultType_Result_LocalType
    const Mp7JrsPtr< Mp7JrsHandWritingRecogResultType_Result_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_score);
	if (tmp->Existscore())
	{
		this->Setscore(Mp7JrsFactory::CloneObject(tmp->Getscore()));
	}
	else
	{
		Invalidatescore();
	}
	}
		this->SetText(XMLString::replicate(tmp->GetText()));
		// Mp7JrsFactory::DeleteObject(m_LexiconIndexRef);
		this->SetLexiconIndexRef(Mp7JrsFactory::CloneObject(tmp->GetLexiconIndexRef()));
}

Mp7JrsNodePtr Mp7JrsHandWritingRecogResultType_Result_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsHandWritingRecogResultType_Result_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrszeroToOnePtr Mp7JrsHandWritingRecogResultType_Result_LocalType::Getscore() const
{
	return m_score;
}

bool Mp7JrsHandWritingRecogResultType_Result_LocalType::Existscore() const
{
	return m_score_Exist;
}
void Mp7JrsHandWritingRecogResultType_Result_LocalType::Setscore(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHandWritingRecogResultType_Result_LocalType::Setscore().");
	}
    m_score = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_score) m_score->SetParent(m_myself.getPointer());
	m_score_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsHandWritingRecogResultType_Result_LocalType::Invalidatescore()
{
	m_score_Exist = false;
}
XMLCh * Mp7JrsHandWritingRecogResultType_Result_LocalType::GetText() const
{
	return m_Text;
}

Mp7JrsReferencePtr Mp7JrsHandWritingRecogResultType_Result_LocalType::GetLexiconIndexRef() const
{
	return m_LexiconIndexRef;
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsHandWritingRecogResultType_Result_LocalType::SetText(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHandWritingRecogResultType_Result_LocalType::SetText().");
	}
	if (m_Text != item)
	{
		XMLString::release(&m_Text);
		m_Text = item;
	// Mp7JrsFactory::DeleteObject(m_LexiconIndexRef);
	m_LexiconIndexRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsHandWritingRecogResultType_Result_LocalType::SetLexiconIndexRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsHandWritingRecogResultType_Result_LocalType::SetLexiconIndexRef().");
	}
	if (m_LexiconIndexRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_LexiconIndexRef);
		m_LexiconIndexRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_LexiconIndexRef) m_LexiconIndexRef->SetParent(m_myself.getPointer());
		if (m_LexiconIndexRef && m_LexiconIndexRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_LexiconIndexRef->UseTypeAttribute = true;
		}
		if(m_LexiconIndexRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_LexiconIndexRef->SetContentName(XMLString::transcode("LexiconIndexRef"));
		}
	XMLString::release(&this->m_Text);
	m_Text = NULL; // FTT Shouldn't it be XMLString::release()?
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsHandWritingRecogResultType_Result_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("LexiconIndexRef")) == 0)
	{
		// LexiconIndexRef is simple element ReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetLexiconIndexRef()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetLexiconIndexRef(p, client);
					if((p = GetLexiconIndexRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for HandWritingRecogResultType_Result_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "HandWritingRecogResultType_Result_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsHandWritingRecogResultType_Result_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsHandWritingRecogResultType_Result_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsHandWritingRecogResultType_Result_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("HandWritingRecogResultType_Result_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_score_Exist)
	{
	// Class
	if (m_score != Mp7JrszeroToOnePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_score->ToText();
		element->setAttributeNS(X(""), X("score"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	 // String
	if(m_Text != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_Text, X("urn:mpeg:mpeg7:schema:2004"), X("Text"), false);
	// Class
	
	if (m_LexiconIndexRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_LexiconIndexRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("LexiconIndexRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_LexiconIndexRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsHandWritingRecogResultType_Result_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("score")))
	{
        // Deserialize class type
		Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
		tmp->Parse(parent->getAttributeNS(X(""), X("score")));
        this->Setscore(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("score")))
	{
		// Deserialize class type
        Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
        tmp->Parse(parent->getAttribute(X("score")));
        this->Setscore(tmp);
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
	do // Deserialize choice just one time!
    {
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("Text"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetText(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetText(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		continue;       // For choices
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("LexiconIndexRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("LexiconIndexRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetLexiconIndexRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsHandWritingRecogResultType_Result_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("LexiconIndexRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetLexiconIndexRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsHandWritingRecogResultType_Result_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetLexiconIndexRef() != Mp7JrsNodePtr())
		result.Insert(GetLexiconIndexRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsHandWritingRecogResultType_Result_LocalType_ExtMethodImpl.h


