 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtImplInclude.h



#include "Mp7JrsVisualTimeSeriesType.h"
#include "Mp7JrsIrregularVisualTimeSeriesType_CollectionType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsIrregularVisualTimeSeriesType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsIrregularVisualTimeSeriesType_LocalType.h" // Sequence collection Descriptor
#include "Mp7JrsVisualDType.h" // Sequence collection element Descriptor
#include "Mp7Jrsunsigned32.h" // Sequence collection element Interval

#include <assert.h>
IMp7JrsIrregularVisualTimeSeriesType::IMp7JrsIrregularVisualTimeSeriesType()
{

// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtPropInit.h

}

IMp7JrsIrregularVisualTimeSeriesType::~IMp7JrsIrregularVisualTimeSeriesType()
{
// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtPropCleanup.h

}

Mp7JrsIrregularVisualTimeSeriesType::Mp7JrsIrregularVisualTimeSeriesType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsIrregularVisualTimeSeriesType::~Mp7JrsIrregularVisualTimeSeriesType()
{
	Cleanup();
}

void Mp7JrsIrregularVisualTimeSeriesType::Init()
{
	// Init base
	m_Base = CreateVisualTimeSeriesType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_IrregularVisualTimeSeriesType_LocalType = Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtMyPropInit.h

}

void Mp7JrsIrregularVisualTimeSeriesType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_IrregularVisualTimeSeriesType_LocalType);
}

void Mp7JrsIrregularVisualTimeSeriesType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use IrregularVisualTimeSeriesTypePtr, since we
	// might need GetBase(), which isn't defined in IIrregularVisualTimeSeriesType
    const Mp7JrsPtr< Mp7JrsIrregularVisualTimeSeriesType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsVisualTimeSeriesPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsIrregularVisualTimeSeriesType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_IrregularVisualTimeSeriesType_LocalType);
		this->SetIrregularVisualTimeSeriesType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetIrregularVisualTimeSeriesType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsIrregularVisualTimeSeriesType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsIrregularVisualTimeSeriesType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsVisualTimeSeriesType > Mp7JrsIrregularVisualTimeSeriesType::GetBase() const
{
	return m_Base;
}

Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr Mp7JrsIrregularVisualTimeSeriesType::GetIrregularVisualTimeSeriesType_LocalType() const
{
	return m_IrregularVisualTimeSeriesType_LocalType;
}

void Mp7JrsIrregularVisualTimeSeriesType::SetIrregularVisualTimeSeriesType_LocalType(const Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIrregularVisualTimeSeriesType::SetIrregularVisualTimeSeriesType_LocalType().");
	}
	if (m_IrregularVisualTimeSeriesType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_IrregularVisualTimeSeriesType_LocalType);
		m_IrregularVisualTimeSeriesType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_IrregularVisualTimeSeriesType_LocalType) m_IrregularVisualTimeSeriesType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsmediaDurationPtr Mp7JrsIrregularVisualTimeSeriesType::Getoffset() const
{
	return GetBase()->Getoffset();
}

bool Mp7JrsIrregularVisualTimeSeriesType::Existoffset() const
{
	return GetBase()->Existoffset();
}
void Mp7JrsIrregularVisualTimeSeriesType::Setoffset(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIrregularVisualTimeSeriesType::Setoffset().");
	}
	GetBase()->Setoffset(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsIrregularVisualTimeSeriesType::Invalidateoffset()
{
	GetBase()->Invalidateoffset();
}
Mp7JrsmediaDurationPtr Mp7JrsIrregularVisualTimeSeriesType::GetTimeIncr() const
{
	return GetBase()->GetTimeIncr();
}

void Mp7JrsIrregularVisualTimeSeriesType::SetTimeIncr(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsIrregularVisualTimeSeriesType::SetTimeIncr().");
	}
	GetBase()->SetTimeIncr(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsIrregularVisualTimeSeriesType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Descriptor")) == 0)
	{
		// Descriptor is contained in itemtype IrregularVisualTimeSeriesType_LocalType
		// in sequence collection IrregularVisualTimeSeriesType_CollectionType

		context->Found = true;
		Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr coll = GetIrregularVisualTimeSeriesType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateIrregularVisualTimeSeriesType_CollectionType;
				SetIrregularVisualTimeSeriesType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(i))->GetDescriptor()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsIrregularVisualTimeSeriesType_LocalPtr item = CreateIrregularVisualTimeSeriesType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(j))->SetDescriptor(
						((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(j+1))->GetDescriptor());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(j))->SetDescriptor(
						((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(j-1))->GetDescriptor());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsVisualDPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(i))->SetDescriptor(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(i))->GetDescriptor()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Interval")) == 0)
	{
		// Interval is contained in itemtype IrregularVisualTimeSeriesType_LocalType
		// in sequence collection IrregularVisualTimeSeriesType_CollectionType

		context->Found = true;
		Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr coll = GetIrregularVisualTimeSeriesType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateIrregularVisualTimeSeriesType_CollectionType;
				SetIrregularVisualTimeSeriesType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(i))->GetInterval()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				// context->FreeIndexList.addElement(i); // FTT We don't allow to shift elems between different sequence items.
				++i;
			}
		}
		int start, stop;
		if(Mp7JrsXPathParseContext::PostProcessSequenceCollection(context, i, start, stop, result))
		{
			if(i >= 0)
			{
				Mp7JrsIrregularVisualTimeSeriesType_LocalPtr item = CreateIrregularVisualTimeSeriesType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			else // Just reorganise the existing nodes and then we can insert without creating another sequence item.
			{
				int j;
				if(start < stop)
				{
					for(j = start; j < stop; ++j)
					{
						((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(j))->SetInterval(
						((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(j+1))->GetInterval());
					}
				}
				else
				{
					for(j = start; j > stop; --j)
					{
						((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(j))->SetInterval(
						((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(j-1))->GetInterval());
					}
				}
				i = stop;
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:unsigned32")))) != empty)
			{
				// Is type allowed
				Mp7Jrsunsigned32Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(i))->SetInterval(p, client);
					 // Maybe some other restrictions are waiting...
					if((p = ((Mp7JrsIrregularVisualTimeSeriesType_LocalPtr)coll->elementAt(i))->GetInterval()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for IrregularVisualTimeSeriesType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "IrregularVisualTimeSeriesType");
	}		
	
	return result;
}

XMLCh * Mp7JrsIrregularVisualTimeSeriesType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsIrregularVisualTimeSeriesType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsIrregularVisualTimeSeriesType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("IrregularVisualTimeSeriesType"));
	// Element serialization:
	if (m_IrregularVisualTimeSeriesType_LocalType != Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_IrregularVisualTimeSeriesType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsIrregularVisualTimeSeriesType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsVisualTimeSeriesType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Sequence Collection
        if((parent != NULL) && (
            (XMLString::compareString(parent->getNodeName()
            , X("urn:mpeg:mpeg7:schema:2004:Descriptor")) == 0)
                ||
            (XMLString::compareString(parent->getNodeName()
            , X("urn:mpeg:mpeg7:schema:2004:Interval")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr tmp = CreateIrregularVisualTimeSeriesType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetIrregularVisualTimeSeriesType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsIrregularVisualTimeSeriesType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
    // local type, so no need to check explicitly for a name (BAW 05 04 2004)
  {
    Mp7JrsIrregularVisualTimeSeriesType_CollectionPtr tmp = CreateIrregularVisualTimeSeriesType_CollectionType;
    this->SetIrregularVisualTimeSeriesType_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsIrregularVisualTimeSeriesType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetIrregularVisualTimeSeriesType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetIrregularVisualTimeSeriesType_LocalType());
	if (GetTimeIncr() != Mp7JrsNodePtr())
		result.Insert(GetTimeIncr());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsIrregularVisualTimeSeriesType_ExtMethodImpl.h


