 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtImplInclude.h



#include "Mp7JrsControlledTermUseType.h"
#include "Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalType.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Sample_LocalType.h"
#include "Mp7JrsMediaFormatType_AudioCoding_Emphasis_LocalType2.h"
#include "Mp7JrsMediaFormatType_AudioCoding_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMediaFormatType_AudioCoding_LocalType::IMp7JrsMediaFormatType_AudioCoding_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtPropInit.h

}

IMp7JrsMediaFormatType_AudioCoding_LocalType::~IMp7JrsMediaFormatType_AudioCoding_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtPropCleanup.h

}

Mp7JrsMediaFormatType_AudioCoding_LocalType::Mp7JrsMediaFormatType_AudioCoding_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMediaFormatType_AudioCoding_LocalType::~Mp7JrsMediaFormatType_AudioCoding_LocalType()
{
	Cleanup();
}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Format = Mp7JrsControlledTermUsePtr(); // Class
	m_Format_Exist = false;
	m_AudioChannels = Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr(); // Class with content 
	m_AudioChannels_Exist = false;
	m_Sample = Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr(); // Class
	m_Sample_Exist = false;
	m_Emphasis = Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr(); // Class
	m_Emphasis_Exist = false;
	m_Presentation = Mp7JrsControlledTermUsePtr(); // Class
	m_Presentation_Exist = false;


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtMyPropInit.h

}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Format);
	// Mp7JrsFactory::DeleteObject(m_AudioChannels);
	// Mp7JrsFactory::DeleteObject(m_Sample);
	// Mp7JrsFactory::DeleteObject(m_Emphasis);
	// Mp7JrsFactory::DeleteObject(m_Presentation);
}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MediaFormatType_AudioCoding_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMediaFormatType_AudioCoding_LocalType
    const Mp7JrsPtr< Mp7JrsMediaFormatType_AudioCoding_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	if (tmp->IsValidFormat())
	{
		// Mp7JrsFactory::DeleteObject(m_Format);
		this->SetFormat(Mp7JrsFactory::CloneObject(tmp->GetFormat()));
	}
	else
	{
		InvalidateFormat();
	}
	if (tmp->IsValidAudioChannels())
	{
		// Mp7JrsFactory::DeleteObject(m_AudioChannels);
		this->SetAudioChannels(Mp7JrsFactory::CloneObject(tmp->GetAudioChannels()));
	}
	else
	{
		InvalidateAudioChannels();
	}
	if (tmp->IsValidSample())
	{
		// Mp7JrsFactory::DeleteObject(m_Sample);
		this->SetSample(Mp7JrsFactory::CloneObject(tmp->GetSample()));
	}
	else
	{
		InvalidateSample();
	}
	if (tmp->IsValidEmphasis())
	{
		// Mp7JrsFactory::DeleteObject(m_Emphasis);
		this->SetEmphasis(Mp7JrsFactory::CloneObject(tmp->GetEmphasis()));
	}
	else
	{
		InvalidateEmphasis();
	}
	if (tmp->IsValidPresentation())
	{
		// Mp7JrsFactory::DeleteObject(m_Presentation);
		this->SetPresentation(Mp7JrsFactory::CloneObject(tmp->GetPresentation()));
	}
	else
	{
		InvalidatePresentation();
	}
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_AudioCoding_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMediaFormatType_AudioCoding_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsControlledTermUsePtr Mp7JrsMediaFormatType_AudioCoding_LocalType::GetFormat() const
{
	return m_Format;
}

// Element is optional
bool Mp7JrsMediaFormatType_AudioCoding_LocalType::IsValidFormat() const
{
	return m_Format_Exist;
}

Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr Mp7JrsMediaFormatType_AudioCoding_LocalType::GetAudioChannels() const
{
	return m_AudioChannels;
}

// Element is optional
bool Mp7JrsMediaFormatType_AudioCoding_LocalType::IsValidAudioChannels() const
{
	return m_AudioChannels_Exist;
}

Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr Mp7JrsMediaFormatType_AudioCoding_LocalType::GetSample() const
{
	return m_Sample;
}

// Element is optional
bool Mp7JrsMediaFormatType_AudioCoding_LocalType::IsValidSample() const
{
	return m_Sample_Exist;
}

Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr Mp7JrsMediaFormatType_AudioCoding_LocalType::GetEmphasis() const
{
	return m_Emphasis;
}

// Element is optional
bool Mp7JrsMediaFormatType_AudioCoding_LocalType::IsValidEmphasis() const
{
	return m_Emphasis_Exist;
}

Mp7JrsControlledTermUsePtr Mp7JrsMediaFormatType_AudioCoding_LocalType::GetPresentation() const
{
	return m_Presentation;
}

// Element is optional
bool Mp7JrsMediaFormatType_AudioCoding_LocalType::IsValidPresentation() const
{
	return m_Presentation_Exist;
}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::SetFormat(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_AudioCoding_LocalType::SetFormat().");
	}
	if (m_Format != item || m_Format_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Format);
		m_Format = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Format) m_Format->SetParent(m_myself.getPointer());
		if (m_Format && m_Format->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Format->UseTypeAttribute = true;
		}
		m_Format_Exist = true;
		if(m_Format != Mp7JrsControlledTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Format->SetContentName(XMLString::transcode("Format"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::InvalidateFormat()
{
	m_Format_Exist = false;
}
void Mp7JrsMediaFormatType_AudioCoding_LocalType::SetAudioChannels(const Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_AudioCoding_LocalType::SetAudioChannels().");
	}
	if (m_AudioChannels != item || m_AudioChannels_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioChannels);
		m_AudioChannels = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioChannels) m_AudioChannels->SetParent(m_myself.getPointer());
		if (m_AudioChannels && m_AudioChannels->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_AudioCoding_AudioChannels_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AudioChannels->UseTypeAttribute = true;
		}
		m_AudioChannels_Exist = true;
		if(m_AudioChannels != Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioChannels->SetContentName(XMLString::transcode("AudioChannels"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::InvalidateAudioChannels()
{
	m_AudioChannels_Exist = false;
}
void Mp7JrsMediaFormatType_AudioCoding_LocalType::SetSample(const Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_AudioCoding_LocalType::SetSample().");
	}
	if (m_Sample != item || m_Sample_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Sample);
		m_Sample = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Sample) m_Sample->SetParent(m_myself.getPointer());
		if (m_Sample && m_Sample->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_AudioCoding_Sample_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Sample->UseTypeAttribute = true;
		}
		m_Sample_Exist = true;
		if(m_Sample != Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Sample->SetContentName(XMLString::transcode("Sample"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::InvalidateSample()
{
	m_Sample_Exist = false;
}
void Mp7JrsMediaFormatType_AudioCoding_LocalType::SetEmphasis(const Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_AudioCoding_LocalType::SetEmphasis().");
	}
	if (m_Emphasis != item || m_Emphasis_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Emphasis);
		m_Emphasis = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Emphasis) m_Emphasis->SetParent(m_myself.getPointer());
		if (m_Emphasis && m_Emphasis->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_AudioCoding_Emphasis_LocalType2"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Emphasis->UseTypeAttribute = true;
		}
		m_Emphasis_Exist = true;
		if(m_Emphasis != Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Emphasis->SetContentName(XMLString::transcode("Emphasis"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::InvalidateEmphasis()
{
	m_Emphasis_Exist = false;
}
void Mp7JrsMediaFormatType_AudioCoding_LocalType::SetPresentation(const Mp7JrsControlledTermUsePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMediaFormatType_AudioCoding_LocalType::SetPresentation().");
	}
	if (m_Presentation != item || m_Presentation_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Presentation);
		m_Presentation = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Presentation) m_Presentation->SetParent(m_myself.getPointer());
		if (m_Presentation && m_Presentation->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Presentation->UseTypeAttribute = true;
		}
		m_Presentation_Exist = true;
		if(m_Presentation != Mp7JrsControlledTermUsePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Presentation->SetContentName(XMLString::transcode("Presentation"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMediaFormatType_AudioCoding_LocalType::InvalidatePresentation()
{
	m_Presentation_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_AudioCoding_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Format")) == 0)
	{
		// Format is simple element ControlledTermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetFormat()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsControlledTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetFormat(p, client);
					if((p = GetFormat()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("AudioChannels")) == 0)
	{
		// AudioChannels is simple element MediaFormatType_AudioCoding_AudioChannels_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetAudioChannels()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_AudioCoding_AudioChannels_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetAudioChannels(p, client);
					if((p = GetAudioChannels()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Sample")) == 0)
	{
		// Sample is simple element MediaFormatType_AudioCoding_Sample_LocalType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetSample()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_AudioCoding_Sample_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetSample(p, client);
					if((p = GetSample()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Emphasis")) == 0)
	{
		// Emphasis is simple element MediaFormatType_AudioCoding_Emphasis_LocalType2
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetEmphasis()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaFormatType_AudioCoding_Emphasis_LocalType2")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetEmphasis(p, client);
					if((p = GetEmphasis()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Presentation")) == 0)
	{
		// Presentation is simple element ControlledTermUseType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPresentation()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ControlledTermUseType")))) != empty)
			{
				// Is type allowed
				Mp7JrsControlledTermUsePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPresentation(p, client);
					if((p = GetPresentation()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MediaFormatType_AudioCoding_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MediaFormatType_AudioCoding_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsMediaFormatType_AudioCoding_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMediaFormatType_AudioCoding_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMediaFormatType_AudioCoding_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MediaFormatType_AudioCoding_LocalType"));
	// Element serialization:
	// Class
	
	if (m_Format != Mp7JrsControlledTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Format->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Format"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Format->Serialize(doc, element, &elem);
	}
	// Class with content		
	
	if (m_AudioChannels != Mp7JrsMediaFormatType_AudioCoding_AudioChannels_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AudioChannels->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AudioChannels"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AudioChannels->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Sample != Mp7JrsMediaFormatType_AudioCoding_Sample_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Sample->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Sample"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Sample->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Emphasis != Mp7JrsMediaFormatType_AudioCoding_Emphasis_Local2Ptr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Emphasis->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Emphasis"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Emphasis->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Presentation != Mp7JrsControlledTermUsePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Presentation->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Presentation"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Presentation->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMediaFormatType_AudioCoding_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Format"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Format")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateControlledTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetFormat(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AudioChannels"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AudioChannels")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaFormatType_AudioCoding_AudioChannels_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAudioChannels(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Sample"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Sample")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaFormatType_AudioCoding_Sample_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSample(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Emphasis"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Emphasis")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaFormatType_AudioCoding_Emphasis_LocalType2;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetEmphasis(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Presentation"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Presentation")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateControlledTermUseType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPresentation(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMediaFormatType_AudioCoding_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Format")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateControlledTermUseType;
    }
    this->SetFormat(child);
  }
  if (XMLString::compareString(elementname, X("AudioChannels")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaFormatType_AudioCoding_AudioChannels_LocalType;
    }
    this->SetAudioChannels(child);
  }
  if (XMLString::compareString(elementname, X("Sample")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaFormatType_AudioCoding_Sample_LocalType;
    }
    this->SetSample(child);
  }
  if (XMLString::compareString(elementname, X("Emphasis")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaFormatType_AudioCoding_Emphasis_LocalType2;
    }
    this->SetEmphasis(child);
  }
  if (XMLString::compareString(elementname, X("Presentation")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateControlledTermUseType;
    }
    this->SetPresentation(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMediaFormatType_AudioCoding_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetFormat() != Mp7JrsNodePtr())
		result.Insert(GetFormat());
	if (GetAudioChannels() != Mp7JrsNodePtr())
		result.Insert(GetAudioChannels());
	if (GetSample() != Mp7JrsNodePtr())
		result.Insert(GetSample());
	if (GetEmphasis() != Mp7JrsNodePtr())
		result.Insert(GetEmphasis());
	if (GetPresentation() != Mp7JrsNodePtr())
		result.Insert(GetPresentation());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_AudioCoding_LocalType_ExtMethodImpl.h


