 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtImplInclude.h



#include "Mp7JrsCameraMotionSegmentType.h"
#include "Mp7JrsFractionalPresenceType.h"
#include "Mp7JrsMixtureAmountOfMotionType.h"
#include "Mp7JrsMediaTimeType.h"
#include "Mp7JrsFocusOfExpansionType.h"
#include "Mp7JrsMixtureCameraMotionSegmentType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsMixtureCameraMotionSegmentType::IMp7JrsMixtureCameraMotionSegmentType()
{

// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtPropInit.h

}

IMp7JrsMixtureCameraMotionSegmentType::~IMp7JrsMixtureCameraMotionSegmentType()
{
// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtPropCleanup.h

}

Mp7JrsMixtureCameraMotionSegmentType::Mp7JrsMixtureCameraMotionSegmentType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMixtureCameraMotionSegmentType::~Mp7JrsMixtureCameraMotionSegmentType()
{
	Cleanup();
}

void Mp7JrsMixtureCameraMotionSegmentType::Init()
{
	// Init base
	m_Base = CreateCameraMotionSegmentType;
	m_Base->m_myself = m_myself.getPointer();
	


	// Init elements (element, union sequence choice all any)
	
	m_FractionalPresence = Mp7JrsFractionalPresencePtr(); // Class
	m_AmountOfMotion = Mp7JrsMixtureAmountOfMotionPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtMyPropInit.h

}

void Mp7JrsMixtureCameraMotionSegmentType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_FractionalPresence);
	// Mp7JrsFactory::DeleteObject(m_AmountOfMotion);
}

void Mp7JrsMixtureCameraMotionSegmentType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MixtureCameraMotionSegmentTypePtr, since we
	// might need GetBase(), which isn't defined in IMixtureCameraMotionSegmentType
    const Mp7JrsPtr< Mp7JrsMixtureCameraMotionSegmentType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsCameraMotionSegmentPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsMixtureCameraMotionSegmentType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
		// Mp7JrsFactory::DeleteObject(m_FractionalPresence);
		this->SetFractionalPresence(Mp7JrsFactory::CloneObject(tmp->GetFractionalPresence()));
		// Mp7JrsFactory::DeleteObject(m_AmountOfMotion);
		this->SetAmountOfMotion(Mp7JrsFactory::CloneObject(tmp->GetAmountOfMotion()));
}

Mp7JrsNodePtr Mp7JrsMixtureCameraMotionSegmentType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsMixtureCameraMotionSegmentType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsCameraMotionSegmentType > Mp7JrsMixtureCameraMotionSegmentType::GetBase() const
{
	return m_Base;
}

Mp7JrsFractionalPresencePtr Mp7JrsMixtureCameraMotionSegmentType::GetFractionalPresence() const
{
	return m_FractionalPresence;
}

Mp7JrsMixtureAmountOfMotionPtr Mp7JrsMixtureCameraMotionSegmentType::GetAmountOfMotion() const
{
	return m_AmountOfMotion;
}

void Mp7JrsMixtureCameraMotionSegmentType::SetFractionalPresence(const Mp7JrsFractionalPresencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixtureCameraMotionSegmentType::SetFractionalPresence().");
	}
	if (m_FractionalPresence != item)
	{
		// Mp7JrsFactory::DeleteObject(m_FractionalPresence);
		m_FractionalPresence = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_FractionalPresence) m_FractionalPresence->SetParent(m_myself.getPointer());
		if (m_FractionalPresence && m_FractionalPresence->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:FractionalPresenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_FractionalPresence->UseTypeAttribute = true;
		}
		if(m_FractionalPresence != Mp7JrsFractionalPresencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_FractionalPresence->SetContentName(XMLString::transcode("FractionalPresence"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixtureCameraMotionSegmentType::SetAmountOfMotion(const Mp7JrsMixtureAmountOfMotionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixtureCameraMotionSegmentType::SetAmountOfMotion().");
	}
	if (m_AmountOfMotion != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AmountOfMotion);
		m_AmountOfMotion = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AmountOfMotion) m_AmountOfMotion->SetParent(m_myself.getPointer());
		if (m_AmountOfMotion && m_AmountOfMotion->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MixtureAmountOfMotionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_AmountOfMotion->UseTypeAttribute = true;
		}
		if(m_AmountOfMotion != Mp7JrsMixtureAmountOfMotionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AmountOfMotion->SetContentName(XMLString::transcode("AmountOfMotion"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsMediaTimePtr Mp7JrsMixtureCameraMotionSegmentType::GetMediaTime() const
{
	return GetBase()->GetMediaTime();
}

Mp7JrsFocusOfExpansionPtr Mp7JrsMixtureCameraMotionSegmentType::GetFocusOfExpansion() const
{
	return GetBase()->GetFocusOfExpansion();
}

// Element is optional
bool Mp7JrsMixtureCameraMotionSegmentType::IsValidFocusOfExpansion() const
{
	return GetBase()->IsValidFocusOfExpansion();
}

void Mp7JrsMixtureCameraMotionSegmentType::SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixtureCameraMotionSegmentType::SetMediaTime().");
	}
	GetBase()->SetMediaTime(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixtureCameraMotionSegmentType::SetFocusOfExpansion(const Mp7JrsFocusOfExpansionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMixtureCameraMotionSegmentType::SetFocusOfExpansion().");
	}
	GetBase()->SetFocusOfExpansion(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsMixtureCameraMotionSegmentType::InvalidateFocusOfExpansion()
{
	GetBase()->InvalidateFocusOfExpansion();
}

Mp7JrsNodeEnum Mp7JrsMixtureCameraMotionSegmentType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("FractionalPresence")) == 0)
	{
		// FractionalPresence is simple element FractionalPresenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetFractionalPresence()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:FractionalPresenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsFractionalPresencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetFractionalPresence(p, client);
					if((p = GetFractionalPresence()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("AmountOfMotion")) == 0)
	{
		// AmountOfMotion is simple element MixtureAmountOfMotionType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetAmountOfMotion()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MixtureAmountOfMotionType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMixtureAmountOfMotionPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetAmountOfMotion(p, client);
					if((p = GetAmountOfMotion()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for MixtureCameraMotionSegmentType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "MixtureCameraMotionSegmentType");
	}		
	
	return result;
}

XMLCh * Mp7JrsMixtureCameraMotionSegmentType::ToText() const
{
	return m_Base->ToText();
}


bool Mp7JrsMixtureCameraMotionSegmentType::Parse(const XMLCh * const txt)
{
	return m_Base->Parse(txt);
}


void Mp7JrsMixtureCameraMotionSegmentType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("MixtureCameraMotionSegmentType"));
	// Element serialization:
	// Class
	
	if (m_FractionalPresence != Mp7JrsFractionalPresencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_FractionalPresence->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("FractionalPresence"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_FractionalPresence->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_AmountOfMotion != Mp7JrsMixtureAmountOfMotionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_AmountOfMotion->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("AmountOfMotion"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_AmountOfMotion->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMixtureCameraMotionSegmentType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Extensionbase is Mp7JrsCameraMotionSegmentType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("FractionalPresence"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("FractionalPresence")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateFractionalPresenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetFractionalPresence(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("AmountOfMotion"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("AmountOfMotion")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMixtureAmountOfMotionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetAmountOfMotion(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMixtureCameraMotionSegmentType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  if (XMLString::compareString(elementname, X("FractionalPresence")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateFractionalPresenceType;
    }
    this->SetFractionalPresence(child);
  }
  if (XMLString::compareString(elementname, X("AmountOfMotion")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMixtureAmountOfMotionType;
    }
    this->SetAmountOfMotion(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMixtureCameraMotionSegmentType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetFractionalPresence() != Mp7JrsNodePtr())
		result.Insert(GetFractionalPresence());
	if (GetAmountOfMotion() != Mp7JrsNodePtr())
		result.Insert(GetAmountOfMotion());
	if (GetMediaTime() != Mp7JrsNodePtr())
		result.Insert(GetMediaTime());
	if (GetFocusOfExpansion() != Mp7JrsNodePtr())
		result.Insert(GetFocusOfExpansion());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMixtureCameraMotionSegmentType_ExtMethodImpl.h


