 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType_ExtImplInclude.h



#include "Mp7JrsVisualDType.h"
#include "Mp7JrsVisualDSType.h"
#include "Mp7JrsVisualTimeSeriesType.h"
#include "Mp7JrsMovingRegionType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsMovingRegionType_LocalType::IMp7JrsMovingRegionType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType_ExtPropInit.h

}

IMp7JrsMovingRegionType_LocalType::~IMp7JrsMovingRegionType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType_ExtPropCleanup.h

}

Mp7JrsMovingRegionType_LocalType::Mp7JrsMovingRegionType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMovingRegionType_LocalType::~Mp7JrsMovingRegionType_LocalType()
{
	Cleanup();
}

void Mp7JrsMovingRegionType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_VisualDescriptor = Mp7JrsPtr< Mp7JrsNode >(); // Class
	m_VisualDescriptionScheme = Mp7JrsPtr< Mp7JrsNode >(); // Class
	m_VisualTimeSeriesDescriptor = Mp7JrsPtr< Mp7JrsNode >(); // Class


// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType_ExtMyPropInit.h

}

void Mp7JrsMovingRegionType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_VisualDescriptor);
	// Mp7JrsFactory::DeleteObject(m_VisualDescriptionScheme);
	// Mp7JrsFactory::DeleteObject(m_VisualTimeSeriesDescriptor);
}

void Mp7JrsMovingRegionType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MovingRegionType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IMovingRegionType_LocalType
    const Mp7JrsPtr< Mp7JrsMovingRegionType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_VisualDescriptor);
		this->SetVisualDescriptor(Mp7JrsFactory::CloneObject(tmp->GetVisualDescriptor()));
		// Mp7JrsFactory::DeleteObject(m_VisualDescriptionScheme);
		this->SetVisualDescriptionScheme(Mp7JrsFactory::CloneObject(tmp->GetVisualDescriptionScheme()));
		// Mp7JrsFactory::DeleteObject(m_VisualTimeSeriesDescriptor);
		this->SetVisualTimeSeriesDescriptor(Mp7JrsFactory::CloneObject(tmp->GetVisualTimeSeriesDescriptor()));
}

Mp7JrsNodePtr Mp7JrsMovingRegionType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMovingRegionType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsPtr< Mp7JrsNode > Mp7JrsMovingRegionType_LocalType::GetVisualDescriptor() const
{
	return m_VisualDescriptor;
}

Mp7JrsPtr< Mp7JrsNode > Mp7JrsMovingRegionType_LocalType::GetVisualDescriptionScheme() const
{
	return m_VisualDescriptionScheme;
}

Mp7JrsPtr< Mp7JrsNode > Mp7JrsMovingRegionType_LocalType::GetVisualTimeSeriesDescriptor() const
{
	return m_VisualTimeSeriesDescriptor;
}

// implementing setter for choice 
/* element */
void Mp7JrsMovingRegionType_LocalType::SetVisualDescriptor(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionType_LocalType::SetVisualDescriptor().");
	}
	if (m_VisualDescriptor != item)
	{
		// Mp7JrsFactory::DeleteObject(m_VisualDescriptor);
		m_VisualDescriptor = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_VisualDescriptor) m_VisualDescriptor->SetParent(m_myself.getPointer());
		// Element is abstract, so set UseTypeAttribute to true
		if (m_VisualDescriptor) m_VisualDescriptor->UseTypeAttribute = true;
		if(m_VisualDescriptor != Mp7JrsPtr< Mp7JrsNode >()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_VisualDescriptor->SetContentName(XMLString::transcode("VisualDescriptor"));
		}
	// Mp7JrsFactory::DeleteObject(m_VisualDescriptionScheme);
	m_VisualDescriptionScheme = Mp7JrsPtr< Mp7JrsNode >();
	// Mp7JrsFactory::DeleteObject(m_VisualTimeSeriesDescriptor);
	m_VisualTimeSeriesDescriptor = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMovingRegionType_LocalType::SetVisualDescriptionScheme(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionType_LocalType::SetVisualDescriptionScheme().");
	}
	if (m_VisualDescriptionScheme != item)
	{
		// Mp7JrsFactory::DeleteObject(m_VisualDescriptionScheme);
		m_VisualDescriptionScheme = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_VisualDescriptionScheme) m_VisualDescriptionScheme->SetParent(m_myself.getPointer());
		// Element is abstract, so set UseTypeAttribute to true
		if (m_VisualDescriptionScheme) m_VisualDescriptionScheme->UseTypeAttribute = true;
		if(m_VisualDescriptionScheme != Mp7JrsPtr< Mp7JrsNode >()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_VisualDescriptionScheme->SetContentName(XMLString::transcode("VisualDescriptionScheme"));
		}
	// Mp7JrsFactory::DeleteObject(m_VisualDescriptor);
	m_VisualDescriptor = Mp7JrsPtr< Mp7JrsNode >();
	// Mp7JrsFactory::DeleteObject(m_VisualTimeSeriesDescriptor);
	m_VisualTimeSeriesDescriptor = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMovingRegionType_LocalType::SetVisualTimeSeriesDescriptor(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionType_LocalType::SetVisualTimeSeriesDescriptor().");
	}
	if (m_VisualTimeSeriesDescriptor != item)
	{
		// Mp7JrsFactory::DeleteObject(m_VisualTimeSeriesDescriptor);
		m_VisualTimeSeriesDescriptor = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_VisualTimeSeriesDescriptor) m_VisualTimeSeriesDescriptor->SetParent(m_myself.getPointer());
		// Element is abstract, so set UseTypeAttribute to true
		if (m_VisualTimeSeriesDescriptor) m_VisualTimeSeriesDescriptor->UseTypeAttribute = true;
		if(m_VisualTimeSeriesDescriptor != Mp7JrsPtr< Mp7JrsNode >()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_VisualTimeSeriesDescriptor->SetContentName(XMLString::transcode("VisualTimeSeriesDescriptor"));
		}
	// Mp7JrsFactory::DeleteObject(m_VisualDescriptor);
	m_VisualDescriptor = Mp7JrsPtr< Mp7JrsNode >();
	// Mp7JrsFactory::DeleteObject(m_VisualDescriptionScheme);
	m_VisualDescriptionScheme = Mp7JrsPtr< Mp7JrsNode >();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: MovingRegionType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsMovingRegionType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsMovingRegionType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMovingRegionType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMovingRegionType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_VisualDescriptor != Mp7JrsPtr< Mp7JrsNode >())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_VisualDescriptor->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("VisualDescriptor"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
			// Abstract type, so use xsitype
			m_VisualDescriptor->UseTypeAttribute = true;
		}
		m_VisualDescriptor->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_VisualDescriptionScheme != Mp7JrsPtr< Mp7JrsNode >())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_VisualDescriptionScheme->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("VisualDescriptionScheme"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
			// Abstract type, so use xsitype
			m_VisualDescriptionScheme->UseTypeAttribute = true;
		}
		m_VisualDescriptionScheme->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_VisualTimeSeriesDescriptor != Mp7JrsPtr< Mp7JrsNode >())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_VisualTimeSeriesDescriptor->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("VisualTimeSeriesDescriptor"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
			// Abstract type, so use xsitype
			m_VisualTimeSeriesDescriptor->UseTypeAttribute = true;
		}
		m_VisualTimeSeriesDescriptor->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMovingRegionType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("VisualDescriptor"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("VisualDescriptor")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateVisualDType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVisualDescriptor(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("VisualDescriptionScheme"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("VisualDescriptionScheme")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateVisualDSType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVisualDescriptionScheme(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("VisualTimeSeriesDescriptor"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("VisualTimeSeriesDescriptor")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateVisualTimeSeriesType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetVisualTimeSeriesDescriptor(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMovingRegionType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("VisualDescriptor")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateVisualDType;
    }
    this->SetVisualDescriptor(child);
  }
  if (XMLString::compareString(elementname, X("VisualDescriptionScheme")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateVisualDSType;
    }
    this->SetVisualDescriptionScheme(child);
  }
  if (XMLString::compareString(elementname, X("VisualTimeSeriesDescriptor")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateVisualTimeSeriesType;
    }
    this->SetVisualTimeSeriesDescriptor(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMovingRegionType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetVisualDescriptor() != Mp7JrsNodePtr())
		result.Insert(GetVisualDescriptor());
	if (GetVisualDescriptionScheme() != Mp7JrsNodePtr())
		result.Insert(GetVisualDescriptionScheme());
	if (GetVisualTimeSeriesDescriptor() != Mp7JrsNodePtr())
		result.Insert(GetVisualTimeSeriesDescriptor());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType_ExtMethodImpl.h


