 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtImplInclude.h



#include "Mp7JrsMovingRegionSpatialDecompositionType.h"
#include "Mp7JrsMovingRegionTemporalDecompositionType.h"
#include "Mp7JrsMovingRegionSpatioTemporalDecompositionType.h"
#include "Mp7JrsMovingRegionMediaSourceDecompositionType.h"
#include "Mp7JrsMovingRegionType_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsMovingRegionType_LocalType0::IMp7JrsMovingRegionType_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtPropInit.h

}

IMp7JrsMovingRegionType_LocalType0::~IMp7JrsMovingRegionType_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtPropCleanup.h

}

Mp7JrsMovingRegionType_LocalType0::Mp7JrsMovingRegionType_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsMovingRegionType_LocalType0::~Mp7JrsMovingRegionType_LocalType0()
{
	Cleanup();
}

void Mp7JrsMovingRegionType_LocalType0::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_SpatialDecomposition = Mp7JrsMovingRegionSpatialDecompositionPtr(); // Class
	m_TemporalDecomposition = Mp7JrsMovingRegionTemporalDecompositionPtr(); // Class
	m_SpatioTemporalDecomposition = Mp7JrsMovingRegionSpatioTemporalDecompositionPtr(); // Class
	m_MediaSourceDecomposition = Mp7JrsMovingRegionMediaSourceDecompositionPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtMyPropInit.h

}

void Mp7JrsMovingRegionType_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_SpatialDecomposition);
	// Mp7JrsFactory::DeleteObject(m_TemporalDecomposition);
	// Mp7JrsFactory::DeleteObject(m_SpatioTemporalDecomposition);
	// Mp7JrsFactory::DeleteObject(m_MediaSourceDecomposition);
}

void Mp7JrsMovingRegionType_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use MovingRegionType_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in IMovingRegionType_LocalType0
    const Mp7JrsPtr< Mp7JrsMovingRegionType_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_SpatialDecomposition);
		this->SetSpatialDecomposition(Mp7JrsFactory::CloneObject(tmp->GetSpatialDecomposition()));
		// Mp7JrsFactory::DeleteObject(m_TemporalDecomposition);
		this->SetTemporalDecomposition(Mp7JrsFactory::CloneObject(tmp->GetTemporalDecomposition()));
		// Mp7JrsFactory::DeleteObject(m_SpatioTemporalDecomposition);
		this->SetSpatioTemporalDecomposition(Mp7JrsFactory::CloneObject(tmp->GetSpatioTemporalDecomposition()));
		// Mp7JrsFactory::DeleteObject(m_MediaSourceDecomposition);
		this->SetMediaSourceDecomposition(Mp7JrsFactory::CloneObject(tmp->GetMediaSourceDecomposition()));
}

Mp7JrsNodePtr Mp7JrsMovingRegionType_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsMovingRegionType_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsMovingRegionSpatialDecompositionPtr Mp7JrsMovingRegionType_LocalType0::GetSpatialDecomposition() const
{
	return m_SpatialDecomposition;
}

Mp7JrsMovingRegionTemporalDecompositionPtr Mp7JrsMovingRegionType_LocalType0::GetTemporalDecomposition() const
{
	return m_TemporalDecomposition;
}

Mp7JrsMovingRegionSpatioTemporalDecompositionPtr Mp7JrsMovingRegionType_LocalType0::GetSpatioTemporalDecomposition() const
{
	return m_SpatioTemporalDecomposition;
}

Mp7JrsMovingRegionMediaSourceDecompositionPtr Mp7JrsMovingRegionType_LocalType0::GetMediaSourceDecomposition() const
{
	return m_MediaSourceDecomposition;
}

// implementing setter for choice 
/* element */
void Mp7JrsMovingRegionType_LocalType0::SetSpatialDecomposition(const Mp7JrsMovingRegionSpatialDecompositionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionType_LocalType0::SetSpatialDecomposition().");
	}
	if (m_SpatialDecomposition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SpatialDecomposition);
		m_SpatialDecomposition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SpatialDecomposition) m_SpatialDecomposition->SetParent(m_myself.getPointer());
		if (m_SpatialDecomposition && m_SpatialDecomposition->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MovingRegionSpatialDecompositionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SpatialDecomposition->UseTypeAttribute = true;
		}
		if(m_SpatialDecomposition != Mp7JrsMovingRegionSpatialDecompositionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SpatialDecomposition->SetContentName(XMLString::transcode("SpatialDecomposition"));
		}
	// Mp7JrsFactory::DeleteObject(m_TemporalDecomposition);
	m_TemporalDecomposition = Mp7JrsMovingRegionTemporalDecompositionPtr();
	// Mp7JrsFactory::DeleteObject(m_SpatioTemporalDecomposition);
	m_SpatioTemporalDecomposition = Mp7JrsMovingRegionSpatioTemporalDecompositionPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaSourceDecomposition);
	m_MediaSourceDecomposition = Mp7JrsMovingRegionMediaSourceDecompositionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMovingRegionType_LocalType0::SetTemporalDecomposition(const Mp7JrsMovingRegionTemporalDecompositionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionType_LocalType0::SetTemporalDecomposition().");
	}
	if (m_TemporalDecomposition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_TemporalDecomposition);
		m_TemporalDecomposition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_TemporalDecomposition) m_TemporalDecomposition->SetParent(m_myself.getPointer());
		if (m_TemporalDecomposition && m_TemporalDecomposition->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MovingRegionTemporalDecompositionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_TemporalDecomposition->UseTypeAttribute = true;
		}
		if(m_TemporalDecomposition != Mp7JrsMovingRegionTemporalDecompositionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_TemporalDecomposition->SetContentName(XMLString::transcode("TemporalDecomposition"));
		}
	// Mp7JrsFactory::DeleteObject(m_SpatialDecomposition);
	m_SpatialDecomposition = Mp7JrsMovingRegionSpatialDecompositionPtr();
	// Mp7JrsFactory::DeleteObject(m_SpatioTemporalDecomposition);
	m_SpatioTemporalDecomposition = Mp7JrsMovingRegionSpatioTemporalDecompositionPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaSourceDecomposition);
	m_MediaSourceDecomposition = Mp7JrsMovingRegionMediaSourceDecompositionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMovingRegionType_LocalType0::SetSpatioTemporalDecomposition(const Mp7JrsMovingRegionSpatioTemporalDecompositionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionType_LocalType0::SetSpatioTemporalDecomposition().");
	}
	if (m_SpatioTemporalDecomposition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SpatioTemporalDecomposition);
		m_SpatioTemporalDecomposition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SpatioTemporalDecomposition) m_SpatioTemporalDecomposition->SetParent(m_myself.getPointer());
		if (m_SpatioTemporalDecomposition && m_SpatioTemporalDecomposition->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MovingRegionSpatioTemporalDecompositionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SpatioTemporalDecomposition->UseTypeAttribute = true;
		}
		if(m_SpatioTemporalDecomposition != Mp7JrsMovingRegionSpatioTemporalDecompositionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SpatioTemporalDecomposition->SetContentName(XMLString::transcode("SpatioTemporalDecomposition"));
		}
	// Mp7JrsFactory::DeleteObject(m_SpatialDecomposition);
	m_SpatialDecomposition = Mp7JrsMovingRegionSpatialDecompositionPtr();
	// Mp7JrsFactory::DeleteObject(m_TemporalDecomposition);
	m_TemporalDecomposition = Mp7JrsMovingRegionTemporalDecompositionPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaSourceDecomposition);
	m_MediaSourceDecomposition = Mp7JrsMovingRegionMediaSourceDecompositionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsMovingRegionType_LocalType0::SetMediaSourceDecomposition(const Mp7JrsMovingRegionMediaSourceDecompositionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsMovingRegionType_LocalType0::SetMediaSourceDecomposition().");
	}
	if (m_MediaSourceDecomposition != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaSourceDecomposition);
		m_MediaSourceDecomposition = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaSourceDecomposition) m_MediaSourceDecomposition->SetParent(m_myself.getPointer());
		if (m_MediaSourceDecomposition && m_MediaSourceDecomposition->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MovingRegionMediaSourceDecompositionType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaSourceDecomposition->UseTypeAttribute = true;
		}
		if(m_MediaSourceDecomposition != Mp7JrsMovingRegionMediaSourceDecompositionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaSourceDecomposition->SetContentName(XMLString::transcode("MediaSourceDecomposition"));
		}
	// Mp7JrsFactory::DeleteObject(m_SpatialDecomposition);
	m_SpatialDecomposition = Mp7JrsMovingRegionSpatialDecompositionPtr();
	// Mp7JrsFactory::DeleteObject(m_TemporalDecomposition);
	m_TemporalDecomposition = Mp7JrsMovingRegionTemporalDecompositionPtr();
	// Mp7JrsFactory::DeleteObject(m_SpatioTemporalDecomposition);
	m_SpatioTemporalDecomposition = Mp7JrsMovingRegionSpatioTemporalDecompositionPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: MovingRegionType_LocalType0: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsMovingRegionType_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsMovingRegionType_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsMovingRegionType_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsMovingRegionType_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_SpatialDecomposition != Mp7JrsMovingRegionSpatialDecompositionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SpatialDecomposition->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SpatialDecomposition"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SpatialDecomposition->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_TemporalDecomposition != Mp7JrsMovingRegionTemporalDecompositionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_TemporalDecomposition->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("TemporalDecomposition"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_TemporalDecomposition->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_SpatioTemporalDecomposition != Mp7JrsMovingRegionSpatioTemporalDecompositionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SpatioTemporalDecomposition->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SpatioTemporalDecomposition"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SpatioTemporalDecomposition->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MediaSourceDecomposition != Mp7JrsMovingRegionMediaSourceDecompositionPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MediaSourceDecomposition->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MediaSourceDecomposition"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MediaSourceDecomposition->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsMovingRegionType_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SpatialDecomposition"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SpatialDecomposition")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMovingRegionSpatialDecompositionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSpatialDecomposition(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("TemporalDecomposition"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("TemporalDecomposition")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMovingRegionTemporalDecompositionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetTemporalDecomposition(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SpatioTemporalDecomposition"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SpatioTemporalDecomposition")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMovingRegionSpatioTemporalDecompositionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSpatioTemporalDecomposition(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaSourceDecomposition"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaSourceDecomposition")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMovingRegionMediaSourceDecompositionType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMediaSourceDecomposition(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsMovingRegionType_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("SpatialDecomposition")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMovingRegionSpatialDecompositionType;
    }
    this->SetSpatialDecomposition(child);
  }
  if (XMLString::compareString(elementname, X("TemporalDecomposition")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMovingRegionTemporalDecompositionType;
    }
    this->SetTemporalDecomposition(child);
  }
  if (XMLString::compareString(elementname, X("SpatioTemporalDecomposition")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMovingRegionSpatioTemporalDecompositionType;
    }
    this->SetSpatioTemporalDecomposition(child);
  }
  if (XMLString::compareString(elementname, X("MediaSourceDecomposition")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMovingRegionMediaSourceDecompositionType;
    }
    this->SetMediaSourceDecomposition(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsMovingRegionType_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSpatialDecomposition() != Mp7JrsNodePtr())
		result.Insert(GetSpatialDecomposition());
	if (GetTemporalDecomposition() != Mp7JrsNodePtr())
		result.Insert(GetTemporalDecomposition());
	if (GetSpatioTemporalDecomposition() != Mp7JrsNodePtr())
		result.Insert(GetSpatioTemporalDecomposition());
	if (GetMediaSourceDecomposition() != Mp7JrsNodePtr())
		result.Insert(GetMediaSourceDecomposition());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsMovingRegionType_LocalType0_ExtMethodImpl.h


