 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtImplInclude.h



#include "Mp7JrsOrganizationType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsPersonGroupType.h"
#include "Mp7JrsPersonType_Affiliation_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsPersonType_Affiliation_LocalType::IMp7JrsPersonType_Affiliation_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtPropInit.h

}

IMp7JrsPersonType_Affiliation_LocalType::~IMp7JrsPersonType_Affiliation_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtPropCleanup.h

}

Mp7JrsPersonType_Affiliation_LocalType::Mp7JrsPersonType_Affiliation_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsPersonType_Affiliation_LocalType::~Mp7JrsPersonType_Affiliation_LocalType()
{
	Cleanup();
}

void Mp7JrsPersonType_Affiliation_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Organization = Mp7JrsOrganizationPtr(); // Class
	m_OrganizationRef = Mp7JrsReferencePtr(); // Class
	m_PersonGroup = Mp7JrsPersonGroupPtr(); // Class
	m_PersonGroupRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtMyPropInit.h

}

void Mp7JrsPersonType_Affiliation_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Organization);
	// Mp7JrsFactory::DeleteObject(m_OrganizationRef);
	// Mp7JrsFactory::DeleteObject(m_PersonGroup);
	// Mp7JrsFactory::DeleteObject(m_PersonGroupRef);
}

void Mp7JrsPersonType_Affiliation_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use PersonType_Affiliation_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IPersonType_Affiliation_LocalType
    const Mp7JrsPtr< Mp7JrsPersonType_Affiliation_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Organization);
		this->SetOrganization(Mp7JrsFactory::CloneObject(tmp->GetOrganization()));
		// Mp7JrsFactory::DeleteObject(m_OrganizationRef);
		this->SetOrganizationRef(Mp7JrsFactory::CloneObject(tmp->GetOrganizationRef()));
		// Mp7JrsFactory::DeleteObject(m_PersonGroup);
		this->SetPersonGroup(Mp7JrsFactory::CloneObject(tmp->GetPersonGroup()));
		// Mp7JrsFactory::DeleteObject(m_PersonGroupRef);
		this->SetPersonGroupRef(Mp7JrsFactory::CloneObject(tmp->GetPersonGroupRef()));
}

Mp7JrsNodePtr Mp7JrsPersonType_Affiliation_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsPersonType_Affiliation_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsOrganizationPtr Mp7JrsPersonType_Affiliation_LocalType::GetOrganization() const
{
	return m_Organization;
}

Mp7JrsReferencePtr Mp7JrsPersonType_Affiliation_LocalType::GetOrganizationRef() const
{
	return m_OrganizationRef;
}

Mp7JrsPersonGroupPtr Mp7JrsPersonType_Affiliation_LocalType::GetPersonGroup() const
{
	return m_PersonGroup;
}

Mp7JrsReferencePtr Mp7JrsPersonType_Affiliation_LocalType::GetPersonGroupRef() const
{
	return m_PersonGroupRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsPersonType_Affiliation_LocalType::SetOrganization(const Mp7JrsOrganizationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonType_Affiliation_LocalType::SetOrganization().");
	}
	if (m_Organization != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Organization);
		m_Organization = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Organization) m_Organization->SetParent(m_myself.getPointer());
		if (m_Organization && m_Organization->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:OrganizationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Organization->UseTypeAttribute = true;
		}
		if(m_Organization != Mp7JrsOrganizationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Organization->SetContentName(XMLString::transcode("Organization"));
		}
	// Mp7JrsFactory::DeleteObject(m_OrganizationRef);
	m_OrganizationRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_PersonGroup);
	m_PersonGroup = Mp7JrsPersonGroupPtr();
	// Mp7JrsFactory::DeleteObject(m_PersonGroupRef);
	m_PersonGroupRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsPersonType_Affiliation_LocalType::SetOrganizationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonType_Affiliation_LocalType::SetOrganizationRef().");
	}
	if (m_OrganizationRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_OrganizationRef);
		m_OrganizationRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_OrganizationRef) m_OrganizationRef->SetParent(m_myself.getPointer());
		if (m_OrganizationRef && m_OrganizationRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_OrganizationRef->UseTypeAttribute = true;
		}
		if(m_OrganizationRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_OrganizationRef->SetContentName(XMLString::transcode("OrganizationRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_Organization);
	m_Organization = Mp7JrsOrganizationPtr();
	// Mp7JrsFactory::DeleteObject(m_PersonGroup);
	m_PersonGroup = Mp7JrsPersonGroupPtr();
	// Mp7JrsFactory::DeleteObject(m_PersonGroupRef);
	m_PersonGroupRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsPersonType_Affiliation_LocalType::SetPersonGroup(const Mp7JrsPersonGroupPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonType_Affiliation_LocalType::SetPersonGroup().");
	}
	if (m_PersonGroup != item)
	{
		// Mp7JrsFactory::DeleteObject(m_PersonGroup);
		m_PersonGroup = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PersonGroup) m_PersonGroup->SetParent(m_myself.getPointer());
		if (m_PersonGroup && m_PersonGroup->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PersonGroupType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_PersonGroup->UseTypeAttribute = true;
		}
		if(m_PersonGroup != Mp7JrsPersonGroupPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PersonGroup->SetContentName(XMLString::transcode("PersonGroup"));
		}
	// Mp7JrsFactory::DeleteObject(m_Organization);
	m_Organization = Mp7JrsOrganizationPtr();
	// Mp7JrsFactory::DeleteObject(m_OrganizationRef);
	m_OrganizationRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_PersonGroupRef);
	m_PersonGroupRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsPersonType_Affiliation_LocalType::SetPersonGroupRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsPersonType_Affiliation_LocalType::SetPersonGroupRef().");
	}
	if (m_PersonGroupRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_PersonGroupRef);
		m_PersonGroupRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_PersonGroupRef) m_PersonGroupRef->SetParent(m_myself.getPointer());
		if (m_PersonGroupRef && m_PersonGroupRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_PersonGroupRef->UseTypeAttribute = true;
		}
		if(m_PersonGroupRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_PersonGroupRef->SetContentName(XMLString::transcode("PersonGroupRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_Organization);
	m_Organization = Mp7JrsOrganizationPtr();
	// Mp7JrsFactory::DeleteObject(m_OrganizationRef);
	m_OrganizationRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_PersonGroup);
	m_PersonGroup = Mp7JrsPersonGroupPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsPersonType_Affiliation_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Organization")) == 0)
	{
		// Organization is simple element OrganizationType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetOrganization()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:OrganizationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsOrganizationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetOrganization(p, client);
					if((p = GetOrganization()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("OrganizationRef")) == 0)
	{
		// OrganizationRef is simple element ReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetOrganizationRef()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetOrganizationRef(p, client);
					if((p = GetOrganizationRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PersonGroup")) == 0)
	{
		// PersonGroup is simple element PersonGroupType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPersonGroup()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:PersonGroupType")))) != empty)
			{
				// Is type allowed
				Mp7JrsPersonGroupPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPersonGroup(p, client);
					if((p = GetPersonGroup()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("PersonGroupRef")) == 0)
	{
		// PersonGroupRef is simple element ReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetPersonGroupRef()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetPersonGroupRef(p, client);
					if((p = GetPersonGroupRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for PersonType_Affiliation_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "PersonType_Affiliation_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsPersonType_Affiliation_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsPersonType_Affiliation_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsPersonType_Affiliation_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("PersonType_Affiliation_LocalType"));
	// Element serialization:
	// Class
	
	if (m_Organization != Mp7JrsOrganizationPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Organization->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Organization"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Organization->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_OrganizationRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_OrganizationRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("OrganizationRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_OrganizationRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_PersonGroup != Mp7JrsPersonGroupPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_PersonGroup->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("PersonGroup"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_PersonGroup->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_PersonGroupRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_PersonGroupRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("PersonGroupRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_PersonGroupRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsPersonType_Affiliation_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Organization"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Organization")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateOrganizationType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetOrganization(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("OrganizationRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("OrganizationRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetOrganizationRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("PersonGroup"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("PersonGroup")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreatePersonGroupType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPersonGroup(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("PersonGroupRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("PersonGroupRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPersonGroupRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsPersonType_Affiliation_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Organization")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateOrganizationType;
    }
    this->SetOrganization(child);
  }
  if (XMLString::compareString(elementname, X("OrganizationRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetOrganizationRef(child);
  }
  if (XMLString::compareString(elementname, X("PersonGroup")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreatePersonGroupType;
    }
    this->SetPersonGroup(child);
  }
  if (XMLString::compareString(elementname, X("PersonGroupRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetPersonGroupRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsPersonType_Affiliation_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetOrganization() != Mp7JrsNodePtr())
		result.Insert(GetOrganization());
	if (GetOrganizationRef() != Mp7JrsNodePtr())
		result.Insert(GetOrganizationRef());
	if (GetPersonGroup() != Mp7JrsNodePtr())
		result.Insert(GetPersonGroup());
	if (GetPersonGroupRef() != Mp7JrsNodePtr())
		result.Insert(GetPersonGroupRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsPersonType_Affiliation_LocalType_ExtMethodImpl.h


