 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Box_LocalType_ExtImplInclude.h



#include "Mp7JrsBoxListType.h"
#include "Mp7Jrsdim_LocalType.h"
#include "Mp7JrsRegionLocatorType_Box_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsRegionLocatorType_Box_LocalType::IMp7JrsRegionLocatorType_Box_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Box_LocalType_ExtPropInit.h

}

IMp7JrsRegionLocatorType_Box_LocalType::~IMp7JrsRegionLocatorType_Box_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Box_LocalType_ExtPropCleanup.h

}

Mp7JrsRegionLocatorType_Box_LocalType::Mp7JrsRegionLocatorType_Box_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsRegionLocatorType_Box_LocalType::~Mp7JrsRegionLocatorType_Box_LocalType()
{
	Cleanup();
}

void Mp7JrsRegionLocatorType_Box_LocalType::Init()
{
	// Init base
	m_Base = CreateBoxListType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_unlocatedRegion = false; // Value
	m_unlocatedRegion_Default = false;
	m_unlocatedRegion_Exist = false;



// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Box_LocalType_ExtMyPropInit.h

}

void Mp7JrsRegionLocatorType_Box_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Box_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
}

void Mp7JrsRegionLocatorType_Box_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use RegionLocatorType_Box_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IRegionLocatorType_Box_LocalType
    const Mp7JrsPtr< Mp7JrsRegionLocatorType_Box_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsBoxListPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsRegionLocatorType_Box_LocalType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	if (tmp->ExistunlocatedRegion())
	{
		this->SetunlocatedRegion(tmp->GetunlocatedRegion());
	}
	else
	{
		InvalidateunlocatedRegion();
	}
	}
}

Mp7JrsNodePtr Mp7JrsRegionLocatorType_Box_LocalType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsRegionLocatorType_Box_LocalType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsBoxListType > Mp7JrsRegionLocatorType_Box_LocalType::GetBase() const
{
	return m_Base;
}

Mp7JrsPtr< Mp7JrsintegerVector > Mp7JrsRegionLocatorType_Box_LocalType::GetBaseCollection() const
{
	return GetBase()->GetBase()->GetBase();
}

void Mp7JrsRegionLocatorType_Box_LocalType::Initialize(unsigned int maxElems)
{
	GetBase()->GetBase()->GetBase()->Initialize(maxElems);
}

void Mp7JrsRegionLocatorType_Box_LocalType::addElement(const int &toAdd, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Box_LocalType::addElement().");
	}
	GetBase()->GetBase()->GetBase()->addElement(toAdd);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsRegionLocatorType_Box_LocalType::setElementAt(const int &toSet, unsigned int setAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Box_LocalType::setElementAt().");
	}
	GetBase()->GetBase()->GetBase()->setElementAt(toSet, setAt);
	Mp7JrsClientManager::SendUpdateNotification(
	m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
	client, m_myself.getPointer());
}

void Mp7JrsRegionLocatorType_Box_LocalType::insertElementAt(const int &toInsert, unsigned int insertAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Box_LocalType::insertElementAt().");
	}
	GetBase()->GetBase()->GetBase()->insertElementAt(toInsert, insertAt);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsRegionLocatorType_Box_LocalType::removeAllElements(Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Box_LocalType::removeAllElements().");
	}
	GetBase()->GetBase()->GetBase()->removeAllElements();
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsRegionLocatorType_Box_LocalType::removeElementAt(unsigned int removeAt, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Box_LocalType::removeElementAt().");
	}
	GetBase()->GetBase()->GetBase()->removeElementAt(removeAt);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

bool Mp7JrsRegionLocatorType_Box_LocalType::containsElement(const int &toCheck)
{
	return GetBase()->GetBase()->GetBase()->containsElement(toCheck);
}

unsigned int Mp7JrsRegionLocatorType_Box_LocalType::curCapacity() const
{
	return GetBase()->GetBase()->GetBase()->curCapacity();
}

const int Mp7JrsRegionLocatorType_Box_LocalType::elementAt(unsigned int getAt) const
{
	return GetBase()->GetBase()->GetBase()->elementAt(getAt);
}

int Mp7JrsRegionLocatorType_Box_LocalType::elementAt(unsigned int getAt)
{
	return GetBase()->GetBase()->GetBase()->elementAt(getAt);
}


unsigned int Mp7JrsRegionLocatorType_Box_LocalType::size() const
{
	return GetBase()->GetBase()->GetBase()->size();
}

void Mp7JrsRegionLocatorType_Box_LocalType::ensureExtraCapacity(unsigned int length)
{
	GetBase()->GetBase()->GetBase()->ensureExtraCapacity(length);
}

int Mp7JrsRegionLocatorType_Box_LocalType::elementIndexOf(const int &toCheck) const
{
	return GetBase()->GetBase()->GetBase()->elementIndexOf(toCheck);
}

bool Mp7JrsRegionLocatorType_Box_LocalType::GetunlocatedRegion() const
{
	if (this->ExistunlocatedRegion()) {
		return m_unlocatedRegion;
	} else {
		return m_unlocatedRegion_Default;
	}
}

bool Mp7JrsRegionLocatorType_Box_LocalType::ExistunlocatedRegion() const
{
	return m_unlocatedRegion_Exist;
}
void Mp7JrsRegionLocatorType_Box_LocalType::SetunlocatedRegion(bool item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Box_LocalType::SetunlocatedRegion().");
	}
    m_unlocatedRegion = item;
	m_unlocatedRegion_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsRegionLocatorType_Box_LocalType::InvalidateunlocatedRegion()
{
	m_unlocatedRegion_Exist = false;
}
Mp7Jrsdim_LocalPtr Mp7JrsRegionLocatorType_Box_LocalType::Getdim() const
{
	return GetBase()->GetBase()->Getdim();
}

void Mp7JrsRegionLocatorType_Box_LocalType::Setdim(const Mp7Jrsdim_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsRegionLocatorType_Box_LocalType::Setdim().");
	}
	GetBase()->GetBase()->Setdim(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsRegionLocatorType_Box_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for RegionLocatorType_Box_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "RegionLocatorType_Box_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsRegionLocatorType_Box_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsRegionLocatorType_Box_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsRegionLocatorType_Box_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	if(m_Base)
	{
		return m_Base->ContentFromString(txt);
	}
	return false;
}
XMLCh* Mp7JrsRegionLocatorType_Box_LocalType::ContentToString() const
{
	if(m_Base)
	{
		return m_Base->ContentToString();
	}
	return (XMLCh*)NULL;
}

void Mp7JrsRegionLocatorType_Box_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Box_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("RegionLocatorType_Box_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_unlocatedRegion_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_unlocatedRegion);
		element->setAttributeNS(X(""), X("unlocatedRegion"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsRegionLocatorType_Box_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("unlocatedRegion")))
	{
        // deserialize value type
        this->SetunlocatedRegion(Mp7JrsConvert::TextToBool(parent->getAttributeNS(X(""), X("unlocatedRegion"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("unlocatedRegion")))
	{
        // deserialize value type
        this->SetunlocatedRegion(Mp7JrsConvert::TextToBool(parent->getAttribute(X("unlocatedRegion"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsBoxListType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Box_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsRegionLocatorType_Box_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsRegionLocatorType_Box_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsRegionLocatorType_Box_LocalType_ExtMethodImpl.h


