 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_LocalType_ExtImplInclude.h



#include "Mp7JrsSceneGraphMaskType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSceneGraphMaskType_LocalType::IMp7JrsSceneGraphMaskType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_LocalType_ExtPropInit.h

}

IMp7JrsSceneGraphMaskType_LocalType::~IMp7JrsSceneGraphMaskType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_LocalType_ExtPropCleanup.h

}

Mp7JrsSceneGraphMaskType_LocalType::Mp7JrsSceneGraphMaskType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSceneGraphMaskType_LocalType::~Mp7JrsSceneGraphMaskType_LocalType()
{
	Cleanup();
}

void Mp7JrsSceneGraphMaskType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_SubGraph = XMLString::transcode(""); //  Mandatory String
	m_SubGraphNum = (0); // Value



// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_LocalType_ExtMyPropInit.h

}

void Mp7JrsSceneGraphMaskType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_LocalType_ExtMyPropCleanup.h


	XMLString::release(&this->m_SubGraph);
	this->m_SubGraph = NULL;
}

void Mp7JrsSceneGraphMaskType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SceneGraphMaskType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISceneGraphMaskType_LocalType
    const Mp7JrsPtr< Mp7JrsSceneGraphMaskType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		this->SetSubGraph(XMLString::replicate(tmp->GetSubGraph()));
		this->SetSubGraphNum(tmp->GetSubGraphNum());
}

Mp7JrsNodePtr Mp7JrsSceneGraphMaskType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSceneGraphMaskType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsSceneGraphMaskType_LocalType::GetSubGraph() const
{
	return m_SubGraph;
}

unsigned Mp7JrsSceneGraphMaskType_LocalType::GetSubGraphNum() const
{
	return m_SubGraphNum;
}

// implementing setter for choice 
/* element */
void Mp7JrsSceneGraphMaskType_LocalType::SetSubGraph(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSceneGraphMaskType_LocalType::SetSubGraph().");
	}
	if (m_SubGraph != item)
	{
		XMLString::release(&m_SubGraph);
		m_SubGraph = item;
	
	m_SubGraphNum_Valid = false;
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSceneGraphMaskType_LocalType::SetSubGraphNum(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSceneGraphMaskType_LocalType::SetSubGraphNum().");
	}
	if (m_SubGraphNum != item)
	{
		m_SubGraphNum = item;
		m_SubGraphNum_Valid = true;
	XMLString::release(&this->m_SubGraph);
	m_SubGraph = NULL; // FTT Shouldn't it be XMLString::release()?
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: SceneGraphMaskType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSceneGraphMaskType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSceneGraphMaskType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSceneGraphMaskType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSceneGraphMaskType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	 // String
	if(m_SubGraph != (XMLCh*)NULL) Mp7JrsUtil::SerializeTextNode(element, doc, m_SubGraph, X("urn:mpeg:mpeg7:schema:2004"), X("SubGraph"), false);
	if(m_SubGraphNum_Valid) // Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_SubGraphNum);
		Mp7JrsUtil::SerializeTextNode(element, doc, tmp, X("urn:mpeg:mpeg7:schema:2004"), X("SubGraphNum"), false);
		XMLString::release(&tmp);
		
	}

}

bool Mp7JrsSceneGraphMaskType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
	// Deserialize string (XMLCh*) element
	if(Mp7JrsUtil::HasNodeName(parent, X("SubGraph"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		// FTT memleaking		this->SetSubGraph(Mp7JrsConvert::TextToString(Mp7JrsUtil::GetElementText(parent)));
		this->SetSubGraph(Mp7JrsUtil::GetElementText(parent));
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		continue;       // For choices
	}
	// Deserialize value element
	if(Mp7JrsUtil::HasNodeName(parent, X("SubGraphNum"), X("urn:mpeg:mpeg7:schema:2004")))
	{
		XMLCh * tmp = Mp7JrsUtil::GetElementText(parent);
		this->SetSubGraphNum(Mp7JrsConvert::TextToUnsignedInt(tmp));
		XMLString::release(&tmp);
		found = true;
		* current = parent;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
		continue;       // For choices
	}
	} while(false);
// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSceneGraphMaskType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSceneGraphMaskType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSceneGraphMaskType_LocalType_ExtMethodImpl.h


