 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSemanticBaseType_MediaOccurrence_LocalType_ExtImplInclude.h



#include "Mp7JrsSemanticBaseType_MediaOccurrence_type_LocalType2.h"
#include "Mp7JrsMediaInformationType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsMediaLocatorType.h"
#include "Mp7JrsMaskType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType.h"
#include "Mp7JrsSemanticBaseType_MediaOccurrence_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsAudioDType.h" // Element collection urn:mpeg:mpeg7:schema:2004:AudioDescriptor
#include "Mp7JrsAudioDSType.h" // Element collection urn:mpeg:mpeg7:schema:2004:AudioDescriptionScheme
#include "Mp7JrsVisualDType.h" // Element collection urn:mpeg:mpeg7:schema:2004:VisualDescriptor
#include "Mp7JrsVisualDSType.h" // Element collection urn:mpeg:mpeg7:schema:2004:VisualDescriptionScheme

#include <assert.h>
IMp7JrsSemanticBaseType_MediaOccurrence_LocalType::IMp7JrsSemanticBaseType_MediaOccurrence_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSemanticBaseType_MediaOccurrence_LocalType_ExtPropInit.h

}

IMp7JrsSemanticBaseType_MediaOccurrence_LocalType::~IMp7JrsSemanticBaseType_MediaOccurrence_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSemanticBaseType_MediaOccurrence_LocalType_ExtPropCleanup.h

}

Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Mp7JrsSemanticBaseType_MediaOccurrence_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::~Mp7JrsSemanticBaseType_MediaOccurrence_LocalType()
{
	Cleanup();
}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Init()
{

	// Init attributes
	m_type = Mp7JrsSemanticBaseType_MediaOccurrence_type_Local2Ptr(); // Create emtpy class ptr
	m_type_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_MediaInformation = Mp7JrsMediaInformationPtr(); // Class
	m_MediaInformationRef = Mp7JrsReferencePtr(); // Class
	m_MediaLocator = Mp7JrsMediaLocatorPtr(); // Class
	m_Mask = Mp7JrsPtr< Mp7JrsNode >(); // Class
	m_Mask_Exist = false;
	m_AudioDescriptor = Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr(); // Collection
	m_AudioDescriptionScheme = Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr(); // Collection
	m_VisualDescriptor = Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr(); // Collection
	m_VisualDescriptionScheme = Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSemanticBaseType_MediaOccurrence_LocalType_ExtMyPropInit.h

}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSemanticBaseType_MediaOccurrence_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_type);
	// Mp7JrsFactory::DeleteObject(m_MediaInformation);
	// Mp7JrsFactory::DeleteObject(m_MediaInformationRef);
	// Mp7JrsFactory::DeleteObject(m_MediaLocator);
	// Mp7JrsFactory::DeleteObject(m_Mask);
	// Mp7JrsFactory::DeleteObject(m_AudioDescriptor);
	// Mp7JrsFactory::DeleteObject(m_AudioDescriptionScheme);
	// Mp7JrsFactory::DeleteObject(m_VisualDescriptor);
	// Mp7JrsFactory::DeleteObject(m_VisualDescriptionScheme);
}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SemanticBaseType_MediaOccurrence_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISemanticBaseType_MediaOccurrence_LocalType
    const Mp7JrsPtr< Mp7JrsSemanticBaseType_MediaOccurrence_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	// Mp7JrsFactory::DeleteObject(m_type);
	if (tmp->Existtype())
	{
		this->Settype(Mp7JrsFactory::CloneObject(tmp->Gettype()));
	}
	else
	{
		Invalidatetype();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_MediaInformation);
		this->SetMediaInformation(Mp7JrsFactory::CloneObject(tmp->GetMediaInformation()));
		// Mp7JrsFactory::DeleteObject(m_MediaInformationRef);
		this->SetMediaInformationRef(Mp7JrsFactory::CloneObject(tmp->GetMediaInformationRef()));
		// Mp7JrsFactory::DeleteObject(m_MediaLocator);
		this->SetMediaLocator(Mp7JrsFactory::CloneObject(tmp->GetMediaLocator()));
	if (tmp->IsValidMask())
	{
		// Mp7JrsFactory::DeleteObject(m_Mask);
		this->SetMask(Mp7JrsFactory::CloneObject(tmp->GetMask()));
	}
	else
	{
		InvalidateMask();
	}
		// Mp7JrsFactory::DeleteObject(m_AudioDescriptor);
		this->SetAudioDescriptor(Mp7JrsFactory::CloneObject(tmp->GetAudioDescriptor()));
		// Mp7JrsFactory::DeleteObject(m_AudioDescriptionScheme);
		this->SetAudioDescriptionScheme(Mp7JrsFactory::CloneObject(tmp->GetAudioDescriptionScheme()));
		// Mp7JrsFactory::DeleteObject(m_VisualDescriptor);
		this->SetVisualDescriptor(Mp7JrsFactory::CloneObject(tmp->GetVisualDescriptor()));
		// Mp7JrsFactory::DeleteObject(m_VisualDescriptionScheme);
		this->SetVisualDescriptionScheme(Mp7JrsFactory::CloneObject(tmp->GetVisualDescriptionScheme()));
}

Mp7JrsNodePtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSemanticBaseType_MediaOccurrence_type_Local2Ptr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Gettype() const
{
	if (this->Existtype()) {
		return m_type;
	} else {
		return m_type_Default;
	}
}

bool Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Existtype() const
{
	return m_type_Exist;
}
void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Settype(const Mp7JrsSemanticBaseType_MediaOccurrence_type_Local2Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Settype().");
	}
    m_type = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_type) m_type->SetParent(m_myself.getPointer());
	m_type_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Invalidatetype()
{
	m_type_Exist = false;
}
Mp7JrsMediaInformationPtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetMediaInformation() const
{
	return m_MediaInformation;
}

Mp7JrsReferencePtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetMediaInformationRef() const
{
	return m_MediaInformationRef;
}

Mp7JrsMediaLocatorPtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetMediaLocator() const
{
	return m_MediaLocator;
}

Mp7JrsPtr< Mp7JrsNode > Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetMask() const
{
	return m_Mask;
}

// Element is optional
bool Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::IsValidMask() const
{
	return m_Mask_Exist;
}

Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetAudioDescriptor() const
{
	return m_AudioDescriptor;
}

Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetAudioDescriptionScheme() const
{
	return m_AudioDescriptionScheme;
}

Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetVisualDescriptor() const
{
	return m_VisualDescriptor;
}

Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetVisualDescriptionScheme() const
{
	return m_VisualDescriptionScheme;
}

	// TODO Implement proper cleanup for nested choices (e.g. CompositionShotEditinbTemporalDecompositionType_LocalType)
// implementing setter for choice 
/* element */
void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetMediaInformation(const Mp7JrsMediaInformationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetMediaInformation().");
	}
	if (m_MediaInformation != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaInformation);
		m_MediaInformation = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaInformation) m_MediaInformation->SetParent(m_myself.getPointer());
		if (m_MediaInformation && m_MediaInformation->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaInformationType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaInformation->UseTypeAttribute = true;
		}
		if(m_MediaInformation != Mp7JrsMediaInformationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaInformation->SetContentName(XMLString::transcode("MediaInformation"));
		}
	// Mp7JrsFactory::DeleteObject(m_MediaInformationRef);
	m_MediaInformationRef = Mp7JrsReferencePtr();
	// Mp7JrsFactory::DeleteObject(m_MediaLocator);
	m_MediaLocator = Mp7JrsMediaLocatorPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetMediaInformationRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetMediaInformationRef().");
	}
	if (m_MediaInformationRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaInformationRef);
		m_MediaInformationRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaInformationRef) m_MediaInformationRef->SetParent(m_myself.getPointer());
		if (m_MediaInformationRef && m_MediaInformationRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaInformationRef->UseTypeAttribute = true;
		}
		if(m_MediaInformationRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaInformationRef->SetContentName(XMLString::transcode("MediaInformationRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_MediaInformation);
	m_MediaInformation = Mp7JrsMediaInformationPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaLocator);
	m_MediaLocator = Mp7JrsMediaLocatorPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetMediaLocator(const Mp7JrsMediaLocatorPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetMediaLocator().");
	}
	if (m_MediaLocator != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaLocator);
		m_MediaLocator = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaLocator) m_MediaLocator->SetParent(m_myself.getPointer());
		if (m_MediaLocator && m_MediaLocator->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaLocatorType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaLocator->UseTypeAttribute = true;
		}
		if(m_MediaLocator != Mp7JrsMediaLocatorPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaLocator->SetContentName(XMLString::transcode("MediaLocator"));
		}
	// Mp7JrsFactory::DeleteObject(m_MediaInformation);
	m_MediaInformation = Mp7JrsMediaInformationPtr();
	// Mp7JrsFactory::DeleteObject(m_MediaInformationRef);
	m_MediaInformationRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetMask(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetMask().");
	}
	if (m_Mask != item || m_Mask_Exist == false)
	{
		// Mp7JrsFactory::DeleteObject(m_Mask);
		m_Mask = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Mask) m_Mask->SetParent(m_myself.getPointer());
		// Element is abstract, so set UseTypeAttribute to true
		if (m_Mask) m_Mask->UseTypeAttribute = true;
		m_Mask_Exist = true;
		if(m_Mask != Mp7JrsPtr< Mp7JrsNode >()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Mask->SetContentName(XMLString::transcode("Mask"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::InvalidateMask()
{
	m_Mask_Exist = false;
}
void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetAudioDescriptor(const Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetAudioDescriptor().");
	}
	if (m_AudioDescriptor != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioDescriptor);
		m_AudioDescriptor = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioDescriptor) m_AudioDescriptor->SetParent(m_myself.getPointer());
		if(m_AudioDescriptor != Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioDescriptor->SetContentName(XMLString::transcode("AudioDescriptor"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetAudioDescriptionScheme(const Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetAudioDescriptionScheme().");
	}
	if (m_AudioDescriptionScheme != item)
	{
		// Mp7JrsFactory::DeleteObject(m_AudioDescriptionScheme);
		m_AudioDescriptionScheme = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_AudioDescriptionScheme) m_AudioDescriptionScheme->SetParent(m_myself.getPointer());
		if(m_AudioDescriptionScheme != Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_AudioDescriptionScheme->SetContentName(XMLString::transcode("AudioDescriptionScheme"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetVisualDescriptor(const Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetVisualDescriptor().");
	}
	if (m_VisualDescriptor != item)
	{
		// Mp7JrsFactory::DeleteObject(m_VisualDescriptor);
		m_VisualDescriptor = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_VisualDescriptor) m_VisualDescriptor->SetParent(m_myself.getPointer());
		if(m_VisualDescriptor != Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_VisualDescriptor->SetContentName(XMLString::transcode("VisualDescriptor"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetVisualDescriptionScheme(const Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::SetVisualDescriptionScheme().");
	}
	if (m_VisualDescriptionScheme != item)
	{
		// Mp7JrsFactory::DeleteObject(m_VisualDescriptionScheme);
		m_VisualDescriptionScheme = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_VisualDescriptionScheme) m_VisualDescriptionScheme->SetParent(m_myself.getPointer());
		if(m_VisualDescriptionScheme != Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_VisualDescriptionScheme->SetContentName(XMLString::transcode("VisualDescriptionScheme"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("MediaInformation")) == 0)
	{
		// MediaInformation is simple element MediaInformationType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMediaInformation()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaInformationType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaInformationPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMediaInformation(p, client);
					if((p = GetMediaInformation()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaInformationRef")) == 0)
	{
		// MediaInformationRef is simple element ReferenceType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMediaInformationRef()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMediaInformationRef(p, client);
					if((p = GetMediaInformationRef()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("MediaLocator")) == 0)
	{
		// MediaLocator is simple element MediaLocatorType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMediaLocator()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaLocatorType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaLocatorPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMediaLocator(p, client);
					if((p = GetMediaLocator()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Mask")) == 0)
	{
		// Mask is simple abstract element MaskType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMask()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsMaskPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMask(p, client);
					if((p = GetMask()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("AudioDescriptor")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:AudioDescriptor is item of abstract type AudioDType
		// in element collection SemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr coll = GetAudioDescriptor();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType;
				SetAudioDescriptor(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsAudioDPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("AudioDescriptionScheme")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:AudioDescriptionScheme is item of abstract type AudioDSType
		// in element collection SemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr coll = GetAudioDescriptionScheme();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType;
				SetAudioDescriptionScheme(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsAudioDSPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("VisualDescriptor")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:VisualDescriptor is item of abstract type VisualDType
		// in element collection SemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr coll = GetVisualDescriptor();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType;
				SetVisualDescriptor(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsVisualDPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("VisualDescriptionScheme")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:VisualDescriptionScheme is item of abstract type VisualDSType
		// in element collection SemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType
		
		context->Found = true;
		Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr coll = GetVisualDescriptionScheme();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType;
				SetVisualDescriptionScheme(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, 0)) != empty)
			{
				// Is type allowed
				Mp7JrsVisualDSPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SemanticBaseType_MediaOccurrence_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SemanticBaseType_MediaOccurrence_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SemanticBaseType_MediaOccurrence_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_type_Exist)
	{
	// Class
	if (m_type != Mp7JrsSemanticBaseType_MediaOccurrence_type_Local2Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_type->ToText();
		element->setAttributeNS(X(""), X("type"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_MediaInformation != Mp7JrsMediaInformationPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MediaInformation->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MediaInformation"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MediaInformation->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MediaInformationRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MediaInformationRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MediaInformationRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MediaInformationRef->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_MediaLocator != Mp7JrsMediaLocatorPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MediaLocator->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MediaLocator"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MediaLocator->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Mask != Mp7JrsPtr< Mp7JrsNode >())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Mask->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Mask"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
			// Abstract type, so use xsitype
			m_Mask->UseTypeAttribute = true;
		}
		m_Mask->Serialize(doc, element, &elem);
	}
	if (m_AudioDescriptor != Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_AudioDescriptor->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_AudioDescriptionScheme != Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_AudioDescriptionScheme->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_VisualDescriptor != Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_VisualDescriptor->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_VisualDescriptionScheme != Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_VisualDescriptionScheme->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("type")))
	{
        // Deserialize class type
		Mp7JrsSemanticBaseType_MediaOccurrence_type_Local2Ptr tmp = CreateSemanticBaseType_MediaOccurrence_type_LocalType2;
		tmp->Parse(parent->getAttributeNS(X(""), X("type")));
        this->Settype(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("type")))
	{
		// Deserialize class type
        Mp7JrsSemanticBaseType_MediaOccurrence_type_Local2Ptr tmp = CreateSemanticBaseType_MediaOccurrence_type_LocalType2;
        tmp->Parse(parent->getAttribute(X("type")));
        this->Settype(tmp);
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaInformation"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaInformation")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaInformationType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMediaInformation(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaInformationRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaInformationRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMediaInformationRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaLocator"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaLocator")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaLocatorType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMediaLocator(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Mask"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Mask")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMaskType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMask(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("AudioDescriptor"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("AudioDescriptor")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr tmp = CreateSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetAudioDescriptor(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("AudioDescriptionScheme"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("AudioDescriptionScheme")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr tmp = CreateSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetAudioDescriptionScheme(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("VisualDescriptor"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("VisualDescriptor")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr tmp = CreateSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetVisualDescriptor(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("VisualDescriptionScheme"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("VisualDescriptionScheme")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr tmp = CreateSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetVisualDescriptionScheme(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSemanticBaseType_MediaOccurrence_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("MediaInformation")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaInformationType;
    }
    this->SetMediaInformation(child);
  }
  if (XMLString::compareString(elementname, X("MediaInformationRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetMediaInformationRef(child);
  }
  if (XMLString::compareString(elementname, X("MediaLocator")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaLocatorType;
    }
    this->SetMediaLocator(child);
  }
  if (XMLString::compareString(elementname, X("Mask")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMaskType;
    }
    this->SetMask(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("AudioDescriptor")) == 0))
  {
    Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionPtr tmp = CreateSemanticBaseType_MediaOccurrence_AudioDescriptor_CollectionType;
    this->SetAudioDescriptor(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("AudioDescriptionScheme")) == 0))
  {
    Mp7JrsSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionPtr tmp = CreateSemanticBaseType_MediaOccurrence_AudioDescriptionScheme_CollectionType;
    this->SetAudioDescriptionScheme(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("VisualDescriptor")) == 0))
  {
    Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionPtr tmp = CreateSemanticBaseType_MediaOccurrence_VisualDescriptor_CollectionType;
    this->SetVisualDescriptor(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("VisualDescriptionScheme")) == 0))
  {
    Mp7JrsSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionPtr tmp = CreateSemanticBaseType_MediaOccurrence_VisualDescriptionScheme_CollectionType;
    this->SetVisualDescriptionScheme(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSemanticBaseType_MediaOccurrence_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMask() != Mp7JrsNodePtr())
		result.Insert(GetMask());
	if (GetAudioDescriptor() != Mp7JrsNodePtr())
		result.Insert(GetAudioDescriptor());
	if (GetAudioDescriptionScheme() != Mp7JrsNodePtr())
		result.Insert(GetAudioDescriptionScheme());
	if (GetVisualDescriptor() != Mp7JrsNodePtr())
		result.Insert(GetVisualDescriptor());
	if (GetVisualDescriptionScheme() != Mp7JrsNodePtr())
		result.Insert(GetVisualDescriptionScheme());
	if (GetMediaInformation() != Mp7JrsNodePtr())
		result.Insert(GetMediaInformation());
	if (GetMediaInformationRef() != Mp7JrsNodePtr())
		result.Insert(GetMediaInformationRef());
	if (GetMediaLocator() != Mp7JrsNodePtr())
		result.Insert(GetMediaLocator());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSemanticBaseType_MediaOccurrence_LocalType_ExtMethodImpl.h


