 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSignalPlaneFractionType_ExtImplInclude.h



#include "Mp7JrsSignalPlaneType.h"
#include "Mp7JrsSignalPlaneType_dim_LocalType.h"
#include "Mp7JrsSignalPlaneOriginType.h"
#include "Mp7JrsSignalPlaneFractionType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsSignalPlaneFractionType::IMp7JrsSignalPlaneFractionType()
{

// no includefile for extension defined 
// file Mp7JrsSignalPlaneFractionType_ExtPropInit.h

}

IMp7JrsSignalPlaneFractionType::~IMp7JrsSignalPlaneFractionType()
{
// no includefile for extension defined 
// file Mp7JrsSignalPlaneFractionType_ExtPropCleanup.h

}

Mp7JrsSignalPlaneFractionType::Mp7JrsSignalPlaneFractionType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSignalPlaneFractionType::~Mp7JrsSignalPlaneFractionType()
{
	Cleanup();
}

void Mp7JrsSignalPlaneFractionType::Init()
{
	// Init base
	m_Base = CreateSignalPlaneType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_x = 0.0; // Value
	m_x_Exist = false;
	m_y = 0.0; // Value
	m_y_Exist = false;
	m_z = 0.0; // Value
	m_z_Exist = false;
	m_t = 0.0; // Value
	m_t_Exist = false;



// no includefile for extension defined 
// file Mp7JrsSignalPlaneFractionType_ExtMyPropInit.h

}

void Mp7JrsSignalPlaneFractionType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSignalPlaneFractionType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
}

void Mp7JrsSignalPlaneFractionType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SignalPlaneFractionTypePtr, since we
	// might need GetBase(), which isn't defined in ISignalPlaneFractionType
    const Mp7JrsPtr< Mp7JrsSignalPlaneFractionType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsSignalPlanePtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSignalPlaneFractionType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	if (tmp->Existx())
	{
		this->Setx(tmp->Getx());
	}
	else
	{
		Invalidatex();
	}
	}
	{
	if (tmp->Existy())
	{
		this->Sety(tmp->Gety());
	}
	else
	{
		Invalidatey();
	}
	}
	{
	if (tmp->Existz())
	{
		this->Setz(tmp->Getz());
	}
	else
	{
		Invalidatez();
	}
	}
	{
	if (tmp->Existt())
	{
		this->Sett(tmp->Gett());
	}
	else
	{
		Invalidatet();
	}
	}
}

Mp7JrsNodePtr Mp7JrsSignalPlaneFractionType::GetBaseRoot()
{
	return GetBase();
}

const Mp7JrsNodePtr Mp7JrsSignalPlaneFractionType::GetBaseRoot() const
{
	return GetBase();
}


Mp7JrsPtr< Mp7JrsSignalPlaneType > Mp7JrsSignalPlaneFractionType::GetBase() const
{
	return m_Base;
}

double Mp7JrsSignalPlaneFractionType::Getx() const
{
	return m_x;
}

bool Mp7JrsSignalPlaneFractionType::Existx() const
{
	return m_x_Exist;
}
void Mp7JrsSignalPlaneFractionType::Setx(double item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneFractionType::Setx().");
	}
    m_x = item;
	m_x_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneFractionType::Invalidatex()
{
	m_x_Exist = false;
}
double Mp7JrsSignalPlaneFractionType::Gety() const
{
	return m_y;
}

bool Mp7JrsSignalPlaneFractionType::Existy() const
{
	return m_y_Exist;
}
void Mp7JrsSignalPlaneFractionType::Sety(double item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneFractionType::Sety().");
	}
    m_y = item;
	m_y_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneFractionType::Invalidatey()
{
	m_y_Exist = false;
}
double Mp7JrsSignalPlaneFractionType::Getz() const
{
	return m_z;
}

bool Mp7JrsSignalPlaneFractionType::Existz() const
{
	return m_z_Exist;
}
void Mp7JrsSignalPlaneFractionType::Setz(double item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneFractionType::Setz().");
	}
    m_z = item;
	m_z_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneFractionType::Invalidatez()
{
	m_z_Exist = false;
}
double Mp7JrsSignalPlaneFractionType::Gett() const
{
	return m_t;
}

bool Mp7JrsSignalPlaneFractionType::Existt() const
{
	return m_t_Exist;
}
void Mp7JrsSignalPlaneFractionType::Sett(double item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneFractionType::Sett().");
	}
    m_t = item;
	m_t_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneFractionType::Invalidatet()
{
	m_t_Exist = false;
}
Mp7JrsSignalPlaneType_dim_LocalPtr Mp7JrsSignalPlaneFractionType::Getdim() const
{
	return GetBase()->Getdim();
}

bool Mp7JrsSignalPlaneFractionType::Existdim() const
{
	return GetBase()->Existdim();
}
void Mp7JrsSignalPlaneFractionType::Setdim(const Mp7JrsSignalPlaneType_dim_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneFractionType::Setdim().");
	}
	GetBase()->Setdim(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneFractionType::Invalidatedim()
{
	GetBase()->Invalidatedim();
}
Mp7JrsSignalPlaneOriginPtr Mp7JrsSignalPlaneFractionType::GetOrigin() const
{
	return GetBase()->GetOrigin();
}

// Element is optional
bool Mp7JrsSignalPlaneFractionType::IsValidOrigin() const
{
	return GetBase()->IsValidOrigin();
}

void Mp7JrsSignalPlaneFractionType::SetOrigin(const Mp7JrsSignalPlaneOriginPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneFractionType::SetOrigin().");
	}
	GetBase()->SetOrigin(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneFractionType::InvalidateOrigin()
{
	GetBase()->InvalidateOrigin();
}

Mp7JrsNodeEnum Mp7JrsSignalPlaneFractionType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SignalPlaneFractionType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SignalPlaneFractionType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSignalPlaneFractionType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSignalPlaneFractionType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsSignalPlaneFractionType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSignalPlaneFractionType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SignalPlaneFractionType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_x_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_x);
		element->setAttributeNS(X(""), X("x"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_y_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_y);
		element->setAttributeNS(X(""), X("y"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_z_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_z);
		element->setAttributeNS(X(""), X("z"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_t_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_t);
		element->setAttributeNS(X(""), X("t"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsSignalPlaneFractionType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("x")))
	{
        // deserialize value type
        this->Setx(Mp7JrsConvert::TextToDouble(parent->getAttributeNS(X(""), X("x"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("x")))
	{
        // deserialize value type
        this->Setx(Mp7JrsConvert::TextToDouble(parent->getAttribute(X("x"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("y")))
	{
        // deserialize value type
        this->Sety(Mp7JrsConvert::TextToDouble(parent->getAttributeNS(X(""), X("y"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("y")))
	{
        // deserialize value type
        this->Sety(Mp7JrsConvert::TextToDouble(parent->getAttribute(X("y"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("z")))
	{
        // deserialize value type
        this->Setz(Mp7JrsConvert::TextToDouble(parent->getAttributeNS(X(""), X("z"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("z")))
	{
        // deserialize value type
        this->Setz(Mp7JrsConvert::TextToDouble(parent->getAttribute(X("z"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("t")))
	{
        // deserialize value type
        this->Sett(Mp7JrsConvert::TextToDouble(parent->getAttributeNS(X(""), X("t"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("t")))
	{
        // deserialize value type
        this->Sett(Mp7JrsConvert::TextToDouble(parent->getAttribute(X("t"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsSignalPlaneType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
// no includefile for extension defined 
// file Mp7JrsSignalPlaneFractionType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSignalPlaneFractionType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSignalPlaneFractionType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetOrigin() != Mp7JrsNodePtr())
		result.Insert(GetOrigin());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSignalPlaneFractionType_ExtMethodImpl.h


