 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSignalPlaneOriginType_ExtImplInclude.h



#include "Mp7JrsSignalPlaneOriginType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsSignalPlaneOriginType::IMp7JrsSignalPlaneOriginType()
{

// no includefile for extension defined 
// file Mp7JrsSignalPlaneOriginType_ExtPropInit.h

}

IMp7JrsSignalPlaneOriginType::~IMp7JrsSignalPlaneOriginType()
{
// no includefile for extension defined 
// file Mp7JrsSignalPlaneOriginType_ExtPropCleanup.h

}

Mp7JrsSignalPlaneOriginType::Mp7JrsSignalPlaneOriginType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSignalPlaneOriginType::~Mp7JrsSignalPlaneOriginType()
{
	Cleanup();
}

void Mp7JrsSignalPlaneOriginType::Init()
{

	// Init attributes
	m_xOrigin = Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::UninitializedEnumeration;
// old	m_xOrigin = Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::Enumeration::;
// old	m_xOrigin_Default = Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::Enumeration::left;
	m_xOrigin_Default = Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::left;
	m_xOrigin_Exist = false;
	m_yOrigin = Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::UninitializedEnumeration;
// old	m_yOrigin = Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::Enumeration::;
// old	m_yOrigin_Default = Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::Enumeration::bottom;
	m_yOrigin_Default = Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::bottom;
	m_yOrigin_Exist = false;
	m_zOrigin = Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::UninitializedEnumeration;
// old	m_zOrigin = Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::Enumeration::;
// old	m_zOrigin_Default = Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::Enumeration::back;
	m_zOrigin_Default = Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::back;
	m_zOrigin_Exist = false;
	m_timeOrigin = Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::UninitializedEnumeration;
// old	m_timeOrigin = Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::Enumeration::;
// old	m_timeOrigin_Default = Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::Enumeration::past;
	m_timeOrigin_Default = Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::past;
	m_timeOrigin_Exist = false;



// no includefile for extension defined 
// file Mp7JrsSignalPlaneOriginType_ExtMyPropInit.h

}

void Mp7JrsSignalPlaneOriginType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSignalPlaneOriginType_ExtMyPropCleanup.h


}

void Mp7JrsSignalPlaneOriginType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SignalPlaneOriginTypePtr, since we
	// might need GetBase(), which isn't defined in ISignalPlaneOriginType
    const Mp7JrsPtr< Mp7JrsSignalPlaneOriginType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	if (tmp->ExistxOrigin())
	{
		this->SetxOrigin(tmp->GetxOrigin());
	}
	else
	{
		InvalidatexOrigin();
	}
	}
	{
	if (tmp->ExistyOrigin())
	{
		this->SetyOrigin(tmp->GetyOrigin());
	}
	else
	{
		InvalidateyOrigin();
	}
	}
	{
	if (tmp->ExistzOrigin())
	{
		this->SetzOrigin(tmp->GetzOrigin());
	}
	else
	{
		InvalidatezOrigin();
	}
	}
	{
	if (tmp->ExisttimeOrigin())
	{
		this->SettimeOrigin(tmp->GettimeOrigin());
	}
	else
	{
		InvalidatetimeOrigin();
	}
	}
}

Mp7JrsNodePtr Mp7JrsSignalPlaneOriginType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSignalPlaneOriginType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::Enumeration Mp7JrsSignalPlaneOriginType::GetxOrigin() const
{
	if (this->ExistxOrigin()) {
		return m_xOrigin;
	} else {
		return m_xOrigin_Default;
	}
}

bool Mp7JrsSignalPlaneOriginType::ExistxOrigin() const
{
	return m_xOrigin_Exist;
}
void Mp7JrsSignalPlaneOriginType::SetxOrigin(Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneOriginType::SetxOrigin().");
	}
    m_xOrigin = item;
	m_xOrigin_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneOriginType::InvalidatexOrigin()
{
	m_xOrigin_Exist = false;
}
Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::Enumeration Mp7JrsSignalPlaneOriginType::GetyOrigin() const
{
	if (this->ExistyOrigin()) {
		return m_yOrigin;
	} else {
		return m_yOrigin_Default;
	}
}

bool Mp7JrsSignalPlaneOriginType::ExistyOrigin() const
{
	return m_yOrigin_Exist;
}
void Mp7JrsSignalPlaneOriginType::SetyOrigin(Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneOriginType::SetyOrigin().");
	}
    m_yOrigin = item;
	m_yOrigin_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneOriginType::InvalidateyOrigin()
{
	m_yOrigin_Exist = false;
}
Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::Enumeration Mp7JrsSignalPlaneOriginType::GetzOrigin() const
{
	if (this->ExistzOrigin()) {
		return m_zOrigin;
	} else {
		return m_zOrigin_Default;
	}
}

bool Mp7JrsSignalPlaneOriginType::ExistzOrigin() const
{
	return m_zOrigin_Exist;
}
void Mp7JrsSignalPlaneOriginType::SetzOrigin(Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneOriginType::SetzOrigin().");
	}
    m_zOrigin = item;
	m_zOrigin_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneOriginType::InvalidatezOrigin()
{
	m_zOrigin_Exist = false;
}
Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::Enumeration Mp7JrsSignalPlaneOriginType::GettimeOrigin() const
{
	if (this->ExisttimeOrigin()) {
		return m_timeOrigin;
	} else {
		return m_timeOrigin_Default;
	}
}

bool Mp7JrsSignalPlaneOriginType::ExisttimeOrigin() const
{
	return m_timeOrigin_Exist;
}
void Mp7JrsSignalPlaneOriginType::SettimeOrigin(Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSignalPlaneOriginType::SettimeOrigin().");
	}
    m_timeOrigin = item;
	m_timeOrigin_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSignalPlaneOriginType::InvalidatetimeOrigin()
{
	m_timeOrigin_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsSignalPlaneOriginType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	// Only rudimentary expressions allowed for this type with no child elements
	return result;
}	

XMLCh * Mp7JrsSignalPlaneOriginType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSignalPlaneOriginType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}


void Mp7JrsSignalPlaneOriginType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SignalPlaneOriginType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_xOrigin_Exist)
	{
	// Enumeration
	if(m_xOrigin != Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::ToText(m_xOrigin);
		element->setAttributeNS(X(""), X("xOrigin"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_yOrigin_Exist)
	{
	// Enumeration
	if(m_yOrigin != Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::ToText(m_yOrigin);
		element->setAttributeNS(X(""), X("yOrigin"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_zOrigin_Exist)
	{
	// Enumeration
	if(m_zOrigin != Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::ToText(m_zOrigin);
		element->setAttributeNS(X(""), X("zOrigin"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_timeOrigin_Exist)
	{
	// Enumeration
	if(m_timeOrigin != Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::ToText(m_timeOrigin);
		element->setAttributeNS(X(""), X("timeOrigin"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsSignalPlaneOriginType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("xOrigin")))
	{
        this->SetxOrigin(Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::Parse(parent->getAttributeNS(X(""), X("xOrigin"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("xOrigin")))
	{
        this->SetxOrigin(Mp7JrsSignalPlaneOriginType_xOrigin_LocalType::Parse(parent->getAttribute(X("xOrigin"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("yOrigin")))
	{
        this->SetyOrigin(Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::Parse(parent->getAttributeNS(X(""), X("yOrigin"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("yOrigin")))
	{
        this->SetyOrigin(Mp7JrsSignalPlaneOriginType_yOrigin_LocalType::Parse(parent->getAttribute(X("yOrigin"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("zOrigin")))
	{
        this->SetzOrigin(Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::Parse(parent->getAttributeNS(X(""), X("zOrigin"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("zOrigin")))
	{
        this->SetzOrigin(Mp7JrsSignalPlaneOriginType_zOrigin_LocalType::Parse(parent->getAttribute(X("zOrigin"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("timeOrigin")))
	{
        this->SettimeOrigin(Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::Parse(parent->getAttributeNS(X(""), X("timeOrigin"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("timeOrigin")))
	{
        this->SettimeOrigin(Mp7JrsSignalPlaneOriginType_timeOrigin_LocalType::Parse(parent->getAttribute(X("timeOrigin"))));
        * current = parent;
    }

// no includefile for extension defined 
// file Mp7JrsSignalPlaneOriginType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSignalPlaneOriginType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSignalPlaneOriginType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSignalPlaneOriginType_ExtMethodImpl.h


