 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtImplInclude.h



#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType.h"
#include "Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtPropInit.h

}

IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::~IMp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtPropCleanup.h

}

Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::~Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0()
{
	Cleanup();
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_CurrPixel = Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr(); // Class
	m_SrcPixel = Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtMyPropInit.h

}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_CurrPixel);
	// Mp7JrsFactory::DeleteObject(m_SrcPixel);
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in ISpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0
    const Mp7JrsPtr< Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_CurrPixel);
		this->SetCurrPixel(Mp7JrsFactory::CloneObject(tmp->GetCurrPixel()));
		// Mp7JrsFactory::DeleteObject(m_SrcPixel);
		this->SetSrcPixel(Mp7JrsFactory::CloneObject(tmp->GetSrcPixel()));
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::GetCurrPixel() const
{
	return m_CurrPixel;
}

Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::GetSrcPixel() const
{
	return m_SrcPixel;
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::SetCurrPixel(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::SetCurrPixel().");
	}
	if (m_CurrPixel != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CurrPixel);
		m_CurrPixel = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CurrPixel) m_CurrPixel->SetParent(m_myself.getPointer());
		if (m_CurrPixel && m_CurrPixel->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CurrPixel->UseTypeAttribute = true;
		}
		if(m_CurrPixel != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CurrPixel->SetContentName(XMLString::transcode("CurrPixel"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::SetSrcPixel(const Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::SetSrcPixel().");
	}
	if (m_SrcPixel != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SrcPixel);
		m_SrcPixel = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SrcPixel) m_SrcPixel->SetParent(m_myself.getPointer());
		if (m_SrcPixel && m_SrcPixel->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:Spatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SrcPixel->UseTypeAttribute = true;
		}
		if(m_SrcPixel != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SrcPixel->SetContentName(XMLString::transcode("SrcPixel"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("Spatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0"));
	// Element serialization:
	// Class
	
	if (m_CurrPixel != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CurrPixel->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CurrPixel"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CurrPixel->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_SrcPixel != Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SrcPixel->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SrcPixel"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SrcPixel->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CurrPixel"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CurrPixel")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCurrPixel(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SrcPixel"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SrcPixel")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSrcPixel(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("CurrPixel")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_CurrPixel_LocalType;
    }
    this->SetCurrPixel(child);
  }
  if (XMLString::compareString(elementname, X("SrcPixel")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSpatial2DCoordinateSystemType_LocalCoordinateSystem_SrcPixel_LocalType;
    }
    this->SetSrcPixel(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetCurrPixel() != Mp7JrsNodePtr())
		result.Insert(GetCurrPixel());
	if (GetSrcPixel() != Mp7JrsNodePtr())
		result.Insert(GetSrcPixel());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpatial2DCoordinateSystemType_LocalCoordinateSystem_LocalType0_ExtMethodImpl.h


