 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtImplInclude.h



#include "Mp7Jrsunsigned16.h"
#include "Mp7JrsMediaTimeType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_CollectionType.h"
#include "Mp7JrsSpokenContentLatticeType_Block_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsSpokenContentLatticeType_Block_Node_LocalType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Node

#include <assert.h>
IMp7JrsSpokenContentLatticeType_Block_LocalType::IMp7JrsSpokenContentLatticeType_Block_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtPropInit.h

}

IMp7JrsSpokenContentLatticeType_Block_LocalType::~IMp7JrsSpokenContentLatticeType_Block_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtPropCleanup.h

}

Mp7JrsSpokenContentLatticeType_Block_LocalType::Mp7JrsSpokenContentLatticeType_Block_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSpokenContentLatticeType_Block_LocalType::~Mp7JrsSpokenContentLatticeType_Block_LocalType()
{
	Cleanup();
}

void Mp7JrsSpokenContentLatticeType_Block_LocalType::Init()
{

	// Init attributes
	m_defaultSpeakerInfoRef = NULL; // String
	m_num = Createunsigned16; // Create a valid class
	m_num->SetContent(0); // Use Value initialiser (xxx2)
	m_audio = Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::UninitializedEnumeration;
// old	m_audio = Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration::;
// old	m_audio_Default = Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration::speech;
	m_audio_Default = Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::speech;
	m_audio_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_MediaTime = Mp7JrsMediaTimePtr(); // Class
	m_Node = Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtMyPropInit.h

}

void Mp7JrsSpokenContentLatticeType_Block_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtMyPropCleanup.h


	XMLString::release(&m_defaultSpeakerInfoRef);
	// Mp7JrsFactory::DeleteObject(m_num);
	// Mp7JrsFactory::DeleteObject(m_MediaTime);
	// Mp7JrsFactory::DeleteObject(m_Node);
}

void Mp7JrsSpokenContentLatticeType_Block_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SpokenContentLatticeType_Block_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISpokenContentLatticeType_Block_LocalType
    const Mp7JrsPtr< Mp7JrsSpokenContentLatticeType_Block_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	{
	XMLString::release(&m_defaultSpeakerInfoRef);
		this->SetdefaultSpeakerInfoRef(XMLString::replicate(tmp->GetdefaultSpeakerInfoRef()));
	}
	{
	// Mp7JrsFactory::DeleteObject(m_num);
		this->Setnum(Mp7JrsFactory::CloneObject(tmp->Getnum()));
	}
	{
	if (tmp->Existaudio())
	{
		this->Setaudio(tmp->Getaudio());
	}
	else
	{
		Invalidateaudio();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_MediaTime);
		this->SetMediaTime(Mp7JrsFactory::CloneObject(tmp->GetMediaTime()));
		// Mp7JrsFactory::DeleteObject(m_Node);
		this->SetNode(Mp7JrsFactory::CloneObject(tmp->GetNode()));
}

Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


XMLCh * Mp7JrsSpokenContentLatticeType_Block_LocalType::GetdefaultSpeakerInfoRef() const
{
	return m_defaultSpeakerInfoRef;
}

void Mp7JrsSpokenContentLatticeType_Block_LocalType::SetdefaultSpeakerInfoRef(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_LocalType::SetdefaultSpeakerInfoRef().");
	}
    m_defaultSpeakerInfoRef = item;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7Jrsunsigned16Ptr Mp7JrsSpokenContentLatticeType_Block_LocalType::Getnum() const
{
	return m_num;
}

void Mp7JrsSpokenContentLatticeType_Block_LocalType::Setnum(const Mp7Jrsunsigned16Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_LocalType::Setnum().");
	}
    m_num = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_num) m_num->SetParent(m_myself.getPointer());
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration Mp7JrsSpokenContentLatticeType_Block_LocalType::Getaudio() const
{
	if (this->Existaudio()) {
		return m_audio;
	} else {
		return m_audio_Default;
	}
}

bool Mp7JrsSpokenContentLatticeType_Block_LocalType::Existaudio() const
{
	return m_audio_Exist;
}
void Mp7JrsSpokenContentLatticeType_Block_LocalType::Setaudio(Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_LocalType::Setaudio().");
	}
    m_audio = item;
	m_audio_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpokenContentLatticeType_Block_LocalType::Invalidateaudio()
{
	m_audio_Exist = false;
}
Mp7JrsMediaTimePtr Mp7JrsSpokenContentLatticeType_Block_LocalType::GetMediaTime() const
{
	return m_MediaTime;
}

Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr Mp7JrsSpokenContentLatticeType_Block_LocalType::GetNode() const
{
	return m_Node;
}

void Mp7JrsSpokenContentLatticeType_Block_LocalType::SetMediaTime(const Mp7JrsMediaTimePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_LocalType::SetMediaTime().");
	}
	if (m_MediaTime != item)
	{
		// Mp7JrsFactory::DeleteObject(m_MediaTime);
		m_MediaTime = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_MediaTime) m_MediaTime->SetParent(m_myself.getPointer());
		if (m_MediaTime && m_MediaTime->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTimeType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_MediaTime->UseTypeAttribute = true;
		}
		if(m_MediaTime != Mp7JrsMediaTimePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_MediaTime->SetContentName(XMLString::transcode("MediaTime"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSpokenContentLatticeType_Block_LocalType::SetNode(const Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSpokenContentLatticeType_Block_LocalType::SetNode().");
	}
	if (m_Node != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Node);
		m_Node = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Node) m_Node->SetParent(m_myself.getPointer());
		if(m_Node != Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Node->SetContentName(XMLString::transcode("Node"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSpokenContentLatticeType_Block_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("MediaTime")) == 0)
	{
		// MediaTime is simple element MediaTimeType
		context->Found = true;
		Mp7JrsXPathParseContext::PreProcessSimpleElement(context);
		
		Mp7JrsNodePtr p;
		if((p = GetMediaTime()) != empty)
		{
			if(Mp7JrsXPathParseContext::HandleSimpleElement(context, p))
			{
				result.Insert(p);
			}
		}
		else if(context->Create)
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:MediaTimeType")))) != empty)
			{
				// Is type allowed
				Mp7JrsMediaTimePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					SetMediaTime(p, client);
					if((p = GetMediaTime()) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Node")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Node is item of type SpokenContentLatticeType_Block_Node_LocalType
		// in element collection SpokenContentLatticeType_Block_Node_CollectionType
		
		context->Found = true;
		Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr coll = GetNode();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSpokenContentLatticeType_Block_Node_CollectionType;
				SetNode(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), 65536))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SpokenContentLatticeType_Block_Node_LocalType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSpokenContentLatticeType_Block_Node_LocalPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SpokenContentLatticeType_Block_LocalType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SpokenContentLatticeType_Block_LocalType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSpokenContentLatticeType_Block_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSpokenContentLatticeType_Block_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSpokenContentLatticeType_Block_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SpokenContentLatticeType_Block_LocalType"));
    // Attribute Serialization:
	// String
	if(m_defaultSpeakerInfoRef != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("defaultSpeakerInfoRef"), m_defaultSpeakerInfoRef);
	}
    // Attribute Serialization:
	// Class
	if (m_num != Mp7Jrsunsigned16Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_num->ToText();
		element->setAttributeNS(X(""), X("num"), tmp);
		XMLString::release(&tmp);
	}
    // Attribute Serialization:
		

	// Optional attriute
	if(m_audio_Exist)
	{
	// Enumeration
	if(m_audio != Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::ToText(m_audio);
		element->setAttributeNS(X(""), X("audio"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	// Class
	
	if (m_MediaTime != Mp7JrsMediaTimePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_MediaTime->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("MediaTime"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_MediaTime->Serialize(doc, element, &elem);
	}
	if (m_Node != Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Node->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSpokenContentLatticeType_Block_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("defaultSpeakerInfoRef")))
	{
        // Deserialize string type
        this->SetdefaultSpeakerInfoRef(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("defaultSpeakerInfoRef"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("defaultSpeakerInfoRef")))
	{
        // Deserialize string type
        this->SetdefaultSpeakerInfoRef(Mp7JrsConvert::TextToString(parent->getAttribute(X("defaultSpeakerInfoRef"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("num")))
	{
        // Deserialize class type
		Mp7Jrsunsigned16Ptr tmp = Createunsigned16;
		tmp->Parse(parent->getAttributeNS(X(""), X("num")));
        this->Setnum(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("num")))
	{
		// Deserialize class type
        Mp7Jrsunsigned16Ptr tmp = Createunsigned16;
        tmp->Parse(parent->getAttribute(X("num")));
        this->Setnum(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("audio")))
	{
        this->Setaudio(Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Parse(parent->getAttributeNS(X(""), X("audio"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("audio")))
	{
        this->Setaudio(Mp7JrsSpokenContentLatticeType_Block_audio_LocalType::Parse(parent->getAttribute(X("audio"))));
        * current = parent;
    }

	parent = Mp7JrsUtil::GetNextChild(parent);
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("MediaTime"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("MediaTime")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateMediaTimeType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetMediaTime(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Node"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Node")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr tmp = CreateSpokenContentLatticeType_Block_Node_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetNode(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSpokenContentLatticeType_Block_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("MediaTime")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateMediaTimeType;
    }
    this->SetMediaTime(child);
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Node")) == 0))
  {
    Mp7JrsSpokenContentLatticeType_Block_Node_CollectionPtr tmp = CreateSpokenContentLatticeType_Block_Node_CollectionType;
    this->SetNode(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSpokenContentLatticeType_Block_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetMediaTime() != Mp7JrsNodePtr())
		result.Insert(GetMediaTime());
	if (GetNode() != Mp7JrsNodePtr())
		result.Insert(GetNode());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSpokenContentLatticeType_Block_LocalType_ExtMethodImpl.h


