 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType0_ExtImplInclude.h



#include "Mp7JrsCollectionModelType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsStructuredCollectionType_LocalType0.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsStructuredCollectionType_LocalType0::IMp7JrsStructuredCollectionType_LocalType0()
{

// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType0_ExtPropInit.h

}

IMp7JrsStructuredCollectionType_LocalType0::~IMp7JrsStructuredCollectionType_LocalType0()
{
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType0_ExtPropCleanup.h

}

Mp7JrsStructuredCollectionType_LocalType0::Mp7JrsStructuredCollectionType_LocalType0()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsStructuredCollectionType_LocalType0::~Mp7JrsStructuredCollectionType_LocalType0()
{
	Cleanup();
}

void Mp7JrsStructuredCollectionType_LocalType0::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_CollectionModel = Mp7JrsCollectionModelPtr(); // Class
	m_CollectionModelRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType0_ExtMyPropInit.h

}

void Mp7JrsStructuredCollectionType_LocalType0::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType0_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_CollectionModel);
	// Mp7JrsFactory::DeleteObject(m_CollectionModelRef);
}

void Mp7JrsStructuredCollectionType_LocalType0::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use StructuredCollectionType_LocalType0Ptr, since we
	// might need GetBase(), which isn't defined in IStructuredCollectionType_LocalType0
    const Mp7JrsPtr< Mp7JrsStructuredCollectionType_LocalType0 > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_CollectionModel);
		this->SetCollectionModel(Mp7JrsFactory::CloneObject(tmp->GetCollectionModel()));
		// Mp7JrsFactory::DeleteObject(m_CollectionModelRef);
		this->SetCollectionModelRef(Mp7JrsFactory::CloneObject(tmp->GetCollectionModelRef()));
}

Mp7JrsNodePtr Mp7JrsStructuredCollectionType_LocalType0::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsStructuredCollectionType_LocalType0::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsCollectionModelPtr Mp7JrsStructuredCollectionType_LocalType0::GetCollectionModel() const
{
	return m_CollectionModel;
}

Mp7JrsReferencePtr Mp7JrsStructuredCollectionType_LocalType0::GetCollectionModelRef() const
{
	return m_CollectionModelRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsStructuredCollectionType_LocalType0::SetCollectionModel(const Mp7JrsCollectionModelPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType_LocalType0::SetCollectionModel().");
	}
	if (m_CollectionModel != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CollectionModel);
		m_CollectionModel = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CollectionModel) m_CollectionModel->SetParent(m_myself.getPointer());
		if (m_CollectionModel && m_CollectionModel->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:CollectionModelType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CollectionModel->UseTypeAttribute = true;
		}
		if(m_CollectionModel != Mp7JrsCollectionModelPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CollectionModel->SetContentName(XMLString::transcode("CollectionModel"));
		}
	// Mp7JrsFactory::DeleteObject(m_CollectionModelRef);
	m_CollectionModelRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsStructuredCollectionType_LocalType0::SetCollectionModelRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsStructuredCollectionType_LocalType0::SetCollectionModelRef().");
	}
	if (m_CollectionModelRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_CollectionModelRef);
		m_CollectionModelRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_CollectionModelRef) m_CollectionModelRef->SetParent(m_myself.getPointer());
		if (m_CollectionModelRef && m_CollectionModelRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_CollectionModelRef->UseTypeAttribute = true;
		}
		if(m_CollectionModelRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_CollectionModelRef->SetContentName(XMLString::transcode("CollectionModelRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_CollectionModel);
	m_CollectionModel = Mp7JrsCollectionModelPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: StructuredCollectionType_LocalType0: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsStructuredCollectionType_LocalType0::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsStructuredCollectionType_LocalType0::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsStructuredCollectionType_LocalType0::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsStructuredCollectionType_LocalType0::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_CollectionModel != Mp7JrsCollectionModelPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CollectionModel->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CollectionModel"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CollectionModel->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_CollectionModelRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_CollectionModelRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("CollectionModelRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_CollectionModelRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsStructuredCollectionType_LocalType0::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CollectionModel"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CollectionModel")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateCollectionModelType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCollectionModel(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("CollectionModelRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("CollectionModelRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetCollectionModelRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType0_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsStructuredCollectionType_LocalType0::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("CollectionModel")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateCollectionModelType;
    }
    this->SetCollectionModel(child);
  }
  if (XMLString::compareString(elementname, X("CollectionModelRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetCollectionModelRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsStructuredCollectionType_LocalType0::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetCollectionModel() != Mp7JrsNodePtr())
		result.Insert(GetCollectionModel());
	if (GetCollectionModelRef() != Mp7JrsNodePtr())
		result.Insert(GetCollectionModelRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsStructuredCollectionType_LocalType0_ExtMethodImpl.h


