 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtImplInclude.h



#include "Mp7JrsDSType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrszeroToOneType.h"
#include "Mp7JrsIDREFS.h"
#include "Mp7JrsSummarySegmentGroupType_Name_CollectionType.h"
#include "Mp7JrsSummarySegmentGroupType_Caption_CollectionType.h"
#include "Mp7JrsSummarySegmentGroupType_CollectionType.h"
#include "Mp7JrsSummarySegmentGroupType_CollectionType0.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsSummarySegmentGroupType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsTextualType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Name
#include "Mp7JrsSummarySegmentGroupType_LocalType.h" // Choice collection SummarySegment
#include "Mp7JrsSummarySegmentType.h" // Choice collection element SummarySegment
#include "Mp7JrsReferenceType.h" // Choice collection element SummarySegmentRef
#include "Mp7JrsSummarySegmentGroupType_LocalType0.h" // Choice collection SummarySegmentGroup
#include "Mp7JrsSummarySegmentGroupType.h" // Choice collection element SummarySegmentGroup

#include <assert.h>
IMp7JrsSummarySegmentGroupType::IMp7JrsSummarySegmentGroupType()
{

// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtPropInit.h

}

IMp7JrsSummarySegmentGroupType::~IMp7JrsSummarySegmentGroupType()
{
// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtPropCleanup.h

}

Mp7JrsSummarySegmentGroupType::Mp7JrsSummarySegmentGroupType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSummarySegmentGroupType::~Mp7JrsSummarySegmentGroupType()
{
	Cleanup();
}

void Mp7JrsSummarySegmentGroupType::Init()
{
	// Init base
	m_Base = CreateDSType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_level = 0; // Value
	m_level_Exist = false;
	m_duration = Mp7JrsmediaDurationPtr(); // Pattern
	m_duration_Exist = false;
	m_numOfKeyFrames = 0; // Value
	m_numOfKeyFrames_Exist = false;
	m_fidelity = CreatezeroToOneType; // Create a valid class
	m_fidelity->SetContent(0.0); // Use Value initialiser (xxx2)
	m_fidelity_Exist = false;
	m_themeIDs = Mp7JrsIDREFSPtr(); // Collection
	m_themeIDs_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_Name = Mp7JrsSummarySegmentGroupType_Name_CollectionPtr(); // Collection
	m_Caption = Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr(); // Collection
	m_SummarySegmentGroupType_LocalType = Mp7JrsSummarySegmentGroupType_CollectionPtr(); // Collection
	m_SummarySegmentGroupType_LocalType0 = Mp7JrsSummarySegmentGroupType_Collection0Ptr(); // Collection


// begin extension included
// file Mp7JrsSummarySegmentGroupType_ExtMyPropInit.h

	// create empty name and caption collections
	m_Name = CreateSummarySegmentGroupType_Name_CollectionType;
	m_Caption = CreateSummarySegmentGroupType_Caption_CollectionType;

	// fidelity
	m_fidelity = CreatezeroToOneType;
	m_fidelity->SetContent(0.0);
// end extension included

}

void Mp7JrsSummarySegmentGroupType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	// Mp7JrsFactory::DeleteObject(m_duration); 
	// Mp7JrsFactory::DeleteObject(m_fidelity);
	// Mp7JrsFactory::DeleteObject(m_themeIDs);
	// Mp7JrsFactory::DeleteObject(m_Name);
	// Mp7JrsFactory::DeleteObject(m_Caption);
	// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupType_LocalType);
	// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupType_LocalType0);
}

void Mp7JrsSummarySegmentGroupType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SummarySegmentGroupTypePtr, since we
	// might need GetBase(), which isn't defined in ISummarySegmentGroupType
    const Mp7JrsPtr< Mp7JrsSummarySegmentGroupType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsDSPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSummarySegmentGroupType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	if (tmp->Existlevel())
	{
		this->Setlevel(tmp->Getlevel());
	}
	else
	{
		Invalidatelevel();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_duration); 
	if (tmp->Existduration())
	{
		this->Setduration(Mp7JrsFactory::CloneObject(tmp->Getduration()));
	}
	else
	{
		Invalidateduration();
	}
	}
	{
	if (tmp->ExistnumOfKeyFrames())
	{
		this->SetnumOfKeyFrames(tmp->GetnumOfKeyFrames());
	}
	else
	{
		InvalidatenumOfKeyFrames();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_fidelity);
	if (tmp->Existfidelity())
	{
		this->Setfidelity(Mp7JrsFactory::CloneObject(tmp->Getfidelity()));
	}
	else
	{
		Invalidatefidelity();
	}
	}
	{
	// Mp7JrsFactory::DeleteObject(m_themeIDs);
	if (tmp->ExistthemeIDs())
	{
		this->SetthemeIDs(Mp7JrsFactory::CloneObject(tmp->GetthemeIDs()));
	}
	else
	{
		InvalidatethemeIDs();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_Name);
		this->SetName(Mp7JrsFactory::CloneObject(tmp->GetName()));
		// Mp7JrsFactory::DeleteObject(m_Caption);
		this->SetCaption(Mp7JrsFactory::CloneObject(tmp->GetCaption()));
		// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupType_LocalType);
		this->SetSummarySegmentGroupType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetSummarySegmentGroupType_LocalType()));
		// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupType_LocalType0);
		this->SetSummarySegmentGroupType_LocalType0(Mp7JrsFactory::CloneObject(tmp->GetSummarySegmentGroupType_LocalType0()));
}

Mp7JrsNodePtr Mp7JrsSummarySegmentGroupType::GetBaseRoot()
{
	return GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSummarySegmentGroupType::GetBaseRoot() const
{
	return GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsDSType > Mp7JrsSummarySegmentGroupType::GetBase() const
{
	return m_Base;
}

int Mp7JrsSummarySegmentGroupType::Getlevel() const
{
	return m_level;
}

bool Mp7JrsSummarySegmentGroupType::Existlevel() const
{
	return m_level_Exist;
}
void Mp7JrsSummarySegmentGroupType::Setlevel(int item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::Setlevel().");
	}
    m_level = item;
	m_level_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::Invalidatelevel()
{
	m_level_Exist = false;
}
Mp7JrsmediaDurationPtr Mp7JrsSummarySegmentGroupType::Getduration() const
{
	return m_duration;
}

bool Mp7JrsSummarySegmentGroupType::Existduration() const
{
	return m_duration_Exist;
}
void Mp7JrsSummarySegmentGroupType::Setduration(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::Setduration().");
	}
    m_duration = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_duration) m_duration->SetParent(m_myself.getPointer());
	m_duration_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::Invalidateduration()
{
	m_duration_Exist = false;
}
unsigned Mp7JrsSummarySegmentGroupType::GetnumOfKeyFrames() const
{
	return m_numOfKeyFrames;
}

bool Mp7JrsSummarySegmentGroupType::ExistnumOfKeyFrames() const
{
	return m_numOfKeyFrames_Exist;
}
void Mp7JrsSummarySegmentGroupType::SetnumOfKeyFrames(unsigned item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetnumOfKeyFrames().");
	}
    m_numOfKeyFrames = item;
	m_numOfKeyFrames_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::InvalidatenumOfKeyFrames()
{
	m_numOfKeyFrames_Exist = false;
}
Mp7JrszeroToOnePtr Mp7JrsSummarySegmentGroupType::Getfidelity() const
{
	return m_fidelity;
}

bool Mp7JrsSummarySegmentGroupType::Existfidelity() const
{
	return m_fidelity_Exist;
}
void Mp7JrsSummarySegmentGroupType::Setfidelity(const Mp7JrszeroToOnePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::Setfidelity().");
	}
    m_fidelity = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_fidelity) m_fidelity->SetParent(m_myself.getPointer());
	m_fidelity_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::Invalidatefidelity()
{
	m_fidelity_Exist = false;
}
Mp7JrsIDREFSPtr Mp7JrsSummarySegmentGroupType::GetthemeIDs() const
{
	return m_themeIDs;
}

bool Mp7JrsSummarySegmentGroupType::ExistthemeIDs() const
{
	return m_themeIDs_Exist;
}
void Mp7JrsSummarySegmentGroupType::SetthemeIDs(const Mp7JrsIDREFSPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetthemeIDs().");
	}
    m_themeIDs = item;
	// baw 27 04 2004: make sure that node on which parent is set is not null
	if (m_themeIDs) m_themeIDs->SetParent(m_myself.getPointer());
	m_themeIDs_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::InvalidatethemeIDs()
{
	m_themeIDs_Exist = false;
}
Mp7JrsSummarySegmentGroupType_Name_CollectionPtr Mp7JrsSummarySegmentGroupType::GetName() const
{
	return m_Name;
}

Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr Mp7JrsSummarySegmentGroupType::GetCaption() const
{
	return m_Caption;
}

Mp7JrsSummarySegmentGroupType_CollectionPtr Mp7JrsSummarySegmentGroupType::GetSummarySegmentGroupType_LocalType() const
{
	return m_SummarySegmentGroupType_LocalType;
}

Mp7JrsSummarySegmentGroupType_Collection0Ptr Mp7JrsSummarySegmentGroupType::GetSummarySegmentGroupType_LocalType0() const
{
	return m_SummarySegmentGroupType_LocalType0;
}

void Mp7JrsSummarySegmentGroupType::SetName(const Mp7JrsSummarySegmentGroupType_Name_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetName().");
	}
	if (m_Name != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Name);
		m_Name = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Name) m_Name->SetParent(m_myself.getPointer());
		if(m_Name != Mp7JrsSummarySegmentGroupType_Name_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Name->SetContentName(XMLString::transcode("Name"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::SetCaption(const Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetCaption().");
	}
	if (m_Caption != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Caption);
		m_Caption = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Caption) m_Caption->SetParent(m_myself.getPointer());
		if(m_Caption != Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Caption->SetContentName(XMLString::transcode("Caption"));
		}
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::SetSummarySegmentGroupType_LocalType(const Mp7JrsSummarySegmentGroupType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetSummarySegmentGroupType_LocalType().");
	}
	if (m_SummarySegmentGroupType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupType_LocalType);
		m_SummarySegmentGroupType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SummarySegmentGroupType_LocalType) m_SummarySegmentGroupType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::SetSummarySegmentGroupType_LocalType0(const Mp7JrsSummarySegmentGroupType_Collection0Ptr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetSummarySegmentGroupType_LocalType0().");
	}
	if (m_SummarySegmentGroupType_LocalType0 != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SummarySegmentGroupType_LocalType0);
		m_SummarySegmentGroupType_LocalType0 = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SummarySegmentGroupType_LocalType0) m_SummarySegmentGroupType_LocalType0->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSummarySegmentGroupType::Getid() const
{
	return GetBase()->Getid();
}

bool Mp7JrsSummarySegmentGroupType::Existid() const
{
	return GetBase()->Existid();
}
void Mp7JrsSummarySegmentGroupType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::Setid().");
	}
	GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::Invalidateid()
{
	GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsSummarySegmentGroupType::GettimeBase() const
{
	return GetBase()->GettimeBase();
}

bool Mp7JrsSummarySegmentGroupType::ExisttimeBase() const
{
	return GetBase()->ExisttimeBase();
}
void Mp7JrsSummarySegmentGroupType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SettimeBase().");
	}
	GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::InvalidatetimeBase()
{
	GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsSummarySegmentGroupType::GettimeUnit() const
{
	return GetBase()->GettimeUnit();
}

bool Mp7JrsSummarySegmentGroupType::ExisttimeUnit() const
{
	return GetBase()->ExisttimeUnit();
}
void Mp7JrsSummarySegmentGroupType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SettimeUnit().");
	}
	GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::InvalidatetimeUnit()
{
	GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsSummarySegmentGroupType::GetmediaTimeBase() const
{
	return GetBase()->GetmediaTimeBase();
}

bool Mp7JrsSummarySegmentGroupType::ExistmediaTimeBase() const
{
	return GetBase()->ExistmediaTimeBase();
}
void Mp7JrsSummarySegmentGroupType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetmediaTimeBase().");
	}
	GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::InvalidatemediaTimeBase()
{
	GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsSummarySegmentGroupType::GetmediaTimeUnit() const
{
	return GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsSummarySegmentGroupType::ExistmediaTimeUnit() const
{
	return GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsSummarySegmentGroupType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetmediaTimeUnit().");
	}
	GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSummarySegmentGroupType::InvalidatemediaTimeUnit()
{
	GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsSummarySegmentGroupType::GetHeader() const
{
	return GetBase()->GetHeader();
}

void Mp7JrsSummarySegmentGroupType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSummarySegmentGroupType::SetHeader().");
	}
	GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSummarySegmentGroupType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Name")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Name is item of type TextualType
		// in element collection SummarySegmentGroupType_Name_CollectionType
		
		context->Found = true;
		Mp7JrsSummarySegmentGroupType_Name_CollectionPtr coll = GetName();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSummarySegmentGroupType_Name_CollectionType;
				SetName(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextualPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Caption")) == 0)
	{
		// urn:mpeg:mpeg7:schema:2004:Caption is item of type TextualType
		// in element collection SummarySegmentGroupType_Caption_CollectionType
		
		context->Found = true;
		Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr coll = GetCaption();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSummarySegmentGroupType_Caption_CollectionType;
				SetCaption(coll, client);
			}
			else
			{
				return result; // No collection, silently return empty enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = coll->elementAt(i)) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				 Mp7JrsXPathParseContext::ErrorInvalidEmptyItem(context, i);
			}
		}
		
		if(Mp7JrsXPathParseContext::PostProcessElementCollection(context, i, result))
		{
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:TextualType")))) != empty)
			{
				// Is type allowed
				Mp7JrsTextualPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Mp7JrsUnkown" type is allowed
				{
					coll->insertElementAt(p, i, client); // Insert or append
					if((p = coll->elementAt(i)) != empty) // Maybe some other restrictions are waiting...
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;
		
	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SummarySegment")) == 0)
	{
		// SummarySegment is contained in itemtype SummarySegmentGroupType_LocalType
		// in choice collection SummarySegmentGroupType_CollectionType
		
		context->Found = true;
		Mp7JrsSummarySegmentGroupType_CollectionPtr coll = GetSummarySegmentGroupType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSummarySegmentGroupType_CollectionType;
				SetSummarySegmentGroupType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSummarySegmentGroupType_LocalPtr)coll->elementAt(i))->GetSummarySegment()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSummarySegmentGroupType_LocalPtr item = CreateSummarySegmentGroupType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SummarySegmentType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSummarySegmentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSummarySegmentGroupType_LocalPtr)coll->elementAt(i))->SetSummarySegment(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSummarySegmentGroupType_LocalPtr)coll->elementAt(i))->GetSummarySegment()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SummarySegmentRef")) == 0)
	{
		// SummarySegmentRef is contained in itemtype SummarySegmentGroupType_LocalType
		// in choice collection SummarySegmentGroupType_CollectionType
		
		context->Found = true;
		Mp7JrsSummarySegmentGroupType_CollectionPtr coll = GetSummarySegmentGroupType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSummarySegmentGroupType_CollectionType;
				SetSummarySegmentGroupType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSummarySegmentGroupType_LocalPtr)coll->elementAt(i))->GetSummarySegmentRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSummarySegmentGroupType_LocalPtr item = CreateSummarySegmentGroupType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSummarySegmentGroupType_LocalPtr)coll->elementAt(i))->SetSummarySegmentRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSummarySegmentGroupType_LocalPtr)coll->elementAt(i))->GetSummarySegmentRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SummarySegmentGroup")) == 0)
	{
		// SummarySegmentGroup is contained in itemtype SummarySegmentGroupType_LocalType0
		// in choice collection SummarySegmentGroupType_CollectionType0
		
		context->Found = true;
		Mp7JrsSummarySegmentGroupType_Collection0Ptr coll = GetSummarySegmentGroupType_LocalType0();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSummarySegmentGroupType_CollectionType0;
				SetSummarySegmentGroupType_LocalType0(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSummarySegmentGroupType_Local0Ptr)coll->elementAt(i))->GetSummarySegmentGroup()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSummarySegmentGroupType_Local0Ptr item = CreateSummarySegmentGroupType_LocalType0;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SummarySegmentGroupType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSummarySegmentGroupPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSummarySegmentGroupType_Local0Ptr)coll->elementAt(i))->SetSummarySegmentGroup(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSummarySegmentGroupType_Local0Ptr)coll->elementAt(i))->GetSummarySegmentGroup()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("SummarySegmentGroupRef")) == 0)
	{
		// SummarySegmentGroupRef is contained in itemtype SummarySegmentGroupType_LocalType0
		// in choice collection SummarySegmentGroupType_CollectionType0
		
		context->Found = true;
		Mp7JrsSummarySegmentGroupType_Collection0Ptr coll = GetSummarySegmentGroupType_LocalType0();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSummarySegmentGroupType_CollectionType0;
				SetSummarySegmentGroupType_LocalType0(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSummarySegmentGroupType_Local0Ptr)coll->elementAt(i))->GetSummarySegmentGroupRef()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSummarySegmentGroupType_Local0Ptr item = CreateSummarySegmentGroupType_LocalType0;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType")))) != empty)
			{
				// Is type allowed
				Mp7JrsReferencePtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSummarySegmentGroupType_Local0Ptr)coll->elementAt(i))->SetSummarySegmentGroupRef(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSummarySegmentGroupType_Local0Ptr)coll->elementAt(i))->GetSummarySegmentGroupRef()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SummarySegmentGroupType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SummarySegmentGroupType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSummarySegmentGroupType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSummarySegmentGroupType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSummarySegmentGroupType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SummarySegmentGroupType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_level_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_level);
		element->setAttributeNS(X(""), X("level"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_duration_Exist)
	{
	// Pattern
	if (m_duration != Mp7JrsmediaDurationPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_duration->ToText();
		element->setAttributeNS(X(""), X("duration"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_numOfKeyFrames_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_numOfKeyFrames);
		element->setAttributeNS(X(""), X("numOfKeyFrames"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_fidelity_Exist)
	{
	// Class
	if (m_fidelity != Mp7JrszeroToOnePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		XMLCh * tmp = m_fidelity->ToText();
		element->setAttributeNS(X(""), X("fidelity"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_themeIDs_Exist)
	{
	// Collection
	if(m_themeIDs != Mp7JrsIDREFSPtr())
	{
		XMLCh * tmp = m_themeIDs->ToText();
		element->setAttributeNS(X(""), X("themeIDs"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_Name != Mp7JrsSummarySegmentGroupType_Name_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Name->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_Caption != Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_Caption->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_SummarySegmentGroupType_LocalType != Mp7JrsSummarySegmentGroupType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SummarySegmentGroupType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}
	if (m_SummarySegmentGroupType_LocalType0 != Mp7JrsSummarySegmentGroupType_Collection0Ptr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SummarySegmentGroupType_LocalType0->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSummarySegmentGroupType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("level")))
	{
        // deserialize value type
        this->Setlevel(Mp7JrsConvert::TextToInt(parent->getAttributeNS(X(""), X("level"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("level")))
	{
        // deserialize value type
        this->Setlevel(Mp7JrsConvert::TextToInt(parent->getAttribute(X("level"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("duration")))
	{
        Mp7JrsmediaDurationPtr tmp = CreatemediaDurationType;
        tmp->Parse(parent->getAttributeNS(X(""), X("duration")));
        this->Setduration(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("duration")))
	{
        Mp7JrsmediaDurationPtr tmp = CreatemediaDurationType;
        tmp->Parse(parent->getAttribute(X("duration")));
        this->Setduration(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("numOfKeyFrames")))
	{
        // deserialize value type
        this->SetnumOfKeyFrames(Mp7JrsConvert::TextToUnsignedInt(parent->getAttributeNS(X(""), X("numOfKeyFrames"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("numOfKeyFrames")))
	{
        // deserialize value type
        this->SetnumOfKeyFrames(Mp7JrsConvert::TextToUnsignedInt(parent->getAttribute(X("numOfKeyFrames"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("fidelity")))
	{
        // Deserialize class type
		Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
		tmp->Parse(parent->getAttributeNS(X(""), X("fidelity")));
        this->Setfidelity(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("fidelity")))
	{
		// Deserialize class type
        Mp7JrszeroToOnePtr tmp = CreatezeroToOneType;
        tmp->Parse(parent->getAttribute(X("fidelity")));
        this->Setfidelity(tmp);
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("themeIDs")))
	{
        // Deserialize collection type
		Mp7JrsIDREFSPtr tmp = CreateIDREFS;
		tmp->Parse(parent->getAttributeNS(X(""), X("themeIDs")));
        this->SetthemeIDs(tmp);
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("themeIDs")))
	{
     
		// Deserialize collection type
        Mp7JrsIDREFSPtr tmp = CreateIDREFS;
        tmp->Parse(parent->getAttribute(X("themeIDs")));
        this->SetthemeIDs(tmp);
        * current = parent;
    }

	// Extensionbase is Mp7JrsDSType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Name"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Name")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSummarySegmentGroupType_Name_CollectionPtr tmp = CreateSummarySegmentGroupType_Name_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetName(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        
        // Element Collection
        if((parent != NULL) && 
        Mp7JrsUtil::HasNodeName(parent, X("Caption"), X("urn:mpeg:mpeg7:schema:2004")))
// OLD        (XMLString::compareString(parent->getNodeName(), X("Caption")) == 0))
        {
            // Deserialize factory type
            Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr tmp = CreateSummarySegmentGroupType_Caption_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetCaption(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:SummarySegment
            Mp7JrsUtil::HasNodeName(parent, X("SummarySegment"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SummarySegment")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:SummarySegmentRef
            Mp7JrsUtil::HasNodeName(parent, X("SummarySegmentRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SummarySegmentRef")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsSummarySegmentGroupType_CollectionPtr tmp = CreateSummarySegmentGroupType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSummarySegmentGroupType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:SummarySegmentGroup
            Mp7JrsUtil::HasNodeName(parent, X("SummarySegmentGroup"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SummarySegmentGroup")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:SummarySegmentGroupRef
            Mp7JrsUtil::HasNodeName(parent, X("SummarySegmentGroupRef"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:SummarySegmentGroupRef")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsSummarySegmentGroupType_Collection0Ptr tmp = CreateSummarySegmentGroupType_CollectionType0;
            tmp->Deserialize(doc, parent, current);
            this->SetSummarySegmentGroupType_LocalType0(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSummarySegmentGroupType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSummarySegmentGroupType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Name")) == 0))
  {
    Mp7JrsSummarySegmentGroupType_Name_CollectionPtr tmp = CreateSummarySegmentGroupType_Name_CollectionType;
    this->SetName(tmp);
    child = tmp;
  }
  // Non-Choice Collection
  if((XMLString::compareString(elementname, X("Caption")) == 0))
  {
    Mp7JrsSummarySegmentGroupType_Caption_CollectionPtr tmp = CreateSummarySegmentGroupType_Caption_CollectionType;
    this->SetCaption(tmp);
    child = tmp;
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("SummarySegment"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("SummarySegment")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("SummarySegmentRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("SummarySegmentRef")) == 0)
    )
  {
    Mp7JrsSummarySegmentGroupType_CollectionPtr tmp = CreateSummarySegmentGroupType_CollectionType;
    this->SetSummarySegmentGroupType_LocalType(tmp);
    child = tmp;
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("SummarySegmentGroup"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("SummarySegmentGroup")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("SummarySegmentGroupRef"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("SummarySegmentGroupRef")) == 0)
    )
  {
    Mp7JrsSummarySegmentGroupType_Collection0Ptr tmp = CreateSummarySegmentGroupType_CollectionType0;
    this->SetSummarySegmentGroupType_LocalType0(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSummarySegmentGroupType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetName() != Mp7JrsNodePtr())
		result.Insert(GetName());
	if (GetCaption() != Mp7JrsNodePtr())
		result.Insert(GetCaption());
	if (GetSummarySegmentGroupType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSummarySegmentGroupType_LocalType());
	if (GetSummarySegmentGroupType_LocalType0() != Mp7JrsNodePtr())
		result.Insert(GetSummarySegmentGroupType_LocalType0());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// begin extension included
// file Mp7JrsSummarySegmentGroupType_ExtMethodImpl.h

#include "Mp7JrsTextualType.h"
#include "Mp7JrsSummarySegmentType.h"
#include "Mp7JrsSummarySegmentGroupType.h"
#include "Mp7JrsSummarySegmentGroupType_LocalType.h"
#include "Mp7JrsSummarySegmentGroupType_LocalType0.h"

#include "Mp7JrsSummarySegmentGroupType_Name_CollectionType.h"
#include "Mp7JrsSummarySegmentGroupType_Caption_CollectionType.h"
#include "Mp7JrsTextualBaseType.h"


void IMp7JrsSummarySegmentGroupType::AddSegment(Mp7JrsSummarySegmentPtr segment, Mp7JrsClientID client) {
	if (GetSummarySegmentGroupType_LocalType()==NULL) 
		SetSummarySegmentGroupType_LocalType(CreateSummarySegmentGroupType_CollectionType,client);
	Mp7JrsSummarySegmentGroupType_LocalPtr segLocal = CreateSummarySegmentGroupType_LocalType;
	segLocal->SetSummarySegment(segment,client);
	GetSummarySegmentGroupType_LocalType()->addElement(segLocal,client);
}

int IMp7JrsSummarySegmentGroupType::GetNrSegments() {
	if (GetSummarySegmentGroupType_LocalType()==NULL) return 0;
	else return GetSummarySegmentGroupType_LocalType()->size();

}

void IMp7JrsSummarySegmentGroupType::AddSegmentGroup(Mp7JrsSummarySegmentGroupPtr segment, Mp7JrsClientID client) {
	if (GetSummarySegmentGroupType_LocalType0()==NULL) 
		SetSummarySegmentGroupType_LocalType0(CreateSummarySegmentGroupType_CollectionType0,client);
	Mp7JrsSummarySegmentGroupType_Local0Ptr grpLocal = CreateSummarySegmentGroupType_LocalType0;
	grpLocal->SetSummarySegmentGroup(segment,client);
	GetSummarySegmentGroupType_LocalType0()->addElement(grpLocal,client);
}


int IMp7JrsSummarySegmentGroupType::GetNrSegmentGroups() {
	if (GetSummarySegmentGroupType_LocalType0()==NULL) return 0;
	else return GetSummarySegmentGroupType_LocalType0()->size();
}


void IMp7JrsSummarySegmentGroupType::AddName(XMLCh* name, Mp7JrsClientID client) {
	Mp7JrsTextualPtr text = CreateTextualType;
	text->SetContent(name,client);
	GetName()->addElement(text);
}

void IMp7JrsSummarySegmentGroupType::AddCaption(XMLCh* caption, Mp7JrsClientID client) {
	Mp7JrsTextualPtr text = CreateTextualType;
	text->SetContent(caption,client);
	GetCaption()->addElement(text,client);
}

////

void IMp7JrsSummarySegmentGroupType::Setfidelity(float fid, Mp7JrsClientID client) {
	Getfidelity()->SetContent(fid,client);
}

// end extension included


