 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_ExtImplInclude.h



#include "Mp7JrsLinguisticEntityType.h"
#include "Mp7JrsSyntacticConstituentType_CollectionType.h"
#include "Mp7JrsLinguisticEntityType_start_LocalType.h"
#include "Mp7JrsLinguisticEntityType_length_LocalType.h"
#include "Mp7JrstermReferenceType.h"
#include "Mp7JrstermReferenceListType.h"
#include "Mp7JrsLinguisticEntityType_edit_LocalType.h"
#include "Mp7JrsLinguisticEntityType_MediaLocator_CollectionType.h"
#include "Mp7JrsLinguisticEntityType_Relation_CollectionType.h"
#include "Mp7JrsxPathRefType.h"
#include "Mp7JrsdurationType.h"
#include "Mp7JrsmediaDurationType.h"
#include "Mp7JrsDSType_Header_CollectionType.h"
#include "Mp7JrsSyntacticConstituentType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"
#include "Mp7JrsHeaderType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Header
#include "Mp7JrsMediaLocatorType.h" // Element collection urn:mpeg:mpeg7:schema:2004:MediaLocator
#include "Mp7JrsGeneralRelationType.h" // Element collection urn:mpeg:mpeg7:schema:2004:Relation
#include "Mp7JrsSyntacticConstituentType_LocalType.h" // Choice collection Head
#include "Mp7JrsSyntacticConstituentType.h" // Choice collection element Head
#include "Mp7JrsLinguisticDocumentType.h" // Choice collection element Quotation

#include <assert.h>
IMp7JrsSyntacticConstituentType::IMp7JrsSyntacticConstituentType()
{

// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_ExtPropInit.h

}

IMp7JrsSyntacticConstituentType::~IMp7JrsSyntacticConstituentType()
{
// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_ExtPropCleanup.h

}

Mp7JrsSyntacticConstituentType::Mp7JrsSyntacticConstituentType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSyntacticConstituentType::~Mp7JrsSyntacticConstituentType()
{
	Cleanup();
}

void Mp7JrsSyntacticConstituentType::Init()
{
	// Init base
	m_Base = CreateLinguisticEntityType;
	m_Base->m_myself = m_myself.getPointer();
	

	// Init attributes
	m_baseForm = NULL; // String
	m_baseForm_Exist = false;
	m_synthesis = Mp7JrssynthesisType::UninitializedEnumeration;
// old	m_synthesis = Mp7JrssynthesisType::Enumeration::;
// old	m_synthesis_Default = Mp7JrssynthesisType::Enumeration::dependency;
	m_synthesis_Default = Mp7JrssynthesisType::dependency;
	m_synthesis_Exist = false;
	m_functionWord = NULL; // String
	m_functionWord_Exist = false;

	// Init elements (element, union sequence choice all any)
	
	m_SyntacticConstituentType_LocalType = Mp7JrsSyntacticConstituentType_CollectionPtr(); // Collection


// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_ExtMyPropInit.h

}

void Mp7JrsSyntacticConstituentType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Base);
	XMLString::release(&m_baseForm);
	XMLString::release(&m_functionWord);
	// Mp7JrsFactory::DeleteObject(m_SyntacticConstituentType_LocalType);
}

void Mp7JrsSyntacticConstituentType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SyntacticConstituentTypePtr, since we
	// might need GetBase(), which isn't defined in ISyntacticConstituentType
    const Mp7JrsPtr< Mp7JrsSyntacticConstituentType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	// Mp7JrsFactory::DeleteObject(m_Base);
	// FIXME: won't work with derived types
	m_Base = Mp7JrsFactory::CloneObject(tmp->GetBase());
//      m_Base = Mp7JrsLinguisticEntityPtr(Mp7JrsFactory::CloneObject((dynamic_cast< const Mp7JrsSyntacticConstituentType *>(&original))->GetBase().Ptr())); // XXX version pre-smartptr-factory
	{
	XMLString::release(&m_baseForm);
	if (tmp->ExistbaseForm())
	{
		this->SetbaseForm(XMLString::replicate(tmp->GetbaseForm()));
	}
	else
	{
		InvalidatebaseForm();
	}
	}
	{
	if (tmp->Existsynthesis())
	{
		this->Setsynthesis(tmp->Getsynthesis());
	}
	else
	{
		Invalidatesynthesis();
	}
	}
	{
	XMLString::release(&m_functionWord);
	if (tmp->ExistfunctionWord())
	{
		this->SetfunctionWord(XMLString::replicate(tmp->GetfunctionWord()));
	}
	else
	{
		InvalidatefunctionWord();
	}
	}
		// Mp7JrsFactory::DeleteObject(m_SyntacticConstituentType_LocalType);
		this->SetSyntacticConstituentType_LocalType(Mp7JrsFactory::CloneObject(tmp->GetSyntacticConstituentType_LocalType()));
}

Mp7JrsNodePtr Mp7JrsSyntacticConstituentType::GetBaseRoot()
{
	return GetBase()->GetBase()->GetBase();
}

const Mp7JrsNodePtr Mp7JrsSyntacticConstituentType::GetBaseRoot() const
{
	return GetBase()->GetBase()->GetBase();
}


Mp7JrsPtr< Mp7JrsLinguisticEntityType > Mp7JrsSyntacticConstituentType::GetBase() const
{
	return m_Base;
}

XMLCh * Mp7JrsSyntacticConstituentType::GetbaseForm() const
{
	return m_baseForm;
}

bool Mp7JrsSyntacticConstituentType::ExistbaseForm() const
{
	return m_baseForm_Exist;
}
void Mp7JrsSyntacticConstituentType::SetbaseForm(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetbaseForm().");
	}
    m_baseForm = item;
	m_baseForm_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidatebaseForm()
{
	m_baseForm_Exist = false;
}
Mp7JrssynthesisType::Enumeration Mp7JrsSyntacticConstituentType::Getsynthesis() const
{
	if (this->Existsynthesis()) {
		return m_synthesis;
	} else {
		return m_synthesis_Default;
	}
}

bool Mp7JrsSyntacticConstituentType::Existsynthesis() const
{
	return m_synthesis_Exist;
}
void Mp7JrsSyntacticConstituentType::Setsynthesis(Mp7JrssynthesisType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setsynthesis().");
	}
    m_synthesis = item;
	m_synthesis_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatesynthesis()
{
	m_synthesis_Exist = false;
}
XMLCh * Mp7JrsSyntacticConstituentType::GetfunctionWord() const
{
	return m_functionWord;
}

bool Mp7JrsSyntacticConstituentType::ExistfunctionWord() const
{
	return m_functionWord_Exist;
}
void Mp7JrsSyntacticConstituentType::SetfunctionWord(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetfunctionWord().");
	}
    m_functionWord = item;
	m_functionWord_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidatefunctionWord()
{
	m_functionWord_Exist = false;
}
Mp7JrsSyntacticConstituentType_CollectionPtr Mp7JrsSyntacticConstituentType::GetSyntacticConstituentType_LocalType() const
{
	return m_SyntacticConstituentType_LocalType;
}

void Mp7JrsSyntacticConstituentType::SetSyntacticConstituentType_LocalType(const Mp7JrsSyntacticConstituentType_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetSyntacticConstituentType_LocalType().");
	}
	if (m_SyntacticConstituentType_LocalType != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SyntacticConstituentType_LocalType);
		m_SyntacticConstituentType_LocalType = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SyntacticConstituentType_LocalType) m_SyntacticConstituentType_LocalType->SetParent(m_myself.getPointer());
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSyntacticConstituentType::Getlang() const
{
	return GetBase()->Getlang();
}

bool Mp7JrsSyntacticConstituentType::Existlang() const
{
	return GetBase()->Existlang();
}
void Mp7JrsSyntacticConstituentType::Setlang(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setlang().");
	}
	GetBase()->Setlang(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatelang()
{
	GetBase()->Invalidatelang();
}
Mp7JrsLinguisticEntityType_start_LocalPtr Mp7JrsSyntacticConstituentType::Getstart() const
{
	return GetBase()->Getstart();
}

bool Mp7JrsSyntacticConstituentType::Existstart() const
{
	return GetBase()->Existstart();
}
void Mp7JrsSyntacticConstituentType::Setstart(const Mp7JrsLinguisticEntityType_start_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setstart().");
	}
	GetBase()->Setstart(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatestart()
{
	GetBase()->Invalidatestart();
}
Mp7JrsLinguisticEntityType_length_LocalPtr Mp7JrsSyntacticConstituentType::Getlength() const
{
	return GetBase()->Getlength();
}

bool Mp7JrsSyntacticConstituentType::Existlength() const
{
	return GetBase()->Existlength();
}
void Mp7JrsSyntacticConstituentType::Setlength(const Mp7JrsLinguisticEntityType_length_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setlength().");
	}
	GetBase()->Setlength(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatelength()
{
	GetBase()->Invalidatelength();
}
Mp7JrstermReferencePtr Mp7JrsSyntacticConstituentType::Gettype() const
{
	return GetBase()->Gettype();
}

bool Mp7JrsSyntacticConstituentType::Existtype() const
{
	return GetBase()->Existtype();
}
void Mp7JrsSyntacticConstituentType::Settype(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Settype().");
	}
	GetBase()->Settype(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatetype()
{
	GetBase()->Invalidatetype();
}
Mp7JrstermReferencePtr Mp7JrsSyntacticConstituentType::Getdepend() const
{
	return GetBase()->Getdepend();
}

bool Mp7JrsSyntacticConstituentType::Existdepend() const
{
	return GetBase()->Existdepend();
}
void Mp7JrsSyntacticConstituentType::Setdepend(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setdepend().");
	}
	GetBase()->Setdepend(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatedepend()
{
	GetBase()->Invalidatedepend();
}
Mp7JrstermReferenceListPtr Mp7JrsSyntacticConstituentType::Getequal() const
{
	return GetBase()->Getequal();
}

bool Mp7JrsSyntacticConstituentType::Existequal() const
{
	return GetBase()->Existequal();
}
void Mp7JrsSyntacticConstituentType::Setequal(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setequal().");
	}
	GetBase()->Setequal(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidateequal()
{
	GetBase()->Invalidateequal();
}
Mp7JrstermReferenceListPtr Mp7JrsSyntacticConstituentType::Getsemantics() const
{
	return GetBase()->Getsemantics();
}

bool Mp7JrsSyntacticConstituentType::Existsemantics() const
{
	return GetBase()->Existsemantics();
}
void Mp7JrsSyntacticConstituentType::Setsemantics(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setsemantics().");
	}
	GetBase()->Setsemantics(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatesemantics()
{
	GetBase()->Invalidatesemantics();
}
Mp7JrstermReferenceListPtr Mp7JrsSyntacticConstituentType::GetcompoundSemantics() const
{
	return GetBase()->GetcompoundSemantics();
}

bool Mp7JrsSyntacticConstituentType::ExistcompoundSemantics() const
{
	return GetBase()->ExistcompoundSemantics();
}
void Mp7JrsSyntacticConstituentType::SetcompoundSemantics(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetcompoundSemantics().");
	}
	GetBase()->SetcompoundSemantics(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidatecompoundSemantics()
{
	GetBase()->InvalidatecompoundSemantics();
}
Mp7JrstermReferenceListPtr Mp7JrsSyntacticConstituentType::Getoperator() const
{
	return GetBase()->Getoperator();
}

bool Mp7JrsSyntacticConstituentType::Existoperator() const
{
	return GetBase()->Existoperator();
}
void Mp7JrsSyntacticConstituentType::Setoperator(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setoperator().");
	}
	GetBase()->Setoperator(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidateoperator()
{
	GetBase()->Invalidateoperator();
}
Mp7JrstermReferenceListPtr Mp7JrsSyntacticConstituentType::Getcopy() const
{
	return GetBase()->Getcopy();
}

bool Mp7JrsSyntacticConstituentType::Existcopy() const
{
	return GetBase()->Existcopy();
}
void Mp7JrsSyntacticConstituentType::Setcopy(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setcopy().");
	}
	GetBase()->Setcopy(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatecopy()
{
	GetBase()->Invalidatecopy();
}
Mp7JrstermReferenceListPtr Mp7JrsSyntacticConstituentType::GetnoCopy() const
{
	return GetBase()->GetnoCopy();
}

bool Mp7JrsSyntacticConstituentType::ExistnoCopy() const
{
	return GetBase()->ExistnoCopy();
}
void Mp7JrsSyntacticConstituentType::SetnoCopy(const Mp7JrstermReferenceListPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetnoCopy().");
	}
	GetBase()->SetnoCopy(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidatenoCopy()
{
	GetBase()->InvalidatenoCopy();
}
Mp7JrstermReferencePtr Mp7JrsSyntacticConstituentType::Getsubstitute() const
{
	return GetBase()->Getsubstitute();
}

bool Mp7JrsSyntacticConstituentType::Existsubstitute() const
{
	return GetBase()->Existsubstitute();
}
void Mp7JrsSyntacticConstituentType::Setsubstitute(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setsubstitute().");
	}
	GetBase()->Setsubstitute(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidatesubstitute()
{
	GetBase()->Invalidatesubstitute();
}
Mp7JrstermReferencePtr Mp7JrsSyntacticConstituentType::GetinScope() const
{
	return GetBase()->GetinScope();
}

bool Mp7JrsSyntacticConstituentType::ExistinScope() const
{
	return GetBase()->ExistinScope();
}
void Mp7JrsSyntacticConstituentType::SetinScope(const Mp7JrstermReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetinScope().");
	}
	GetBase()->SetinScope(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidateinScope()
{
	GetBase()->InvalidateinScope();
}
Mp7JrsLinguisticEntityType_edit_LocalPtr Mp7JrsSyntacticConstituentType::Getedit() const
{
	return GetBase()->Getedit();
}

bool Mp7JrsSyntacticConstituentType::Existedit() const
{
	return GetBase()->Existedit();
}
void Mp7JrsSyntacticConstituentType::Setedit(const Mp7JrsLinguisticEntityType_edit_LocalPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setedit().");
	}
	GetBase()->Setedit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidateedit()
{
	GetBase()->Invalidateedit();
}
Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr Mp7JrsSyntacticConstituentType::GetMediaLocator() const
{
	return GetBase()->GetMediaLocator();
}

Mp7JrsLinguisticEntityType_Relation_CollectionPtr Mp7JrsSyntacticConstituentType::GetRelation() const
{
	return GetBase()->GetRelation();
}

void Mp7JrsSyntacticConstituentType::SetMediaLocator(const Mp7JrsLinguisticEntityType_MediaLocator_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetMediaLocator().");
	}
	GetBase()->SetMediaLocator(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::SetRelation(const Mp7JrsLinguisticEntityType_Relation_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetRelation().");
	}
	GetBase()->SetRelation(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

XMLCh * Mp7JrsSyntacticConstituentType::Getid() const
{
	return GetBase()->GetBase()->Getid();
}

bool Mp7JrsSyntacticConstituentType::Existid() const
{
	return GetBase()->GetBase()->Existid();
}
void Mp7JrsSyntacticConstituentType::Setid(XMLCh * item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::Setid().");
	}
	GetBase()->GetBase()->Setid(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::Invalidateid()
{
	GetBase()->GetBase()->Invalidateid();
}
Mp7JrsxPathRefPtr Mp7JrsSyntacticConstituentType::GettimeBase() const
{
	return GetBase()->GetBase()->GettimeBase();
}

bool Mp7JrsSyntacticConstituentType::ExisttimeBase() const
{
	return GetBase()->GetBase()->ExisttimeBase();
}
void Mp7JrsSyntacticConstituentType::SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SettimeBase().");
	}
	GetBase()->GetBase()->SettimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidatetimeBase()
{
	GetBase()->GetBase()->InvalidatetimeBase();
}
Mp7JrsdurationPtr Mp7JrsSyntacticConstituentType::GettimeUnit() const
{
	return GetBase()->GetBase()->GettimeUnit();
}

bool Mp7JrsSyntacticConstituentType::ExisttimeUnit() const
{
	return GetBase()->GetBase()->ExisttimeUnit();
}
void Mp7JrsSyntacticConstituentType::SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SettimeUnit().");
	}
	GetBase()->GetBase()->SettimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidatetimeUnit()
{
	GetBase()->GetBase()->InvalidatetimeUnit();
}
Mp7JrsxPathRefPtr Mp7JrsSyntacticConstituentType::GetmediaTimeBase() const
{
	return GetBase()->GetBase()->GetmediaTimeBase();
}

bool Mp7JrsSyntacticConstituentType::ExistmediaTimeBase() const
{
	return GetBase()->GetBase()->ExistmediaTimeBase();
}
void Mp7JrsSyntacticConstituentType::SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetmediaTimeBase().");
	}
	GetBase()->GetBase()->SetmediaTimeBase(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidatemediaTimeBase()
{
	GetBase()->GetBase()->InvalidatemediaTimeBase();
}
Mp7JrsmediaDurationPtr Mp7JrsSyntacticConstituentType::GetmediaTimeUnit() const
{
	return GetBase()->GetBase()->GetmediaTimeUnit();
}

bool Mp7JrsSyntacticConstituentType::ExistmediaTimeUnit() const
{
	return GetBase()->GetBase()->ExistmediaTimeUnit();
}
void Mp7JrsSyntacticConstituentType::SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetmediaTimeUnit().");
	}
	GetBase()->GetBase()->SetmediaTimeUnit(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsSyntacticConstituentType::InvalidatemediaTimeUnit()
{
	GetBase()->GetBase()->InvalidatemediaTimeUnit();
}
Mp7JrsDSType_Header_CollectionPtr Mp7JrsSyntacticConstituentType::GetHeader() const
{
	return GetBase()->GetBase()->GetHeader();
}

void Mp7JrsSyntacticConstituentType::SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType::SetHeader().");
	}
	GetBase()->GetBase()->SetHeader(item, client);
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}


Mp7JrsNodeEnum Mp7JrsSyntacticConstituentType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	// Base class first
	Mp7JrsNodeEnum result = m_Base->GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	const Mp7JrsNodePtr empty = Mp7JrsNodePtr();
	//------------------------------------------------------------------
	if(XMLString::compareString(context->ElementName, X("Head")) == 0)
	{
		// Head is contained in itemtype SyntacticConstituentType_LocalType
		// in choice collection SyntacticConstituentType_CollectionType
		
		context->Found = true;
		Mp7JrsSyntacticConstituentType_CollectionPtr coll = GetSyntacticConstituentType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSyntacticConstituentType_CollectionType;
				SetSyntacticConstituentType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->GetHead()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSyntacticConstituentType_LocalPtr item = CreateSyntacticConstituentType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SyntacticConstituentType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSyntacticConstituentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->SetHead(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->GetHead()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Phrase")) == 0)
	{
		// Phrase is contained in itemtype SyntacticConstituentType_LocalType
		// in choice collection SyntacticConstituentType_CollectionType
		
		context->Found = true;
		Mp7JrsSyntacticConstituentType_CollectionPtr coll = GetSyntacticConstituentType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSyntacticConstituentType_CollectionType;
				SetSyntacticConstituentType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->GetPhrase()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSyntacticConstituentType_LocalPtr item = CreateSyntacticConstituentType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SyntacticConstituentType")))) != empty)
			{
				// Is type allowed
				Mp7JrsSyntacticConstituentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->SetPhrase(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->GetPhrase()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	//------------------------------------------------------------------
	else if(XMLString::compareString(context->ElementName, X("Quotation")) == 0)
	{
		// Quotation is contained in itemtype SyntacticConstituentType_LocalType
		// in choice collection SyntacticConstituentType_CollectionType
		
		context->Found = true;
		Mp7JrsSyntacticConstituentType_CollectionPtr coll = GetSyntacticConstituentType_LocalType();
		if(coll == empty) // Create one via factory
		{
			if(context->Create)
			{
				coll = CreateSyntacticConstituentType_CollectionType;
				SetSyntacticConstituentType_LocalType(coll, client);
			}
			else
			{
				return result; // No collection, silently return emtpy enumeration
			}
		}
		if(!Mp7JrsXPathParseContext::PreProcessCollection(context, coll->size(), -1))
		{
			return result;
		}
		
		int i = 0;
		Mp7JrsNodePtr p;
		while(i < (int)coll->size())
		{
			if((p = ((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->GetQuotation()) != empty)
			{
				i = Mp7JrsXPathParseContext::HandleCollection(context, i, p, result);
			}
			else
			{
				++i;
			}
		}
		if(Mp7JrsXPathParseContext::PostProcessChoiceCollection(context, i, result))
		{
			if(i >= 0)
			{
				Mp7JrsSyntacticConstituentType_LocalPtr item = CreateSyntacticConstituentType_LocalType;
				coll->insertElementAt(item, i, client);
			}
			if((p = Mp7JrsXPathParseContext::CreateNode(context, Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:LinguisticDocumentType")))) != empty)
			{
				// Is type allowed
				Mp7JrsLinguisticDocumentPtr test = p;
				if(test || p->GetClassId() == 1) // Deliberate "Unkown" type is allowed
				{
					((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->SetQuotation(p, client);
					// Maybe some other restrictions are waiting...				
					if((p = ((Mp7JrsSyntacticConstituentType_LocalPtr)coll->elementAt(i))->GetQuotation()) != empty)
					{
						result.Insert(p);
					}
				}
				if(result.Size() == 0)
				{
					Mp7JrsXPathParseContext::ErrorCannotSetElement(context);
				}
			}
		}
		
		if(result.Size() > 0 && XMLString::stringLen(context->UnparsedXPath) > 0)
		{
			Mp7JrsNodeEnum subresult;
			while(result.HasNext())
			{
				subresult.Insert(result.GetNext()->GetOrCreateFromXPath(context->UnparsedXPath, client, flag, NULL));
			}
			return subresult;
		}		
		return result;

	}
	else if(isentrypoint)
	{
		// Sorry, unknown subelement name for SyntacticConstituentType
		Mp7JrsXPathParseContext::ErrorUnknownSubElement(context, "SyntacticConstituentType");
	}		
	
	return result;
}

XMLCh * Mp7JrsSyntacticConstituentType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSyntacticConstituentType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSyntacticConstituentType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	// Don't create own node: LocalType is from Choice or Sequence
	else {
		element = parent;
	}


    // pass newElem to base class, so that it contains new node after return
    m_Base->Serialize(doc, element, newElem);
    element = *newElem;

	assert(element);
// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("SyntacticConstituentType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_baseForm_Exist)
	{
	// String
	if(m_baseForm != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("baseForm"), m_baseForm);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_synthesis_Exist)
	{
	// Enumeration
	if(m_synthesis != Mp7JrssynthesisType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrssynthesisType::ToText(m_synthesis);
		element->setAttributeNS(X(""), X("synthesis"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_functionWord_Exist)
	{
	// String
	if(m_functionWord != (XMLCh *)NULL)
	{
		element->setAttributeNS(X(""), X("functionWord"), m_functionWord);
	}
		
	} // Optional attriute
	
	// Element serialization:
	if (m_SyntacticConstituentType_LocalType != Mp7JrsSyntacticConstituentType_CollectionPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
	{
		// Collection
		// No extra child node needed for choices or sequences with maxOccurs > 1
		m_SyntacticConstituentType_LocalType->Serialize(doc, element, NULL); // &element); - mio 041123
	}

}

bool Mp7JrsSyntacticConstituentType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("baseForm")))
	{
        // Deserialize string type
        this->SetbaseForm(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("baseForm"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("baseForm")))
	{
        // Deserialize string type
        this->SetbaseForm(Mp7JrsConvert::TextToString(parent->getAttribute(X("baseForm"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("synthesis")))
	{
        this->Setsynthesis(Mp7JrssynthesisType::Parse(parent->getAttributeNS(X(""), X("synthesis"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("synthesis")))
	{
        this->Setsynthesis(Mp7JrssynthesisType::Parse(parent->getAttribute(X("synthesis"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("functionWord")))
	{
        // Deserialize string type
        this->SetfunctionWord(Mp7JrsConvert::TextToString(parent->getAttributeNS(X(""), X("functionWord"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("functionWord")))
	{
        // Deserialize string type
        this->SetfunctionWord(Mp7JrsConvert::TextToString(parent->getAttribute(X("functionWord"))));
        * current = parent;
    }

	// Extensionbase is Mp7JrsLinguisticEntityType
	// Deserialize cce factory type
	if(m_Base->Deserialize(doc, parent, current))
	{
		found = true;
		parent = * current;
		parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
	}
	else
	{ // This is new for cce only
		parent = Mp7JrsUtil::GetNextChild(parent);
	}
        // Deserialise Choice Collection
        if((parent != NULL) && (
            // urn:mpeg:mpeg7:schema:2004:Head
            Mp7JrsUtil::HasNodeName(parent, X("Head"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Head")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:Phrase
            Mp7JrsUtil::HasNodeName(parent, X("Phrase"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Phrase")) == 0)
                ||
            // urn:mpeg:mpeg7:schema:2004:Quotation
            Mp7JrsUtil::HasNodeName(parent, X("Quotation"), X("urn:mpeg:mpeg7:schema:2004"))
//OLD            (XMLString::compareString(parent->getNodeName(), X("urn:mpeg:mpeg7:schema:2004:Quotation")) == 0)
                ))
        {
            // Deserialize factory type
            Mp7JrsSyntacticConstituentType_CollectionPtr tmp = CreateSyntacticConstituentType_CollectionType;
            tmp->Deserialize(doc, parent, current);
            this->SetSyntacticConstituentType_LocalType(tmp);
            found = true;
            parent = * current; // For collections
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
        }
// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSyntacticConstituentType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = m_Base->CreateChild(elementname, xsitype);
  if (child == NULL) { // Base couldn't create child node
    child = Mp7JrsNodePtr();
  } else {
    return child;
  }
  // Choice Collection
  if(
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Head"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Head")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Phrase"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Phrase")) == 0)
    ||
// TODO better use this    
//  (Mp7JrsUtil::HasNodeName(parent, X("Quotation"), X("urn:mpeg:mpeg7:schema:2004")))

// TODO Remove the old way
    (XMLString::compareString(elementname, X("Quotation")) == 0)
    )
  {
    Mp7JrsSyntacticConstituentType_CollectionPtr tmp = CreateSyntacticConstituentType_CollectionType;
    this->SetSyntacticConstituentType_LocalType(tmp);
    child = tmp;
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSyntacticConstituentType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSyntacticConstituentType_LocalType() != Mp7JrsNodePtr())
		result.Insert(GetSyntacticConstituentType_LocalType());
	if (GetMediaLocator() != Mp7JrsNodePtr())
		result.Insert(GetMediaLocator());
	if (GetRelation() != Mp7JrsNodePtr())
		result.Insert(GetRelation());
	if (GetHeader() != Mp7JrsNodePtr())
		result.Insert(GetHeader());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_ExtMethodImpl.h


