 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_LocalType_ExtImplInclude.h



#include "Mp7JrsSyntacticConstituentType.h"
#include "Mp7JrsLinguisticDocumentType.h"
#include "Mp7JrsSyntacticConstituentType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsSyntacticConstituentType_LocalType::IMp7JrsSyntacticConstituentType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_LocalType_ExtPropInit.h

}

IMp7JrsSyntacticConstituentType_LocalType::~IMp7JrsSyntacticConstituentType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_LocalType_ExtPropCleanup.h

}

Mp7JrsSyntacticConstituentType_LocalType::Mp7JrsSyntacticConstituentType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsSyntacticConstituentType_LocalType::~Mp7JrsSyntacticConstituentType_LocalType()
{
	Cleanup();
}

void Mp7JrsSyntacticConstituentType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_Head = Mp7JrsSyntacticConstituentPtr(); // Class
	m_Phrase = Mp7JrsSyntacticConstituentPtr(); // Class
	m_Quotation = Mp7JrsLinguisticDocumentPtr(); // Class


// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_LocalType_ExtMyPropInit.h

}

void Mp7JrsSyntacticConstituentType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_Head);
	// Mp7JrsFactory::DeleteObject(m_Phrase);
	// Mp7JrsFactory::DeleteObject(m_Quotation);
}

void Mp7JrsSyntacticConstituentType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use SyntacticConstituentType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ISyntacticConstituentType_LocalType
    const Mp7JrsPtr< Mp7JrsSyntacticConstituentType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_Head);
		this->SetHead(Mp7JrsFactory::CloneObject(tmp->GetHead()));
		// Mp7JrsFactory::DeleteObject(m_Phrase);
		this->SetPhrase(Mp7JrsFactory::CloneObject(tmp->GetPhrase()));
		// Mp7JrsFactory::DeleteObject(m_Quotation);
		this->SetQuotation(Mp7JrsFactory::CloneObject(tmp->GetQuotation()));
}

Mp7JrsNodePtr Mp7JrsSyntacticConstituentType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsSyntacticConstituentType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsSyntacticConstituentPtr Mp7JrsSyntacticConstituentType_LocalType::GetHead() const
{
	return m_Head;
}

Mp7JrsSyntacticConstituentPtr Mp7JrsSyntacticConstituentType_LocalType::GetPhrase() const
{
	return m_Phrase;
}

Mp7JrsLinguisticDocumentPtr Mp7JrsSyntacticConstituentType_LocalType::GetQuotation() const
{
	return m_Quotation;
}

// implementing setter for choice 
/* element */
void Mp7JrsSyntacticConstituentType_LocalType::SetHead(const Mp7JrsSyntacticConstituentPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType_LocalType::SetHead().");
	}
	if (m_Head != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Head);
		m_Head = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Head) m_Head->SetParent(m_myself.getPointer());
		if (m_Head && m_Head->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SyntacticConstituentType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Head->UseTypeAttribute = true;
		}
		if(m_Head != Mp7JrsSyntacticConstituentPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Head->SetContentName(XMLString::transcode("Head"));
		}
	// Mp7JrsFactory::DeleteObject(m_Phrase);
	m_Phrase = Mp7JrsSyntacticConstituentPtr();
	// Mp7JrsFactory::DeleteObject(m_Quotation);
	m_Quotation = Mp7JrsLinguisticDocumentPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSyntacticConstituentType_LocalType::SetPhrase(const Mp7JrsSyntacticConstituentPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType_LocalType::SetPhrase().");
	}
	if (m_Phrase != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Phrase);
		m_Phrase = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Phrase) m_Phrase->SetParent(m_myself.getPointer());
		if (m_Phrase && m_Phrase->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:SyntacticConstituentType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Phrase->UseTypeAttribute = true;
		}
		if(m_Phrase != Mp7JrsSyntacticConstituentPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Phrase->SetContentName(XMLString::transcode("Phrase"));
		}
	// Mp7JrsFactory::DeleteObject(m_Head);
	m_Head = Mp7JrsSyntacticConstituentPtr();
	// Mp7JrsFactory::DeleteObject(m_Quotation);
	m_Quotation = Mp7JrsLinguisticDocumentPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsSyntacticConstituentType_LocalType::SetQuotation(const Mp7JrsLinguisticDocumentPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsSyntacticConstituentType_LocalType::SetQuotation().");
	}
	if (m_Quotation != item)
	{
		// Mp7JrsFactory::DeleteObject(m_Quotation);
		m_Quotation = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_Quotation) m_Quotation->SetParent(m_myself.getPointer());
		if (m_Quotation && m_Quotation->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:LinguisticDocumentType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_Quotation->UseTypeAttribute = true;
		}
		if(m_Quotation != Mp7JrsLinguisticDocumentPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_Quotation->SetContentName(XMLString::transcode("Quotation"));
		}
	// Mp7JrsFactory::DeleteObject(m_Head);
	m_Head = Mp7JrsSyntacticConstituentPtr();
	// Mp7JrsFactory::DeleteObject(m_Phrase);
	m_Phrase = Mp7JrsSyntacticConstituentPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: SyntacticConstituentType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsSyntacticConstituentType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsSyntacticConstituentType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsSyntacticConstituentType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsSyntacticConstituentType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_Head != Mp7JrsSyntacticConstituentPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Head->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Head"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Head->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Phrase != Mp7JrsSyntacticConstituentPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Phrase->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Phrase"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Phrase->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_Quotation != Mp7JrsLinguisticDocumentPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_Quotation->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("Quotation"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_Quotation->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsSyntacticConstituentType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Head"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Head")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSyntacticConstituentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetHead(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Phrase"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Phrase")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateSyntacticConstituentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetPhrase(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("Quotation"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("Quotation")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateLinguisticDocumentType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetQuotation(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsSyntacticConstituentType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("Head")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSyntacticConstituentType;
    }
    this->SetHead(child);
  }
  if (XMLString::compareString(elementname, X("Phrase")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateSyntacticConstituentType;
    }
    this->SetPhrase(child);
  }
  if (XMLString::compareString(elementname, X("Quotation")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateLinguisticDocumentType;
    }
    this->SetQuotation(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsSyntacticConstituentType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetHead() != Mp7JrsNodePtr())
		result.Insert(GetHead());
	if (GetPhrase() != Mp7JrsNodePtr())
		result.Insert(GetPhrase());
	if (GetQuotation() != Mp7JrsNodePtr())
		result.Insert(GetQuotation());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsSyntacticConstituentType_LocalType_ExtMethodImpl.h


