 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtImplInclude.h



#include "Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"
// XPath stuff
#include "Mp7JrsXPathParseContext.h"

#include <assert.h>
IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtPropInit.h

}

IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::~IMp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtPropCleanup.h

}

Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::~Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType()
{
	Cleanup();
}

void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Init()
{
	// Init base
	m_Base = 0.0;

	// Init attributes
	m_type = Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::UninitializedEnumeration;
// old	m_type = Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration::;
// old	m_type_Default = Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration::firstOrder;
	m_type_Default = Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::firstOrder;
	m_type_Exist = false;
	m_param = 0.0; // Value
	m_param_Default = 0.0;
	m_param_Exist = false;



// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtMyPropInit.h

}

void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtMyPropCleanup.h


}

void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in ITemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType
    const Mp7JrsPtr< Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
	m_Base = tmp->GetContent();
	{
	if (tmp->Existtype())
	{
		this->Settype(tmp->Gettype());
	}
	else
	{
		Invalidatetype();
	}
	}
	{
	if (tmp->Existparam())
	{
		this->Setparam(tmp->Getparam());
	}
	else
	{
		Invalidateparam();
	}
	}
}

Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::SetContent(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::SetContent().");
	}
    if (m_Base != item)
    {
		m_Base = item;
	}
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

float Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::GetContent() const
{
	return m_Base;
}
Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Gettype() const
{
	if (this->Existtype()) {
		return m_type;
	} else {
		return m_type_Default;
	}
}

bool Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Existtype() const
{
	return m_type_Exist;
}
void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Settype(Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Enumeration item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Settype().");
	}
    m_type = item;
	m_type_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Invalidatetype()
{
	m_type_Exist = false;
}
float Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Getparam() const
{
	if (this->Existparam()) {
		return m_param;
	} else {
		return m_param_Default;
	}
}

bool Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Existparam() const
{
	return m_param_Exist;
}
void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Setparam(float item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Setparam().");
	}
    m_param = item;
	m_param_Exist = true;
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Invalidateparam()
{
	m_param_Exist = false;
}

Mp7JrsNodeEnum Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
{
	Mp7JrsXPathParseContext c;
	bool isentrypoint = Mp7JrsXPathParseContext::Initialise(c, &context, xpath, flag);
	
	Mp7JrsNodeEnum result = Mp7JrsNode::GetOrCreateFromXPath(xpath, client, flag, context);
	if(context->Found) return result; // Ready
	if(isentrypoint)
	{
		// No Mp7JrsNodePtr subelement to get or create for TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType
		Mp7JrsXPathParseContext::ErrorNoSubElement(context, "TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType");
	}
	
	return result;
}

XMLCh * Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Parse(const XMLCh * const txt)
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return false;
}

bool Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::ContentFromString(const XMLCh * const txt)
{
	if(! txt) return false;
	// Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType with workaround via Deserialise()
	return Mp7JrsXPathParseContext::ContentFromString(this, txt);
}
XMLCh* Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::ContentToString() const
{
	// Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType with workaround via Serialise()
	return Mp7JrsXPathParseContext::ContentToString(this);
}

void Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// baw 06 02 2004: create elements only if no base is present 
	// baw 17 02 2004: or if the base has a type that does not create a named node
	if (*newElem) 
	{
		// Element was passed in -> use it
		element = *newElem;
	} else if(parent == NULL) 
	{
		// Root node (presumably)
		element = doc->getDocumentElement();
	}
	else {
		// Create new element
		if (this->GetContentName() != (XMLCh*)NULL) {
			DOMElement * elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), this->GetContentName());
			elem->setPrefix(prefix); // Might be NULL in case it is the default namespace and Archive::usePrefixForDefaultNS == false
			parent->appendChild(elem);
			element = elem;
		} else {
			// sat 2004-03-24: this should never happen
			assert(false);
		}
	}
	// baw 10 02 2004: added newElem to return new node to caller from derived class
	// sat 2004-03-18: set *newElem to parent unconditionally, not just in
	//   some branches (crashes if parent passed in, but no ContentName set)
	//   -- leaves out nodes, but at least doesn't crash.
	// baw 2004-04-19: set *newElem only if it is NULL, otherwise we would replace the value we get
	if (!(*newElem)) *newElem = element;


    {
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_Base);
		element->appendChild(doc->createTextNode(tmp));
		XMLString::release(&tmp);
    }

	assert(element);
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtPreSerialize.h


	Mp7JrsUtil::HandleXsiType(element, doc, this->UseTypeAttribute, X("urn:mpeg:mpeg7:schema:2004"), X("TemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType"));
    // Attribute Serialization:
		

	// Optional attriute
	if(m_type_Exist)
	{
	// Enumeration
	if(m_type != Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::UninitializedEnumeration)
	{
		XMLCh * tmp = Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::ToText(m_type);
		element->setAttributeNS(X(""), X("type"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
    // Attribute Serialization:
		

	// Optional attriute
	if(m_param_Exist)
	{
	// Value
	{
		XMLCh * tmp = Mp7JrsConvert::BinToText(m_param);
		element->setAttributeNS(X(""), X("param"), tmp);
		XMLString::release(&tmp);
	}
		
	} // Optional attriute
	
	// Element serialization:

}

bool Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("type")))
	{
        this->Settype(Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Parse(parent->getAttributeNS(X(""), X("type"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("type")))
	{
        this->Settype(Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_type_LocalType::Parse(parent->getAttribute(X("type"))));
        * current = parent;
    }

	// Deserialize attribute
	// For now, we silently assume attributeFormDefault = "unqualified"
#if 0	
	if(parent->hasAttributeNS(X(""), X("param")))
	{
        // deserialize value type
        this->Setparam(Mp7JrsConvert::TextToFloat(parent->getAttributeNS(X(""), X("param"))));
        * current = parent;
	}
#endif // 0	
	if(parent->hasAttribute(X("param")))
	{
        // deserialize value type
        this->Setparam(Mp7JrsConvert::TextToFloat(parent->getAttribute(X("param"))));
        * current = parent;
    }

  m_Base = Mp7JrsConvert::TextToFloat(Mp7JrsUtil::GetElementText(parent));
  found = true;
// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsTemporalInterpolationType_InterpolationFunctions_KeyValue_LocalType_ExtMethodImpl.h


