
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_Regularity_LocalType_ExtImplInclude.h


#include "Mp7JrsTextureBrowsingType_Regularity_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsTextureBrowsingType_Regularity_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsTextureBrowsingType_Regularity_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsTextureBrowsingType_Regularity_LocalType::ToText(Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/irregular:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("irregular");
			break;
		case /*Enumeration::*/slightlyRegular:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("slightlyRegular");
			break;
		case /*Enumeration::*/regular:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("regular");
			break;
		case /*Enumeration::*/highlyRegular:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("highlyRegular");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration Mp7JrsTextureBrowsingType_Regularity_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsTextureBrowsingType_Regularity_LocalType::Enumeration result = Mp7JrsTextureBrowsingType_Regularity_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "irregular") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Regularity_LocalType::/*Enumeration::*/irregular;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "slightlyRegular") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Regularity_LocalType::/*Enumeration::*/slightlyRegular;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "regular") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Regularity_LocalType::/*Enumeration::*/regular;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "highlyRegular") == 0)
	{
		result = Mp7JrsTextureBrowsingType_Regularity_LocalType::/*Enumeration::*/highlyRegular;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
