
/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// Based on UnknownFactory_cpp.template

#include "Mp7JrsUnknownFactory.h"
#include "Mp7JrsUnknown.h"

Mp7JrsUnknownFactory::Mp7JrsUnknownFactory()
// FTT deprecated    :  Mp7JrsFactory("9f01f468-eea6-4931-8ffb-10f21d16a5c1", "Mp7JrsUnknown")
   : Mp7JrsFactory("Mp7JrsUnknown", "Mp7JrsUnknown") // FTT No namespace!
{
}

Mp7JrsUnknownFactory::~Mp7JrsUnknownFactory()
{
}

const char * Mp7JrsUnknownFactory::GetTypeName() const
{
	// Note: This is slow
	// return Mp7JrsUnknown().GetTypeName();
	
	// FTT Easier but needs more memory in debug mode (no string pooling)
	return "Mp7JrsUnknown";
}

Mp7JrsNodePtr Mp7JrsUnknownFactory::CreateObject()
{
	return Mp7JrsNodePtr(new Mp7JrsUnknown);
}
