
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsVariationType_VariationRelationship_LocalType_ExtImplInclude.h


#include "Mp7JrsVariationType_VariationRelationship_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsVariationType_VariationRelationship_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsVariationType_VariationRelationship_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsVariationType_VariationRelationship_LocalType::ToText(Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/summarization:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("summarization");
			break;
		case /*Enumeration::*/abstraction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("abstraction");
			break;
		case /*Enumeration::*/extraction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("extraction");
			break;
		case /*Enumeration::*/modalityTranslation:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("modalityTranslation");
			break;
		case /*Enumeration::*/languageTranslation:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("languageTranslation");
			break;
		case /*Enumeration::*/colorReduction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("colorReduction");
			break;
		case /*Enumeration::*/spatialReduction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("spatialReduction");
			break;
		case /*Enumeration::*/temporalReduction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("temporalReduction");
			break;
		case /*Enumeration::*/samplingReduction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("samplingReduction");
			break;
		case /*Enumeration::*/rateReduction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("rateReduction");
			break;
		case /*Enumeration::*/qualityReduction:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("qualityReduction");
			break;
		case /*Enumeration::*/compression:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("compression");
			break;
		case /*Enumeration::*/scaling:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("scaling");
			break;
		case /*Enumeration::*/revision:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("revision");
			break;
		case /*Enumeration::*/substitution:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("substitution");
			break;
		case /*Enumeration::*/replay:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("replay");
			break;
		case /*Enumeration::*/alternativeView:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("alternativeView");
			break;
		case /*Enumeration::*/alternativeMediaProfile:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("alternativeMediaProfile");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration Mp7JrsVariationType_VariationRelationship_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsVariationType_VariationRelationship_LocalType::Enumeration result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "summarization") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/summarization;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "abstraction") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/abstraction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "extraction") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/extraction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "modalityTranslation") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/modalityTranslation;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "languageTranslation") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/languageTranslation;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "colorReduction") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/colorReduction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "spatialReduction") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/spatialReduction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "temporalReduction") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/temporalReduction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "samplingReduction") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/samplingReduction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "rateReduction") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/rateReduction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "qualityReduction") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/qualityReduction;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "compression") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/compression;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "scaling") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/scaling;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "revision") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/revision;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "substitution") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/substitution;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "replay") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/replay;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "alternativeView") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/alternativeView;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "alternativeMediaProfile") == 0)
	{
		result = Mp7JrsVariationType_VariationRelationship_LocalType::/*Enumeration::*/alternativeMediaProfile;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
