 

// Core library class
// based on ClassType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtImplInclude.h



#include "Mp7JrsVideoViewGraphType.h"
#include "Mp7JrsReferenceType.h"
#include "Mp7JrsVideoViewGraphType_LocalType.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsConvert.h"
#include "Mp7JrsUtil.h"
#include "Mp7JrsClientManager.h"

#include <assert.h>
IMp7JrsVideoViewGraphType_LocalType::IMp7JrsVideoViewGraphType_LocalType()
{

// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtPropInit.h

}

IMp7JrsVideoViewGraphType_LocalType::~IMp7JrsVideoViewGraphType_LocalType()
{
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtPropCleanup.h

}

Mp7JrsVideoViewGraphType_LocalType::Mp7JrsVideoViewGraphType_LocalType()
{
	//Init();  // Must be called by factory -- base init depends on m_myself being set up
}

Mp7JrsVideoViewGraphType_LocalType::~Mp7JrsVideoViewGraphType_LocalType()
{
	Cleanup();
}

void Mp7JrsVideoViewGraphType_LocalType::Init()
{


	// Init elements (element, union sequence choice all any)
	
	m_SpaceFrequencyChild = Mp7JrsVideoViewGraphPtr(); // Class
	m_SpaceFrequencyChildRef = Mp7JrsReferencePtr(); // Class


// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtMyPropInit.h

}

void Mp7JrsVideoViewGraphType_LocalType::Cleanup()
{
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtMyPropCleanup.h


	// Mp7JrsFactory::DeleteObject(m_SpaceFrequencyChild);
	// Mp7JrsFactory::DeleteObject(m_SpaceFrequencyChildRef);
}

void Mp7JrsVideoViewGraphType_LocalType::DeepCopy(const Mp7JrsNodePtr &original)
{
	// Don't use VideoViewGraphType_LocalTypePtr, since we
	// might need GetBase(), which isn't defined in IVideoViewGraphType_LocalType
    const Mp7JrsPtr< Mp7JrsVideoViewGraphType_LocalType > tmp(original);
	if (tmp == NULL) return; // EXIT: passed argument of wrong type
		// Mp7JrsFactory::DeleteObject(m_SpaceFrequencyChild);
		this->SetSpaceFrequencyChild(Mp7JrsFactory::CloneObject(tmp->GetSpaceFrequencyChild()));
		// Mp7JrsFactory::DeleteObject(m_SpaceFrequencyChildRef);
		this->SetSpaceFrequencyChildRef(Mp7JrsFactory::CloneObject(tmp->GetSpaceFrequencyChildRef()));
}

Mp7JrsNodePtr Mp7JrsVideoViewGraphType_LocalType::GetBaseRoot()
{
	return m_myself.getPointer();
}

const Mp7JrsNodePtr Mp7JrsVideoViewGraphType_LocalType::GetBaseRoot() const
{
	return m_myself.getPointer();
}


Mp7JrsVideoViewGraphPtr Mp7JrsVideoViewGraphType_LocalType::GetSpaceFrequencyChild() const
{
	return m_SpaceFrequencyChild;
}

Mp7JrsReferencePtr Mp7JrsVideoViewGraphType_LocalType::GetSpaceFrequencyChildRef() const
{
	return m_SpaceFrequencyChildRef;
}

// implementing setter for choice 
/* element */
void Mp7JrsVideoViewGraphType_LocalType::SetSpaceFrequencyChild(const Mp7JrsVideoViewGraphPtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsVideoViewGraphType_LocalType::SetSpaceFrequencyChild().");
	}
	if (m_SpaceFrequencyChild != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SpaceFrequencyChild);
		m_SpaceFrequencyChild = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SpaceFrequencyChild) m_SpaceFrequencyChild->SetParent(m_myself.getPointer());
		if (m_SpaceFrequencyChild && m_SpaceFrequencyChild->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:VideoViewGraphType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SpaceFrequencyChild->UseTypeAttribute = true;
		}
		if(m_SpaceFrequencyChild != Mp7JrsVideoViewGraphPtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SpaceFrequencyChild->SetContentName(XMLString::transcode("SpaceFrequencyChild"));
		}
	// Mp7JrsFactory::DeleteObject(m_SpaceFrequencyChildRef);
	m_SpaceFrequencyChildRef = Mp7JrsReferencePtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

/* element */
void Mp7JrsVideoViewGraphType_LocalType::SetSpaceFrequencyChildRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client)
{
	if (!IsLocked(client)) {
		throw Mp7JrsException(MP7JRS_ERROR, "Could not acquire lock in Mp7JrsVideoViewGraphType_LocalType::SetSpaceFrequencyChildRef().");
	}
	if (m_SpaceFrequencyChildRef != item)
	{
		// Mp7JrsFactory::DeleteObject(m_SpaceFrequencyChildRef);
		m_SpaceFrequencyChildRef = item;
		// baw 27 04 2004: make sure that node on which parent is set is not null
		if (m_SpaceFrequencyChildRef) m_SpaceFrequencyChildRef->SetParent(m_myself.getPointer());
		if (m_SpaceFrequencyChildRef && m_SpaceFrequencyChildRef->GetClassId() 
    != Mp7JrsFactory::GetTypeIndex(X("urn:mpeg:mpeg7:schema:2004:ReferenceType"))) {
		  // Element is concrete, so set UseTypeAttribute to true only if item is derived!
		  m_SpaceFrequencyChildRef->UseTypeAttribute = true;
		}
		if(m_SpaceFrequencyChildRef != Mp7JrsReferencePtr()) // FTT removed extra parenthesis to make it compile under gcc 3.2.2
		{
			m_SpaceFrequencyChildRef->SetContentName(XMLString::transcode("SpaceFrequencyChildRef"));
		}
	// Mp7JrsFactory::DeleteObject(m_SpaceFrequencyChild);
	m_SpaceFrequencyChild = Mp7JrsVideoViewGraphPtr();
    }
	Mp7JrsClientManager::SendUpdateNotification(
		m_myself.getPointer(), MP7JRS_NA_NODE_UPDATED,
		client, m_myself.getPointer());
}

// Type: VideoViewGraphType_LocalType: Only types with an element name can have GetOrCreate()
// Mp7JrsNodeEnum Mp7JrsVideoViewGraphType_LocalType::GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client /* = MP7JRS_UNDEFINED_CLIENT */, Mp7JrsXPathCreation flag /* = MP7JRS_FORCECREATE */, Mp7JrsXPathParseContext * context /* = NULL */)
//

XMLCh * Mp7JrsVideoViewGraphType_LocalType::ToText() const
{
	// for Emtpy, ElementOnly, Mixed and TextOnly containing attributes intentionally dummy implemented
	return XMLString::transcode(this->GetTypeName());
}


bool Mp7JrsVideoViewGraphType_LocalType::Parse(const XMLCh * const txt)
{
	return false;
}


void Mp7JrsVideoViewGraphType_LocalType::Serialize(DOMDocument * doc, DOMElement* parent, DOMElement** newElem)
{
	// The element we serialize in.
	DOMElement* element;

	// baw 10 02 2004: added newElem to return new node to caller from derived class
	DOMElement* localNewElem = NULL;
	if (!(newElem)) newElem = &localNewElem;
	// ---

	// Check if we should add the namespace prefix
	const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));

	// Serialize Choice of Sequence collection item
	element = parent;


	// Element serialization:
	// Class
	
	if (m_SpaceFrequencyChild != Mp7JrsVideoViewGraphPtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SpaceFrequencyChild->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SpaceFrequencyChild"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SpaceFrequencyChild->Serialize(doc, element, &elem);
	}
	// Class
	
	if (m_SpaceFrequencyChildRef != Mp7JrsReferencePtr())
	{
		// Class
		// Create child node to serialize into, only if current type is not unknown
		// (Unknown types are serialising the whole subtree including this element)
		DOMElement * elem = NULL;
  	if(m_SpaceFrequencyChildRef->GetClassId() != Mp7JrsFactory::GetTypeIndex(X("Mp7JrsUnknown")))
		{
		
			elem = doc->createElementNS(X("urn:mpeg:mpeg7:schema:2004"), X("SpaceFrequencyChildRef"));
			const XMLCh * prefix = Mp7JrsUtil::LookupNamespacePrefix(doc, X("urn:mpeg:mpeg7:schema:2004"));
			elem->setPrefix(prefix);
			
			element->appendChild(elem);
		}
		m_SpaceFrequencyChildRef->Serialize(doc, element, &elem);
	}

}

bool Mp7JrsVideoViewGraphType_LocalType::Deserialize(DOMDocument * doc, DOMElement * parent, DOMElement ** current)
{
	if(!parent) return false;

	bool found = false;

	do // Deserialize choice just one time!
    {
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SpaceFrequencyChild"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SpaceFrequencyChild")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateVideoViewGraphType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSpaceFrequencyChild(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
        // Deserialize element
	if(Mp7JrsUtil::HasNodeName(parent, X("SpaceFrequencyChildRef"), X("urn:mpeg:mpeg7:schema:2004")))
//        if((parent != NULL) && (XMLString::compareString(parent->getNodeName(), X("SpaceFrequencyChildRef")) == 0))
        {
            // We have to deal with xsi:type classes...
            // Deserialize factory type
            Mp7JrsPtr< Mp7JrsNode > tmp;
            if(parent->hasAttribute(X("xsi:type")))
            {
              NamespaceHelper result;
              Mp7JrsUtil::GetXsiType(parent, doc, &result);
              XMLCh * xsitype = Mp7JrsUtil::QualifiedName(&result);
              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(xsitype))));
//              tmp = Mp7JrsPtr< Mp7JrsNode >(Mp7JrsFactory::CreateObject((Mp7JrsFactory::GetTypeIndex(parent->getAttribute(X("xsi:type"))))));
              if(xsitype) Mp7JrsUtil::deallocate(&xsitype);
            }else 
            {
              tmp = CreateReferenceType;
            }
            tmp->Deserialize(doc, parent, current);
            
            if(parent->hasAttribute(X("xsi:type"))) {
                    tmp->UseTypeAttribute = true;
            }
            this->SetSpaceFrequencyChildRef(tmp);
            found = true;
            * current = parent; // We must adjust it!
            parent = Mp7JrsUtil::GetNextAkin(parent); // Previously GetNextSibling
            continue;       // For choices
        }
	} while(false);
// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtPostDeserialize.h

	return found;
}

Mp7JrsNodePtr Mp7JrsVideoViewGraphType_LocalType::CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype)
{
  assert(elementname);
  Mp7JrsNodePtr child = Mp7JrsNodePtr();
  if (XMLString::compareString(elementname, X("SpaceFrequencyChild")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateVideoViewGraphType;
    }
    this->SetSpaceFrequencyChild(child);
  }
  if (XMLString::compareString(elementname, X("SpaceFrequencyChildRef")) == 0) {
    // We check for xsi:type
    if (xsitype != NULL && XMLString::stringLen(xsitype) > 0) {
      child = Mp7JrsNodePtr(Mp7JrsFactory::CreateObject( Mp7JrsFactory::GetTypeIndex(xsitype) ) );
    } else { // no xsi:type
      child = CreateReferenceType;
    }
    this->SetSpaceFrequencyChildRef(child);
  }
  return child;
 
}

Mp7JrsNodeEnum Mp7JrsVideoViewGraphType_LocalType::GetAllChildElements() const
{
	Mp7JrsNodeEnum result;
	if (GetSpaceFrequencyChild() != Mp7JrsNodePtr())
		result.Insert(GetSpaceFrequencyChild());
	if (GetSpaceFrequencyChildRef() != Mp7JrsNodePtr())
		result.Insert(GetSpaceFrequencyChildRef());
	// Note that this returns only child elements (no attributes)
	// that are Patterns, Elements or Collections!
	return result;
}

// no includefile for extension defined 
// file Mp7JrsVideoViewGraphType_LocalType_ExtMethodImpl.h


