
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType_ExtImplInclude.h


#include "Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType.h"

// no includefile for extension defined 
// file Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::ToText(Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/word:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("word");
			break;
		case /*Enumeration::*/syllable:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("syllable");
			break;
		case /*Enumeration::*/morpheme:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("morpheme");
			break;
		case /*Enumeration::*/phrase:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("phrase");
			break;
		case /*Enumeration::*/component:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("component");
			break;
		case /*Enumeration::*/stem:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("stem");
			break;
		case /*Enumeration::*/affix:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("affix");
			break;
		case /*Enumeration::*/nonspeech:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("nonspeech");
			break;
		case /*Enumeration::*/other:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("other");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::Enumeration Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::Enumeration result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "word") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/word;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "syllable") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/syllable;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "morpheme") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/morpheme;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "phrase") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/phrase;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "component") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/component;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "stem") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/stem;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "affix") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/affix;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "nonspeech") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/nonspeech;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "other") == 0)
	{
		result = Mp7JrsWordLexiconType_Token_linguisticUnit_LocalType::/*Enumeration::*/other;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
