
// Based on EnumerationType_CPP.template

/*****************************************************************************/
/* Copyright (C) 2003-2009, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#include <stdio.h>
#include <xercesc/util/Janitor.hpp>

// no includefile for extension defined 
// file Mp7JrspaddingType_LocalType_ExtImplInclude.h


#include "Mp7JrspaddingType_LocalType.h"

// no includefile for extension defined 
// file Mp7JrspaddingType_LocalType_ExtMethodImpl.h


const XMLCh * Mp7JrspaddingType_LocalType::nsURI(){ return X("urn:mpeg:mpeg7:schema:2004");}

XMLCh * Mp7JrspaddingType_LocalType::ToText(Mp7JrspaddingType_LocalType::Enumeration item)
{
	XMLCh * result = NULL;
	switch(item)
	{
		case /*Enumeration::*/zero:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("zero");
			break;
		case /*Enumeration::*/replication:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("replication");
			break;
		case /*Enumeration::*/periodic:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("periodic");
			break;
		case /*Enumeration::*/symmetric:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("symmetric");
			break;
		case /*Enumeration::*/antiSymmetric:
			result = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode("antiSymmetric");
			break;
		default:; break;
	}	
	
	// Note: You must release this result after using it
	return result;
}

Mp7JrspaddingType_LocalType::Enumeration Mp7JrspaddingType_LocalType::Parse(const XMLCh * const txt)
{
	char * item = XERCES_CPP_NAMESPACE_QUALIFIER XMLString::transcode(txt);
	Mp7JrspaddingType_LocalType::Enumeration result = Mp7JrspaddingType_LocalType::/*Enumeration::*/UninitializedEnumeration;
	
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "zero") == 0)
	{
		result = Mp7JrspaddingType_LocalType::/*Enumeration::*/zero;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "replication") == 0)
	{
		result = Mp7JrspaddingType_LocalType::/*Enumeration::*/replication;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "periodic") == 0)
	{
		result = Mp7JrspaddingType_LocalType::/*Enumeration::*/periodic;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "symmetric") == 0)
	{
		result = Mp7JrspaddingType_LocalType::/*Enumeration::*/symmetric;
	}
	if(XERCES_CPP_NAMESPACE_QUALIFIER XMLString::compareString(item, "antiSymmetric") == 0)
	{
		result = Mp7JrspaddingType_LocalType::/*Enumeration::*/antiSymmetric;
	}
	

	XERCES_CPP_NAMESPACE_QUALIFIER XMLString::release(&item);
	return result;
}
